// -----------------------------------------------------
//        DIB
// -----------------------------------------------------

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <commdlg.h>
#include <mem.h>
#pragma hdrstop

#include "dib.hpp"

// -------------------------------
//  DIBSelectFile
//  DIB-
// -------------------------------

HFILE DIBSelectFile(void)
{
  //    
  OPENFILENAME ofn;

  //       
  char szFile[256];

  //      
  char szFileTitle[256];

  //    
  char szFilter[256] =
	 "Bitmap Files\0*.bmp;*.dib;*.rle\0Any Files\0*.*\0";

  //   
  HFILE hf;

  //    
  //  ,    
  szFile[0] = '\0';

  //      
  // ,    
  //  
  memset(&ofn, 0, sizeof(OPENFILENAME));

  //    

  //  
  ofn.lStructSize       = sizeof(OPENFILENAME);

  //  
  ofn.hwndOwner         = NULL;

  //   
  ofn.lpstrFilter       = szFilter;

  //   
  ofn.nFilterIndex      = 1;

  //     
  //  
  ofn.lpstrFile         = szFile;

  //     
  //  
  ofn.nMaxFile          = sizeof(szFile);

  //     
  //  
  ofn.lpstrFileTitle    = szFileTitle;

  //     
  //  
  ofn.nMaxFileTitle     = sizeof(szFileTitle);

  //     
  //    
  ofn.lpstrInitialDir   = NULL;

  //    
  ofn.Flags =   OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST
				  | OFN_HIDEREADONLY;
  //   
  if (GetOpenFileName(&ofn)) {

    //   
    hf = _lopen(ofn.lpstrFile, OF_READ);

    //   
	 return hf;
  }
  //     
  //  
  else return 0;
}

// -------------------------------
//  DIBReadFile
//  DIB-
// -------------------------------

HDIB DIBReadFile(HFILE hfDIBFile, DWORD *dwFileSize)
{
  //   
  // ,    
  //  
  HDIB hDib;

  HCURSOR  hCursor; //  
  
  //     
  LPDIB lpBuf;

  //     
  hCursor = SetCursor (LoadCursor(NULL, IDC_WAIT));

  //   .  
  //    
  //  
  *dwFileSize = _llseek(hfDIBFile, 0l, 2);

  //   
  //   
  _llseek(hfDIBFile, 0l, 0);

  //    ,
  //     
  hDib = (HDIB)GlobalAlloc(GMEM_FIXED, *dwFileSize);
  lpBuf = (unsigned char huge *)GlobalLock(hDib);

  //    ,
  //   
  if(lpBuf == NULL) return(NULL);

  //      
  _hread(hfDIBFile, lpBuf, *dwFileSize);

  //  
  SetCursor (hCursor);

  //  
  GlobalUnlock(hDib);

  //  
  _lclose(hfDIBFile);

  return hDib;
}

// -------------------------------
//  DIBInfo
//     
//  DIB-
// -------------------------------

BOOL DIBInfo(HDIB hDib, DWORD dwFileSize)
{
  char szBuf[256], szBuf1[256];
  DWORD biSize;
  LPBITMAPFILEHEADER lpDIBFileHeader;
  LPBITMAPINFOHEADER lpDIBInfoHeader;
  LPBITMAPCOREHEADER lpDIBCoreHeader;
  DWORD bfOffset;
  BOOL bWDIB;
  LPDIB lpDIBPtr;
  int nDIBType;
  WORD wNumColors;

  //    
  nDIBType = DIBType(hDib);

  if(!nDIBType) //  ,  
  {
    MessageBox(NULL, "   DIB-",
      "Bitmap Info", MB_OK | MB_ICONHAND);
    return FALSE;
  }

  //   ,    DIB
  lpDIBPtr = (unsigned char huge *)GlobalLock(hDib);
  if(lpDIBPtr == NULL)
     return(FALSE);

  lpDIBFileHeader = (LPBITMAPFILEHEADER)lpDIBPtr;

  //    
  //   
  bfOffset = lpDIBFileHeader->bfOffBits;
  biSize = (DWORD)(lpDIBPtr[sizeof(BITMAPFILEHEADER)]);

  //     
  wsprintf(szBuf,  " , :\t%ld\n", biSize);
  wsprintf(szBuf1, " , :    \t%ld\n", dwFileSize);
  lstrcat(szBuf, szBuf1);
  wsprintf(szBuf1, " , :\t%ld\n", bfOffset);
  lstrcat(szBuf, szBuf1);

  //     DIB (PM  Windows)
  //      
  if((nDIBType == WINRGB_DIB) ||
     (nDIBType == WINRLE4_DIB) ||
     (nDIBType == WINRLE8_DIB))
  {
    wsprintf(szBuf1,  "\nBMP  Windows\n", biSize);
    lstrcat(szBuf, szBuf1);
    lpDIBInfoHeader =
      (LPBITMAPINFOHEADER)(lpDIBPtr + sizeof(BITMAPFILEHEADER));

    wsprintf(szBuf1, ":\t%ldx%ld\n",
      lpDIBInfoHeader->biWidth, lpDIBInfoHeader->biHeight);
    lstrcat(szBuf, szBuf1);

    wsprintf(szBuf1, "  :\t%d\n",
      lpDIBInfoHeader->biBitCount);
    lstrcat(szBuf, szBuf1);

    wNumColors = DIBNumColors(lpDIBPtr);
    wsprintf(szBuf1, " :\t%d\n", wNumColors);
    lstrcat(szBuf, szBuf1);

    if(lpDIBInfoHeader->biCompression == BI_RGB)
    {
      lstrcat(szBuf, " \n");
    }
    else if(lpDIBInfoHeader->biCompression == BI_RLE4)
    {
      lstrcat(szBuf, " RLE4\n");
    }
    else if(lpDIBInfoHeader->biCompression == BI_RLE8)
    {
      lstrcat(szBuf, " RLE8\n");
    }
  }

  //   DIB   PM
  else
  {
    wsprintf(szBuf1,
      "\nBMP  Presentation Manager\n", biSize);
    lstrcat(szBuf, szBuf1);
    lpDIBCoreHeader =
      (LPBITMAPCOREHEADER)(lpDIBPtr + sizeof(BITMAPFILEHEADER));

    wsprintf(szBuf1, ":\t%dx%d\n",
      lpDIBCoreHeader->bcWidth, lpDIBCoreHeader->bcHeight);
    lstrcat(szBuf, szBuf1);

    wsprintf(szBuf1, "  :\t%d\n",
      lpDIBCoreHeader->bcBitCount);
    lstrcat(szBuf, szBuf1);
  }

  MessageBox(NULL, (LPSTR)szBuf,
    "Bitmap Info", MB_OK | MB_ICONINFORMATION);

  GlobalUnlock(hDib);
  return TRUE;
}


// -------------------------------
//  DIBType
//     DIB
// -------------------------------

int DIBType(HDIB hDib)
{
  LPBITMAPFILEHEADER lpDIBFileHeader;
  LPBITMAPINFOHEADER lpih;
  LPBITMAPCOREHEADER lpch;

  DWORD biSize;
  LPDIB hDIBPtr;
  int   nDIBType;

  if(hDib == NULL)
    //   DIB
    return(-2); 

  //  ,    DIB
  hDIBPtr = (LPDIB)GlobalLock(hDib);
  if(hDIBPtr == NULL)
    return(-1);

  lpDIBFileHeader = (LPBITMAPFILEHEADER)hDIBPtr;

  //   
  if(lpDIBFileHeader->bfType != 0x4d42)
  {
    GlobalUnlock(hDib);
    return 0;
  }

  //   
  biSize = (DWORD)(hDIBPtr[sizeof(BITMAPFILEHEADER)]);

  if(biSize == sizeof(BITMAPINFOHEADER)) // 40 
  {
    //   DIB   Windows
    lpih =
      (LPBITMAPINFOHEADER)(hDIBPtr + sizeof(BITMAPFILEHEADER));

    //     DIB
    if((lpih->biPlanes   == 1) &&
       ((lpih->biBitCount == 1) ||
        (lpih->biBitCount == 4) ||
        (lpih->biBitCount == 8) ||
        (lpih->biBitCount == 24)) &&
        ((lpih->biCompression  == BI_RGB) ||
         (lpih->biCompression == BI_RLE4 && lpih->biBitCount == 4) ||
         (lpih->biCompression == BI_RLE8 && lpih->biBitCount == 8)))
    {
       //    
       if(lpih->biCompression  == BI_RGB)
         nDIBType = WINRGB_DIB;
       else if(lpih->biCompression  == BI_RLE4)
         nDIBType = WINRLE4_DIB;
       else if(lpih->biCompression  == BI_RLE8)
         nDIBType = WINRLE8_DIB;
       else
         nDIBType = 0;
    }
    else
       nDIBType = 0;
  }

  else if(biSize == sizeof(BITMAPCOREHEADER)) // 12 
  {
    //   DIB   Presentation Manager
    lpch =
      (LPBITMAPCOREHEADER)(hDIBPtr + sizeof(BITMAPFILEHEADER));

    //     DIB
    if((lpch->bcPlanes   == 1) &&
       (lpch->bcBitCount == 1 ||
        lpch->bcBitCount == 4 ||
        lpch->bcBitCount == 8 ||
        lpch->bcBitCount == 24))
    {
      nDIBType = PM_DIB;
    }
    else
      nDIBType = 0;
  }

  else
    nDIBType = 0;

  GlobalUnlock(hDib);

  //      
  return nDIBType;
}

// -------------------------------
//  DIBNumColors
//   
// -------------------------------

WORD DIBNumColors(LPDIB lpDib)
{
  DWORD dwColorUsed;
  LPBITMAPINFOHEADER lpih;

  lpih =
    (LPBITMAPINFOHEADER)(lpDib + sizeof(BITMAPFILEHEADER));

  //  
  dwColorUsed = lpih->biClrUsed;

  //     ,
  //   
  if(dwColorUsed)
    return((WORD)dwColorUsed);

  //      ,
  //      
  //  ,   
  switch(lpih->biBitCount)
  {
    case 1:
      return 2;
    case 4:
      return 16;
    case 8:
      return 256;
    default:
      return 0;   //   
  }
}

// -------------------------------
//  DIBHeight
//   DIB  
// -------------------------------

WORD DIBHeight(LPDIB lpDib)
{
  LPBITMAPINFOHEADER lpih;

  lpih = (LPBITMAPINFOHEADER)(lpDib + sizeof(BITMAPFILEHEADER));
  return lpih->biHeight;
}

// -------------------------------
//  DIBWidth
//   DIB  
// -------------------------------

WORD DIBWidth(LPDIB lpDib)
{
  LPBITMAPINFOHEADER lpih;

  lpih = (LPBITMAPINFOHEADER)(lpDib + sizeof(BITMAPFILEHEADER));
  return lpih->biWidth;
}

// -------------------------------
//  DIBFindBits
//     
// -------------------------------

LPSTR DIBFindBits(LPDIB lpDib)
{
  LPBITMAPFILEHEADER lpfh;
  LPBITMAPINFOHEADER lpih;

  lpfh = (LPBITMAPFILEHEADER)lpDib;

  //  ,   
  //  (    )
  if(lpfh->bfOffBits)
    return((LPSTR)lpfh + lpfh->bfOffBits);

  //       
  //  
  lpih =
    (LPBITMAPINFOHEADER)(lpDib + sizeof(BITMAPFILEHEADER));

  return((LPSTR)lpih + lpih->biSize +
    (DWORD)(DIBNumColors(lpDib) * sizeof(RGBQUAD)));
}

// -------------------------------
//  DIBPaint
//  DIB    StretchDIBits
// -------------------------------

BOOL DIBPaint(HDC hdc, int x, int y, HDIB hDib)
{
  HBITMAP hbmp;
  HDC hMemDC;
  WORD wHeight, wWidth;
  LPDIB lpDib;
  LPBITMAPINFOHEADER lpih;

  lpDib = (LPDIB)GlobalLock(hDib);
  if(lpDib == NULL)
    return(-1);

  lpih =
    (LPBITMAPINFOHEADER)(lpDib + sizeof(BITMAPFILEHEADER));

  //   DIB 
  wHeight = lpih->biHeight;
  wWidth  = lpih->biWidth;

  //  DIB  
  StretchDIBits(hdc,
     x, y, wWidth, wHeight,
     0, 0, wWidth, wHeight,
     DIBFindBits(lpDib),
     (LPBITMAPINFO)lpih,
     DIB_RGB_COLORS, SRCCOPY);

  GlobalUnlock(hDib);

  return TRUE;
}

// -------------------------------
//  DIBPaintBlt
//  DIB    BitBlt
// -------------------------------

BOOL DIBPaintBlt(HDC hdc, int x, int y, HDIB hDib)
{
  HBITMAP hbmp;
  HDC hMemDC;
  WORD wHeight, wWidth;
  LPDIB lpDib;
  LPBITMAPINFOHEADER lpih;


  lpDib = (LPDIB)GlobalLock(hDib);
  if(lpDib == NULL)
    return(-1);

  lpih = (LPBITMAPINFOHEADER)(lpDib + sizeof(BITMAPFILEHEADER));

  wHeight = lpih->biHeight;
  wWidth  = lpih->biWidth;

  //    
  hbmp = CreateCompatibleBitmap(hdc, wWidth, wHeight);

  //    
  hMemDC = CreateCompatibleDC(hdc);

  //  DIB  DDB
  SetDIBits(hdc, hbmp, 0, wHeight,
    DIBFindBits(lpDib),
    (LPBITMAPINFO)lpih, DIB_RGB_COLORS);

  //  DDB   
  hbmp = (HBITMAP)SelectObject(hMemDC, hbmp);

  //  DDB
  BitBlt(hdc, x, y, wWidth, wHeight,
         hMemDC, 0, 0, SRCCOPY);

  //   
  DeleteObject(SelectObject(hMemDC, hbmp));
  DeleteDC(hMemDC);

  GlobalUnlock(hDib);
  return TRUE;
}

// -------------------------------
//  DIBCreatePalette
//       DIB
// -------------------------------

HPALETTE DIBCreatePalette(HDIB hDib)
{
   LPLOGPALETTE lpPal;
   HPALETTE     hPal = NULL;
   HANDLE       hLogPal;
   int i, wNumColors;
   LPSTR lpbi;
   LPBITMAPINFO lpbmi;

   if (!hDib)
      return NULL;

   lpbi = (LPSTR)GlobalLock(hDib);
   lpbmi =
     (LPBITMAPINFO)(lpbi + sizeof(BITMAPFILEHEADER));

   //    
   wNumColors = DIBNumColors(lpbi);

   //   DIB   ,  
   if (wNumColors)
   {
      //    
      hLogPal = GlobalAlloc(GHND, sizeof(LOGPALETTE)
         + sizeof(PALETTEENTRY) *  wNumColors);

      if (!hLogPal)
      {
        GlobalUnlock(hDib);
        return NULL;
      }

      //    
      lpPal = (LPLOGPALETTE)GlobalLock(hLogPal);

      //  
      lpPal->palVersion = 0x300;
      lpPal->palNumEntries = wNumColors;

      //  
      for (i = 0; i < wNumColors; i++)
      {
        lpPal->palPalEntry[i].peRed   =
           lpbmi->bmiColors[i].rgbRed;

        lpPal->palPalEntry[i].peGreen =
           lpbmi->bmiColors[i].rgbGreen;

        lpPal->palPalEntry[i].peBlue  =
           lpbmi->bmiColors[i].rgbBlue;

        lpPal->palPalEntry[i].peFlags = 0;
      }

      //  
      hPal = CreatePalette(lpPal);
      if (!hPal)
      {
        GlobalUnlock(hLogPal);
        GlobalFree(hLogPal);
        return NULL;
      }

     GlobalUnlock(hLogPal);
     GlobalFree(hLogPal);
   }

   GlobalUnlock(hDib);

   //     
   return hPal;
}

