// ----------------------------------------
//    
//   
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>

//  

BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

//   
char const szClassName[]   = "BrushAppClass";

//  
char const szWindowTitle[] = "Brush Demo";

//   bitmap
HBITMAP hBmp;

//  
HBRUSH  hBrush;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  //   bitmap  
  hBmp   = LoadBitmap(hInstance, "#123");

  //     
  hBrush = CreatePatternBrush(hBmp);

  //  
  if(!InitApp(hInstance))
      return FALSE;

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,    
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 

  //     ,  
  if(!hwnd)
    return FALSE;

  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  //    

  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }

  //    
  //      
  DeleteObject(hBmp);
  DeleteObject(hBrush);

  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  

  memset(&wc, 0, sizeof(wc));

  //    
  wc.hbrBackground = hBrush;

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}