// ----------------------------------------
//   
//  "combobox"  
//  
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>
#include <dir.h>

#define ID_LIST   1
#define ID_BUTTON 2

//  
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

//   
char const szClassName[]   = "ComboAppClass";

//  
char const szWindowTitle[] = " ";

//   
HINSTANCE hInst;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  //  
  if(!InitApp(hInstance))
      return FALSE;

  //    
  //   
  hInst = hInstance;

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,   
    CW_USEDEFAULT,       // 
    CW_USEDEFAULT,       // 
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 
  //     ,  
  if(!hwnd)
    return FALSE;

  //   
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  //    
  while(GetMessage(&msg, 0, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  //    "combobox"
  static HWND hComboBox;

  //  
  static HWND hButton;

  switch (msg)
  {
    case WM_CREATE:
    {
      //  
      hComboBox = CreateWindow("ComboBox", NULL,
	 WS_CHILD | WS_VISIBLE | WS_VSCROLL |
         CBS_AUTOHSCROLL | CBS_SIMPLE,
	 30, 30, 200, 200,
	 hwnd, (HMENU) ID_LIST, hInst, NULL);

      //     
      // 
      SendMessage(hComboBox, CB_DIR,
        DDL_READWRITE | DDL_READONLY | DDL_HIDDEN |
        DDL_SYSTEM | DDL_DIRECTORY | DDL_DRIVES |
        DDL_ARCHIVE,
        (LPARAM)(LPSTR)"*.*");

      //  
      hButton = CreateWindow("button", "OK",
         WS_CHILD | WS_VISIBLE |
	 BS_PUSHBUTTON,
	 250, 30, 50, 20,
	 hwnd, (HMENU) ID_BUTTON, hInst, NULL);

      return 0;
    }

    case WM_SETFOCUS:
    {
      SetFocus(hComboBox);
      return 0;
    }

    case WM_COMMAND:
    {
      //     
      if(wParam == ID_LIST)
      {
	if(HIWORD(lParam) == (unsigned)CBN_ERRSPACE)
	{
	  MessageBox(hwnd, " ",
	   szWindowTitle, MB_OK);
	}

        //     , 
        //  
	else if(HIWORD(lParam) == CBN_DBLCLK)
	{
          //     
          SendMessage(hwnd, WM_COMMAND, ID_BUTTON, 0L);
          return 0;
	}

        //    
        // ,    
        //  
	else if(HIWORD(lParam) == CBN_SELCHANGE)
	{
          int uSelectedItem, nSize;
          char Buffer[256];
          HDC hdc;

          //     
	  uSelectedItem = (int)SendMessage(hComboBox,
	     CB_GETCURSEL, 0, 0L);

	  if(uSelectedItem != CB_ERR)
	  {
             //  
             SendMessage(hComboBox, CB_GETLBTEXT,
	       uSelectedItem, (LPARAM)Buffer);

             hdc = GetDC(hwnd);
             nSize = lstrlen(Buffer);

             TextOut(hdc, 250, 60,
             (LPSTR)"                         ", 25);
             TextOut(hdc, 250, 60, (LPSTR)Buffer, nSize);

             ReleaseDC(hwnd, hdc);
          }
	}
      }

      //   
      else if(wParam == ID_BUTTON)
      {
        int uSelectedItem;
        char Buffer[256];

        //    
        uSelectedItem = (int)SendMessage(hComboBox,
           CB_GETCURSEL, 0, 0L);

        if(uSelectedItem != LB_ERR)
        {
           //   
           SendMessage(hComboBox, CB_GETLBTEXT,
             uSelectedItem, (LPARAM)Buffer);

           //      ,
           //    
           // ,    
           if(Buffer[0] == '[')
           {
             //      
             Buffer[lstrlen(Buffer) - 1] = '\0';

             //   
             if(chdir(&Buffer[1]) != 0)
             {
               //   ,   
               // .     
               //      ":\\:
               Buffer[3] = '\0';
               lstrcat(Buffer, ":\\");
  
               //   
               if(chdir(&Buffer[2]) == 0)
               {
                 //    
                 //  
                 AnsiLowerBuff(&Buffer[2], 1);

                 //   
                 setdisk(Buffer[2] - 'a');
               }
             }

             //   
             SendMessage(hComboBox, CB_RESETCONTENT, 0, 0L);

             //     
             //     ,  
             //     
             SendMessage(hComboBox, CB_DIR,
                DDL_READWRITE | DDL_READONLY  | DDL_HIDDEN |
                DDL_SYSTEM    | DDL_DIRECTORY | DDL_DRIVES |
                DDL_ARCHIVE, (LPARAM)(LPSTR)"*.*");
           }

           //   ,     
           else
           {
	      MessageBox(hwnd, Buffer, szWindowTitle, MB_OK);
           }
        }
      }
      return 0;
    }

    case WM_PAINT:
    {
      HDC hdc;
      PAINTSTRUCT ps;

      hdc = BeginPaint(hwnd, &ps);

      TextOut(hdc, 30, 10,
	" ,   ", 31);

      EndPaint(hwnd, &ps);
      return 0;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}