// ----------------------------------------
//     COMBOBOX
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>
#include "dlgcombo.hpp"

#define IDB_Button1 1

//  
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL    CALLBACK _export DlgProc(HWND, UINT, WPARAM, LPARAM);

//   
char const szClassName[]   = "DialogAppClass";

//  
char const szWindowTitle[] = "Dialog Box Demo";

HINSTANCE hInst;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  HWND hButton1;

  //  
  if(!InitApp(hInstance))
      return FALSE;

  hInst = hInstance;

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,    
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 

  //     ,  
  if(!hwnd)
    return FALSE;

  //   
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  //  
  hButton1 = CreateWindow("button", "Open...",
    WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
    20, 20,
    90, 30,
    hwnd,
    (HMENU) IDB_Button1,
    hInstance, NULL);

  //    
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    case WM_COMMAND:
    {
      //   , 
      //  
      if(wParam == IDB_Button1)
      {
        //    
        DialogBox(hInst, "SELECT_FILE", hwnd, (DLGPROC)DlgProc);
      }
      return 0;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// =====================================
//  DldProc
// =====================================
#pragma argsused

BOOL CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    //   
    case WM_INITDIALOG:
    {
      //    , 
      //   
      DlgDirListComboBox(hdlg,
        "*.*", IDC_COMBO, IDC_STATIC,
        DDL_READWRITE | DDL_READONLY  | DDL_HIDDEN |
        DDL_SYSTEM    | DDL_DIRECTORY | DDL_DRIVES |
        DDL_ARCHIVE);

      return TRUE;
    }

    case WM_COMMAND:
    {
      switch(wParam)
      {
        char Buffer[80];

        //    
        case IDC_COMBO:
        {
          //      
          if(HIWORD(lParam) == LBN_DBLCLK)
          {
            //   
            //     
            GetDlgItemText(hdlg, IDC_COMBO, Buffer, 80);
            MessageBox(hdlg, Buffer, szWindowTitle, MB_OK);
          }
          return TRUE;
        }

        //    "OK"
        case IDOK:
        {
          //   
          //     
          GetDlgItemText(hdlg, IDC_COMBO, Buffer, 80);
          MessageBox(hdlg, Buffer, szWindowTitle, MB_OK);
          return TRUE;
        }

        //   .
        case IDCANCEL:
        {
          //    
          EndDialog(hdlg, 0);
          return TRUE;
        }
      }
    }
  }
  return FALSE;
}
