// ----------------------------------------
//  
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>

//   
#define ID_EDIT   1

//  
#define ID_BUTTON 2

//  
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

//   
char const szClassName[]   = "EditAppClass";

//  
char const szWindowTitle[] = "Edit Demo";

//   
HINSTANCE hInst;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  //  
  if(!InitApp(hInstance))
      return FALSE;

  //    
  //   
  hInst = hInstance;

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,   
    CW_USEDEFAULT,       // 
    CW_USEDEFAULT,       // 
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 
  //     ,  
  if(!hwnd)
    return FALSE;

  //   
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  //    
  while(GetMessage(&msg, 0, 0, 0))
  {
    //    
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  //   
  static HWND hEdit;

  //  
  static HWND hButton;

  switch (msg)
  {
    case WM_CREATE:
    {
      //   
      hEdit = CreateWindow("edit", NULL,
         WS_CHILD | WS_VISIBLE | WS_BORDER |
	 ES_LEFT,
	 30, 30, 300, 30,
	 hwnd, (HMENU) ID_EDIT, hInst, NULL);

      //  
      hButton = CreateWindow("button", "OK",
         WS_CHILD | WS_VISIBLE |
	 BS_PUSHBUTTON,
	 30, 80, 100, 30,
	 hwnd, (HMENU) ID_BUTTON, hInst, NULL);

      return 0;
    }

    //     
    //  ,    
    case WM_SETFOCUS:
    {
      SetFocus(hEdit);
      return 0;
    }

    case WM_COMMAND:
    {
      //    
      //  
      if(wParam == ID_EDIT)
      {
	if(HIWORD(lParam) == EN_ERRSPACE)
	{
	  MessageBox(hwnd, " ",
	   szWindowTitle, MB_OK);
	}
      }

      //   
      else if(wParam == ID_BUTTON)
      {
	 BYTE chBuff[80];
         WORD cbText;

	 //     
         //     
         * (WORD *) chBuff = sizeof (chBuff) - 1;

	 //     
	 //  .   
         // ,   
	 cbText = SendMessage(hEdit, EM_GETLINE, 0,
	   (LPARAM)(LPSTR)chBuff);

         //    
	 chBuff[cbText] = '\0';

         //     
	 MessageBox(hwnd, chBuff,
	   szWindowTitle, MB_OK);
      }
      return 0;
    }

    case WM_PAINT:
    {
      HDC hdc;
      PAINTSTRUCT ps;

      //    
      hdc = BeginPaint(hwnd, &ps);

      //   
      TextOut(hdc, 30, 10,
	"     'OK'", 36);

      //    
      EndPaint(hwnd, &ps);
      return 0;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}