// ----------------------------------------
//  
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>
#include "ico.hpp"

void Error(void);
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

char szClassName[80];
char szWindowTitle[80];

HINSTANCE hInst;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine,
	int       nCmdShow)
{
  MSG  msg;   //     
  HWND hwnd;  //    
  int  cb;

  hInst = hInstance;

  //    
  cb = LoadString(hInstance, IDS_CLASSNAME,
    szClassName, sizeof(szClassName));

  if(!cb)
  {
    Error(); return -1;
  }

  cb = LoadString(hInstance, IDS_WINDOWTITLE,
    szWindowTitle, sizeof(szWindowTitle));

  if(!cb)
  {
    Error(); return -1;
  }

  if(!InitApp(hInstance))
      return FALSE;

  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,    
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 
  if(!hwnd)
    return FALSE;

  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  

  memset(&wc, 0, sizeof(wc));

  //  ,   
  //       
  wc.hIcon = LoadIcon(hInstance, "AppIcon");

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  aWndClass = RegisterClass(&wc);
  return (aWndClass != 0);
}

// --------------------------------------------
//     
// --------------------------------------------
void Error(void)
{
  MessageBox(NULL, "   ",
    "Error", MB_OK | MB_ICONSTOP);
}