#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <mem.h>

#include "toolbar.hpp"


LRESULT CALLBACK _export
  ToolbarWndProc(HWND, UINT, WPARAM, LPARAM);

void DrawButton(LPDRAWITEMSTRUCT lpInfo);
void DrawBitmap(HDC hDC, int x, int y, HBITMAP hBitmap);

//     TbMain
HBITMAP   TbMain::hbmpUp[20];
HBITMAP   TbMain::hbmpDown[20];
HBITMAP   TbMain::hbmpGrayed[20];
HWND      TbMain::hwndParent;
HINSTANCE TbMain::hInst;
int       TbMain::nFirstId = 0;

// ======================================================
//   Toolbar
// ======================================================
Toolbar::Toolbar(HINSTANCE hInstance, HWND hwndParentWindow, int nFirstId)
{
  //   
  errno = 0;

  //    ,
  //   , 
  // TOOLBAR,     
  //   TOOLBAR
  TbMain::hInst = hInstance;
  TbMain::hwndParent = hwndParentWindow;
  TbMain::nFirstId = nFirstId;

  //    
  //  
  GetClientRect(TbMain::hwndParent, &rcParent);

  //    , 
  //      TOOLBAR
  GetRect();

  //      TOOLBAR
  if(!RegisterWndClass())
  {
    errno = 1;
    return;
  }

  //    TOOLBAR
  CreateTbWindow();

  if(hwndToolbar == NULL)
  {
    errno = 2;
    return;
  }
}

// ======================================================
//   Toolbar
// ======================================================
Toolbar::~Toolbar()
{
  //    TOOLBAR
  DestroyWindow(hwndToolbar);
}

// ======================================================
//   ToolbarWndProc    TOOLBAR
// ======================================================

LRESULT CALLBACK _export
ToolbarWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
     //   WM_COMMAND   
     //  
     case WM_COMMAND:
     {
       SendMessage(TbMain::hwndParent, WM_COMMAND, wParam, lParam);
       return 0;
     }

     //      
     //    ,  
     //  
     case WM_DRAWITEM:
     {
       //  
       DrawButton( (LPDRAWITEMSTRUCT)lParam );
       break;
     }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// ======================================================
//  DrawButton
//  
// ======================================================

void DrawButton(LPDRAWITEMSTRUCT lpInfo)
{
   HBITMAP hbm;

   //   WM_DRAWITEM
   //       
   if(lpInfo->CtlType != ODT_BUTTON)
     return;

   hbm = TbMain::hbmpUp[(lpInfo->CtlID) - TbMain::nFirstId];

   //   ,    
   // 
   if (lpInfo->itemState & ODS_SELECTED)
   {
     hbm = TbMain::hbmpDown[(lpInfo->CtlID) - TbMain::nFirstId];
   }

   //   ,  
   //     
   else if (lpInfo->itemState & ODS_DISABLED)
   {
     hbm = TbMain::hbmpGrayed[(lpInfo->CtlID) - TbMain::nFirstId];
   }

   //     
   if(!hbm) return;

   //       
   // ,   DrawBitmap
   if((lpInfo->itemAction & ODA_DRAWENTIRE) ||
      (lpInfo->itemAction & ODA_SELECT))
   {
     //  
     DrawBitmap(lpInfo->hDC,
       (lpInfo->rcItem).left,
       (lpInfo->rcItem).top , hbm);
   }
}
