#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <commdlg.h>
#include <mmsystem.h>
#include <mem.h>
#pragma hdrstop

#include "waveio.hpp"

BOOL WAVEPlay(HWND);

extern WAVEIOCB waveiocbOut;
extern WAVEIOCB waveiocbIn;
extern HWAVEOUT hWaveOut;
extern HWAVEIN  hWaveIn;
extern int  nMode;
extern int  nPosition;

//-----------------------------------------------------
// WAVELoad
//  wav-  
//-----------------------------------------------------
BOOL WAVELoad(LPWAVEIOCB lpwiocb)
{
  BYTE szFileName[256];
  OPENFILENAME ofn;
  int rc;
  BYTE szBuf[256];

  //   ,  
  //  
  rc=waveOutGetNumDevs();
  if(!rc)
  {
    MessageBox(NULL,
    (LPSTR)"     ",
    "Wave Error", MB_OK | MB_ICONHAND);
    return FALSE;
  }

  //  wav-
  if(!wioSelectFile(szFileName))
    return FALSE;

  //       
  rc = wioFileOpen(lpwiocb, (LPSTR)szFileName);

  if(rc == WIOERR_NOERROR)
    return TRUE;
  else if(rc == WIOERR_FILEERROR)
    lstrcpy(szBuf, "   ");
  else if(rc == WIOERR_BADFORMAT)
    lstrcpy(szBuf, "    ");
  else if(rc == WIOERR_NOMEM)
    lstrcpy(szBuf, " ");
  else if(rc == WIOERR_READERROR)
    lstrcpy(szBuf, "  ");
  else
    lstrcpy(szBuf, " ");

  MessageBox(NULL, (LPSTR)szBuf,
    "Wave Error", MB_OK | MB_ICONHAND);
  return FALSE;
}

//-----------------------------------------------------
// wioSelectFile
//  wav-
//-----------------------------------------------------
BOOL wioSelectFile(LPSTR lpszFileName)
{
  OPENFILENAME ofn;

  char szFile[256];
  char szFileTitle[256];
  char szFilter[256] =
	 "Wave Files\0*.wav\0Any Files\0*.*\0";
  szFile[0] = '\0';
  memset(&ofn, 0, sizeof(OPENFILENAME));

  //    
  ofn.lStructSize       = sizeof(OPENFILENAME);
  ofn.hwndOwner         = NULL;
  ofn.lpstrFilter       = szFilter;
  ofn.nFilterIndex      = 1;
  ofn.lpstrFile         = szFile;
  ofn.nMaxFile          = sizeof(szFile);
  ofn.lpstrFileTitle    = szFileTitle;
  ofn.nMaxFileTitle     = sizeof(szFileTitle);
  ofn.lpstrInitialDir   = NULL;
  ofn.Flags =   OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST
               | OFN_HIDEREADONLY;

  //   
  if (GetOpenFileName(&ofn))
  {
    //     
    lstrcpy(lpszFileName, (LPSTR)szFile);
    return TRUE;
  }
  else
    return FALSE;
}

//---------------------------------------------------------
//  wioFileOpen
//     wav-
//---------------------------------------------------------
int wioFileOpen(LPWAVEIOCB lpwiocb, LPSTR lpszFileName)
{
  HMMIO hmmio;
  MMCKINFO ckRIFF, ckFMT;
  DWORD dwFmtSize;

  //  wav-
  hmmio = mmioOpen((LPSTR)lpszFileName, NULL, MMIO_READ | MMIO_ALLOCBUF);
  if(!hmmio)
    return WIOERR_FILEERROR;

  //   "WAVE"
  memset(&ckRIFF, 0, sizeof(MMCKINFO));
  ckRIFF.fccType = mmioFOURCC('W', 'A', 'V', 'E');

  if(mmioDescend(hmmio, &ckRIFF, NULL, MMIO_FINDRIFF))
  {
    mmioClose(hmmio,0);
    return WIOERR_BADFORMAT;
  }

  //   "fmt "
  memset(&ckFMT, 0, sizeof(MMCKINFO));
  ckFMT.ckid = mmioFOURCC('f', 'm', 't', ' ');

  if(mmioDescend(hmmio,
    &ckFMT, &ckRIFF, MMIO_FINDCHUNK))
  {
    mmioClose(hmmio,0);
    return WIOERR_BADFORMAT;
  }

  dwFmtSize = sizeof(PCMWAVEFORMAT);  //ckFMT.cksize;

  //        
  lpwiocb->lpFmt = (PCMWAVEFORMAT FAR *)GlobalAllocPtr(GPTR, dwFmtSize);

  if(!lpwiocb->lpFmt)
  {
    mmioClose(hmmio,0);
    return WIOERR_NOMEM;
  }

  //    
  if(mmioRead(hmmio, (HPSTR)lpwiocb->lpFmt, dwFmtSize) != (LONG)dwFmtSize)
  {
    GlobalFreePtr(lpwiocb->lpFmt);
    mmioClose(hmmio,0);
    return WIOERR_READERROR;
  }

  //    
  if(lpwiocb->lpFmt->wf.wFormatTag != WAVE_FORMAT_PCM)
  {
    GlobalFreePtr(lpwiocb->lpFmt);
    mmioClose(hmmio,0);
    return WIOERR_BADFORMAT;
  }

  //       
  if(waveOutOpen(NULL, WAVE_MAPPER, (WAVEFORMAT FAR *)lpwiocb->lpFmt,
       NULL, 0L, WAVE_FORMAT_QUERY | WAVE_ALLOWSYNC))
  {
    GlobalFreePtr(lpwiocb->lpFmt);
    mmioClose(hmmio,0);
    return WIOERR_BADFORMAT;
  }

  //   ,  
  //     
  lpwiocb->wBitsPerSample = lpwiocb->lpFmt->wBitsPerSample;
  lpwiocb->wBytesPerSample =
    (waveiocbOut.wBitsPerSample/8) * waveiocbOut.lpFmt->wf.nChannels;

  //   "data"
  mmioAscend(hmmio, &ckFMT, 0);
  ckFMT.ckid = mmioFOURCC('d', 'a', 't', 'a');

  if(mmioDescend(hmmio, &ckFMT, &ckRIFF, MMIO_FINDCHUNK))
  {
    GlobalFreePtr(lpwiocb->lpFmt);
    mmioClose(hmmio,0);
    return WIOERR_BADFORMAT;
  }

  //     
  //      wav-
  lpwiocb->dwDataSize   = ckFMT.cksize;
  lpwiocb->dwDataOffset = ckFMT.dwDataOffset;

  // ,    
  if(lpwiocb->dwDataSize == 0L)
  {
    GlobalFreePtr(lpwiocb->lpFmt);
    mmioClose(hmmio,0);
    return WIOERR_BADFORMAT;
  }

  //     
  lpwiocb->lpWaveHdr =
    (LPWAVEHDR)GlobalAllocPtr(GMEM_MOVEABLE | GMEM_SHARE, sizeof(WAVEHDR));
  if(!lpwiocb->lpWaveHdr)
    return WIOERR_NOMEM;

  //      
  lpwiocb->lpData =
    (HPSTR)GlobalAllocPtr(GMEM_MOVEABLE | GMEM_SHARE, lpwiocb->dwDataSize);
  if(!lpwiocb->lpData)
    return WIOERR_NOMEM;

  //     
  mmioSeek(hmmio, SEEK_SET, lpwiocb->dwDataOffset);

  //   
  mmioRead(hmmio, lpwiocb->lpData, lpwiocb->dwDataSize);

  //  wav-
  mmioClose(hmmio,0);

  return WIOERR_NOERROR;
}

//---------------------------------------------------------
// wioPlay
//     
//---------------------------------------------------------
int wioPlay(LPWAVEIOCB lpwiocb, HWND hwnd)
{
  WORD rc;

  //   
  rc=waveOutOpen(&hWaveOut, WAVE_MAPPER, (WAVEFORMAT FAR *)lpwiocb->lpFmt,
                 (UINT)hwnd, 0L, CALLBACK_WINDOW | WAVE_ALLOWSYNC);
  if(rc) return rc;

  //    
  lpwiocb->lpWaveHdr->lpData          = (LPSTR)lpwiocb->lpData;
  lpwiocb->lpWaveHdr->dwBufferLength  = lpwiocb->dwDataSize;
  lpwiocb->lpWaveHdr->dwBytesRecorded = 0;
  lpwiocb->lpWaveHdr->dwFlags         = 0;
  lpwiocb->lpWaveHdr->dwLoops         = 0;
  lpwiocb->lpWaveHdr->dwUser          = 0;
  lpwiocb->lpWaveHdr->lpNext          = 0;
  lpwiocb->lpWaveHdr->reserved        = 0;

  //    
  rc=waveOutPrepareHeader(hWaveOut, lpwiocb->lpWaveHdr, sizeof(WAVEHDR));
  if(rc)
  {
    GlobalFreePtr(lpwiocb->lpWaveHdr);
    return rc;
  }

  //   
  rc = waveOutWrite(hWaveOut, lpwiocb->lpWaveHdr, sizeof(WAVEHDR));
  if(rc)
  {
    waveOutUnprepareHeader(hWaveOut, lpwiocb->lpWaveHdr, sizeof(WAVEHDR));
    GlobalFreePtr(lpwiocb->lpWaveHdr);
    return rc;
  }

  return 0;
}

//---------------------------------------------------------
//  wioRecord
//    
//---------------------------------------------------------
int wioRecord(LPWAVEIOCB lpwiocb, HWND hwnd)
{
  int rc;

  //   , 
  //    
  rc=waveInGetNumDevs();
  if(!rc)
  {
    MessageBox(NULL,
    (LPSTR)"     ",
    "Wave Error", MB_OK | MB_ICONHAND);
    return WIOERR_NODEVICE;
  }

  //     
  lpwiocb->dwDataSize = MAXSAMPLES;

  //     
  lpwiocb->lpWaveHdr =
    (LPWAVEHDR)GlobalAllocPtr(GMEM_MOVEABLE | GMEM_SHARE, sizeof(WAVEHDR));
  if(!lpwiocb->lpWaveHdr)
    return WIOERR_NOMEM;

  //      
  lpwiocb->lpData =
    (HPSTR)GlobalAllocPtr(GMEM_MOVEABLE | GMEM_SHARE, lpwiocb->dwDataSize);
  if(!lpwiocb->lpData)
    return WIOERR_NOMEM;

  //      
  lpwiocb->lpFmt =
    (PCMWAVEFORMAT FAR *)GlobalAllocPtr(GPTR, sizeof(WAVEFORMAT));

  if(!lpwiocb->lpFmt)
  {
    return WIOERR_NOMEM;
  }

  //   .   
  //      WAVE_FORMAT_PCM
  //    22,05 
  lpwiocb->lpFmt->wf.wFormatTag      = WAVE_FORMAT_PCM;
  lpwiocb->lpFmt->wf.nChannels       = 1;
  lpwiocb->lpFmt->wf.nSamplesPerSec  = 22050;
  lpwiocb->lpFmt->wf.nAvgBytesPerSec = 22050;
  lpwiocb->lpFmt->wf.nBlockAlign     = 1;

  //   
  rc=waveInOpen(&hWaveIn, WAVE_MAPPER, (WAVEFORMAT FAR *)lpwiocb->lpFmt,
                (UINT)hwnd, 0L, CALLBACK_WINDOW | WAVE_ALLOWSYNC);
  if(rc)
  {
    wioInError(rc);
    return WIOERR_BADFORMAT;
  }

  //   
  lpwiocb->lpWaveHdr->lpData         = (LPSTR)lpwiocb->lpData;
  lpwiocb->lpWaveHdr->dwBufferLength = lpwiocb->dwDataSize;
  lpwiocb->lpWaveHdr->dwFlags        = 0L;
  lpwiocb->lpWaveHdr->dwLoops        = 0L;
  lpwiocb->lpWaveHdr->dwUser         = 0L;

  //    
  rc = waveInPrepareHeader(hWaveIn, lpwiocb->lpWaveHdr, sizeof(WAVEHDR));
  if(rc)
  {
    wioInError(rc);
    GlobalFreePtr(lpwiocb->lpWaveHdr);
    return WIOERR_BADFORMAT;
  }

  //    
  rc = waveInAddBuffer(hWaveIn, lpwiocb->lpWaveHdr, sizeof(WAVEHDR));
  if(rc)
  {
    wioInError(rc);
    waveInUnprepareHeader(hWaveIn, lpwiocb->lpWaveHdr, sizeof(WAVEHDR));
    GlobalFreePtr(lpwiocb->lpWaveHdr);
    GlobalFreePtr(lpwiocb->lpFmt);
    GlobalFreePtr(lpwiocb->lpData);
    return WIOERR_ERROR;
  }

  //  
  rc = waveInStart(hWaveIn);
  if(rc)  wioInError(rc);

  return TRUE;
}

//---------------------------------------------------------
//  wioFileSave
//      wav-
//---------------------------------------------------------
BOOL wioFileSave(LPSTR szFileName)
{
   DWORD dwDataSize;
   char szdata[] = "data";
   HMMIO hFile;
   MMCKINFO ck;
   WORD wBitsPerSample = 8;
   char szfmt[] = "fmt ";
   DWORD dwFmtSize = sizeof(PCMWAVEFORMAT);

   //      
   hFile = mmioOpen(szFileName, NULL, MMIO_CREATE | MMIO_READWRITE);
   if(hFile != NULL)
   {
     //   wav- 
     ck.ckid = MMIO_CREATERIFF;
     ck.cksize = waveiocbIn.lpWaveHdr->dwBytesRecorded
                 + sizeof(PCMWAVEFORMAT) + 20;
     ck.fccType = mmioFOURCC('W', 'A', 'V', 'E');
     mmioCreateChunk(hFile, (LPMMCKINFO)&ck, MMIO_CREATERIFF);

     //   "fmt "
     mmioWrite(hFile, (HPSTR)szfmt, 4);
     mmioWrite(hFile, (HPSTR)&dwFmtSize, sizeof(DWORD));

     mmioWrite(hFile, (HPSTR)waveiocbIn.lpFmt, sizeof(WAVEFORMAT));
     mmioWrite(hFile, (HPSTR)&wBitsPerSample, sizeof(WORD));

     mmioWrite(hFile, (HPSTR)szdata, 4);
     dwDataSize = waveiocbIn.lpWaveHdr->dwBytesRecorded;
     mmioWrite(hFile, (HPSTR)&dwDataSize, sizeof(DWORD));

     //  
     mmioWrite(hFile, (HPSTR)waveiocbIn.lpData, waveiocbIn.lpWaveHdr->dwBytesRecorded);

     //  
     mmioClose(hFile, 0);
     return TRUE;
   }
   return FALSE;
}

//---------------------------------------------------------
//  wioOutError
//        
//---------------------------------------------------------
void wioOutError(int rc)
{
  BYTE szBuf[MAXERRORLENGTH];

  if(waveOutGetErrorText(rc, (LPSTR)szBuf, MAXERRORLENGTH) ==
    MMSYSERR_BADERRNUM)
  {
    lstrcpy(szBuf, "Unknown Error");
  }
  MessageBox(NULL, (LPSTR)szBuf,
    "Wave Error", MB_OK | MB_ICONHAND);
}

//---------------------------------------------------------
//  wioOutError
//        
//---------------------------------------------------------
void wioInError(int rc)
{
  BYTE szBuf[MAXERRORLENGTH];

  if(waveInGetErrorText(rc, (LPSTR)szBuf, MAXERRORLENGTH) ==
    MMSYSERR_BADERRNUM)
  {
    lstrcpy(szBuf, "Unknown Error");
  }
  MessageBox(NULL, (LPSTR)szBuf,
    "Wave Error", MB_OK | MB_ICONHAND);
}
