// UART.H


/**
*.Name         SelectPort
*
*.Title        롨ࠥ ᯮ㥬 COM-
*
*.Descr         㭪 ।   COM-⮬
*                쭥襬 㤥 ࠡ.
*
*.Proto        void far SelectPort(int port)
*
*.Params       int port -   (COM1..COM4)
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far SelectPort(int);


/**
*.Name         SaveCom
*
*.Title        ࠭塞   뢠 COM-
*
*.Descr         㭪 ࠭  ண ࠡ稪
*              뢠  COM-.
*
*.Proto        void far SaveCom(void)
*
*.Params        ᯮ
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far SaveCom(void);


/**
*.Name         RestoreCom
*
*.Title        ⠭   뢠 COM-
*
*.Descr         㭪 ⠭  ண ࠡ稪
*              뢠  COM-.
*
*.Proto        void far RestoreCom(void)
*
*.Params        ᯮ
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far RestoreCom(void);


/**
*.Name         InstallCom
*
*.Title        ⠭ ᢮ ࠡ稪 뢠 COM-
*
*.Descr         㭪 ⠭  ࠡ稪
*              뢠  COM-.
*
*.Proto        int far InstallCom(void)
*
*.Params        ᯮ
*
*.Return       頥 1  ᯥ譮 ⠭
*               0  砥 訡
*
*.Sample       comm.asm
**/
int far InstallCom(void);


/**
*.Name         OpenCom
*
*.Title        ⠭ ᢮ ࠡ稪 뢠 COM-
*
*.Descr         㭪 ⠭  ࠡ稪
*              뢠  COM-.
*
*.Proto        void far OpenCom( int baud, int device,
*                                 int parity, int stop_bits )
*
*.Params       int baud       - ᪮ 
*              int device     - ⨯ ந⢠ 裡: M - 
*                               D - -
*              int parity     - ஢ઠ  ⭮: N -  ஢ન
*                                ⭮, O - ஢ઠ  ⭮,
*                               E - ஢ઠ  ⭮, S - Space,
*                               M - Mark
*              int stop_bits  - ⢮ ⮯ ⮢
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far OpenCom( int, int, int, int );


/**
*.Name         CloseCom
*
*.Title        頥 뢠  ᨭ஭  COM-
*
*.Descr         㭪 頥 뢠  COM-
*
*.Proto        void far CloseCom(void)
*
*.Params        ᯮ
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far CloseCom(void);  /* close com port */


/**
*.Name         DtrOff
*
*.Title        뢠 ᨣ DTR
*
*.Proto        void far DtrOff(void)
*
*.Params        ᯮ
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far DtrOff(void);


/**
*.Name         DtrOn
*
*.Title        ⠭ ᨣ DTR
*
*.Proto        void far DtrOn(void)
*
*.Params        ᯮ
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far DtrOn(void);


/**
*.Name         RCount
*
*.Title        ।塞 ﭨ  ਥ
*
*.Proto        long far RCount(void)
*
*.Params        ᯮ
*
*.Return        襬  ᫮ ⮢   ਥ,
*                襬 騩 ࠧ  ਥ
*
*
*.Sample       comm.asm
**/
long far RCount(void);

// ம। r_count_size 頥
// 騩 ࠧ  ਥ

#define RCountSize() ((int)(RCount() >> 16))

// ம। r_count_pending 頥
// ᫮ ⮢   ਥ

#define RCountPending() ((int)RCount())


/**
*.Name         ReceiveCom
*
*.Title          ᨬ   ਥ
*
*.Proto        int far ReceiveCom(void)
*
*.Params        ᯮ
*
*.Return       । ᨬ   ਥ
*
*.Sample       comm.asm
**/
int far ReceiveCom(void);


/**
*.Name         SCount
*
*.Title        ।塞 ﭨ  ਥ
*
*.Proto        long far SCount(void)
*
*.Params        ᯮ
*
*.Return        襬  ᫮ ᢮ ⮢   ।稪,
*                襬 騩 ࠧ  ।稪
*
*
*.Sample       comm.asm
**/
long far SCount(void);

// ம। s_count_size 頥
// 騩 ࠧ  ਥ

#define SCountSize() ((int)(SCount() >> 16))

// ம। s_count_pending 頥
// ᫮ ⮢   ਥ

#define SCountFree() ((int)SCount())


/**
*.Name         SendCom
*
*.Title        ।  ᨬ   ।稪
*
*.Proto        void far SendCom(int ch)
*
*.Params       int ch - । ᨬ
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far SendCom(int);


/**
*.Name         BreakCom
*
*.Title        । ᨣ "BREAK" 㤠 
*
*.Proto        void far BreakCom(void)
*
*.Params        ᯮ
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
void far BreakCom(void);

/**
*.Name         ComErrors
*
*.Title        頥 㪠⥫쭠 ᨢ 稪 訡
*
*.Proto        int far *far ComErrors(void)
*
*.Params        ᯮ
*
*.Return        ᯮ
*
*.Sample       comm.asm
**/
int far *far ComErrors(void);


#define COM_EOVFLOW 0   // ९ 
#define COM_EOVRUN  1   // 訡 ९  ਥ
#define COM_EBREAK  2   // 㦥   뢠
#define COM_EFRAME  3   // 訡 ᨭ஭樨
#define COM_EPARITY 4   // 訡 ⭮
#define COM_EXMIT   5   // 訡  ।
#define COM_EDSR    6   //  祭 ᨣ dsr
#define COM_ECTS    7   //  祭 ᨣ cts
