// (C)  .., 1995
//  E-mail: frolov@glas.apc.org

#include	<windows.h>
#include	<string.h>
#include	<conio.h>
#include	<stdio.h>

//  
#define	QUEUE_SIZE	1024
#define	CTRL_Q		17
#define	CTRL_S		19
#define	ESC			27 

//  
int InitCommPort(void);
int CloseCommPort(int idCommPort);
int ProcessExchange(int idCommPort);

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain( HANDLE hInstance,
			HANDLE hPrevInstance,
			LPSTR lpszCmdLine,
			int cmdShow )
{
	int	idCommPort;				//  COM-


	//       
	if( hPrevInstance )
		return( FALSE );

	//   EasyWin
	_InitEasyWin();

	//  COM-     
	idCommPort = InitCommPort();

	//       COM-
	//   
	if(idCommPort < 0)
		return FALSE;

	puts( "     <ESC>" );

	while( TRUE )
	{
		MSG    msg;

		//    
		if( PeekMessage( ( LPMSG )&msg, NULL, 0, 0, PM_REMOVE ) )
		{
			//    WM_QUIT  
			if ( msg.message == WM_QUIT )
				return( msg.wParam );

			TranslateMessage( &msg );
			DispatchMessage ( &msg );
		}

		//      ,  
		//   COM-
		else
      {
			if( !ProcessExchange( idCommPort ))
			{
				//   WM_DESTROY   
				PostMessage( GetFocus(), WM_DESTROY, 0, 0L  );
			}
      }
	}
}

// =====================================
//  InitCommPort
// =====================================
int InitCommPort()
{
	DCB	dcbCommPort;	//  DCB
	int	idCommPort;		//  COM-

	char	szMsg[144];				//  
	char	szCommSettings[20];	//   COM-
	char	szPortName[6];			//  COM-


	//    [Port]  PHONE.INI  Mode,
	//    COM-     
	// szCommSettings

	GetPrivateProfileString("Port", "Mode", "COM1:9600,n,8,1",
			szCommSettings, sizeof(szCommSettings) - 1, "easytty.ini");


	//       , 
	//  COM-      OpenComm
	lstrcpyn(szPortName, szCommSettings, 5);
	szPortName[4] = '\0';


	//  COM- szPortName
	if (( idCommPort = OpenComm( szPortName, QUEUE_SIZE, QUEUE_SIZE )) < 0 )
	{
		//         
		wsprintf( szMsg,
			"  .\n OpenComm  %d",
			idCommPort );

		MessageBox( NULL, szMsg,
						"", MB_OK | MB_ICONEXCLAMATION );

		return( idCommPort );
	}

	//      
	FlushComm( idCommPort, 0 );

	//      
	FlushComm( idCommPort, 1 );

	//   DCB     
	// Mode   [Port]  PHONE.INI

	if( BuildCommDCB( szCommSettings, &dcbCommPort ) != 0 )
	{
		//         
		MessageBox( NULL, "    DCB",
						"", MB_OK | MB_ICONEXCLAMATION );
		return( -1 );
	}

	//    COM-   
	//   DCB
	if ( SetCommState( &dcbCommPort ) != 0 )
	{
		//         
		MessageBox( NULL, "   COM-",
						"", MB_OK | MB_ICONEXCLAMATION );

		return( -1 );
	}

	//    COM-
	return idCommPort;
}

// =====================================
//  ProcessExchange
// =====================================
int ProcessExchange( int idCommPort )
{
	int nCharWaiting, nCharWriting;
	COMSTAT	ComStat;
	char	inBuff[ QUEUE_SIZE ];

	//     COM-
	GetCommError( idCommPort, &ComStat );

	//          
	//   
	if ((nCharWaiting = ComStat.cbInQue ) > 0 )
	{

		//           inBuff
		nCharWaiting = ReadComm( idCommPort, inBuff,
							( nCharWaiting > QUEUE_SIZE ? QUEUE_SIZE : nCharWaiting ));

		//     
		if ( nCharWaiting > 0 )
			for( int i = 0; i < nCharWaiting; i++ )	putch(inBuff[i]);

		else
			return( FALSE );
	}

	// ,   -   
	else if ( kbhit() )
	{
		//   ,   
		char keyHit  = ( char )getch();

		if ( !keyHit )
			keyHit = ( char )getch();

		//    <Esc>  COM-  
		//  
		if ( keyHit == ESC )
		{
			CloseCommPort( idCommPort );
			return( FALSE );
		}

		//        COM-
		else
		{
			nCharWriting = WriteComm( idCommPort, ( LPSTR )&keyHit, 1 );

			//     
			if( nCharWriting < 0 )
				return( FALSE );
		}
	}
	return( TRUE );
}

// =====================================
//  CloseCommPort
// =====================================
int CloseCommPort( int idCommPort )
{
	//         COM-
	FlushComm( idCommPort, 0 );
	FlushComm( idCommPort, 1 );

	//  COM-
	CloseComm( idCommPort );

	return 0;
}

