// (C)  .., 1995
//  E-mail: frolov@glas.apc.org

// ----------------------------------------
//      
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <commdlg.h>
#include <mem.h>
#include <string.h>
#include <stdlib.h>

//   
#define ID_EDIT    1

//  
#define ID_NEW     2
#define ID_OPEN    3
#define ID_SAVE    4
#define ID_PRINT   5
#define ID_EXIT    6

//  
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);
HFILE OpenFile(void);
HFILE OpenSaveFile(void);
int PrintFile(HWND, NPSTR, WORD);

//   
char const szClassName[]   = "TEditAppClass";

//  
char const szWindowTitle[] = "Text Editor";

//   
HINSTANCE hInst;

//    
BOOL bUpdate;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  //  
  if(!InitApp(hInstance))
      return FALSE;

  //    
  //   
  hInst = hInstance;

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,   
    CW_USEDEFAULT,       // 
    CW_USEDEFAULT,       // 
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 
  //     ,  
  if(!hwnd)
    return FALSE;

  //   
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  //    
  while(GetMessage(&msg, 0, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  //   
  static HWND hEdit;

  //  
  static HWND hButtNew;
  static HWND hButtOpen;
  static HWND hButtSave;
  static HWND hButtPrint;
  static HWND hButtExit;

  //  
  static HFILE hfSrcFile, hfDstFile;

  switch (msg)
  {
    case WM_CREATE:
    {
      //   
      hEdit = CreateWindow("edit", NULL,
	 WS_CHILD | WS_VISIBLE | WS_BORDER |
         WS_HSCROLL | WS_VSCROLL |
	 ES_LEFT | ES_AUTOHSCROLL | ES_AUTOVSCROLL |
	 ES_MULTILINE,
	 0, 0, 0, 0,
	 hwnd, (HMENU) ID_EDIT, hInst, NULL);

      //   
      //  ,  32000 
      SendMessage(hEdit, EM_LIMITTEXT, 32000, 0L);

      //    
      bUpdate = FALSE;

      //  
      hButtNew = CreateWindow("button", "New",
         WS_CHILD | WS_VISIBLE |
	 BS_PUSHBUTTON,
	 0, 0, 80, 20,
	 hwnd, (HMENU) ID_NEW, hInst, NULL);

      hButtOpen = CreateWindow("button", "Open",
         WS_CHILD | WS_VISIBLE |
	 BS_PUSHBUTTON,
	 80, 0, 80, 20,
	 hwnd, (HMENU) ID_OPEN, hInst, NULL);

      hButtSave = CreateWindow("button", "Save",
         WS_CHILD | WS_VISIBLE |
	 BS_PUSHBUTTON,
	 160, 0, 80, 20,
	 hwnd, (HMENU) ID_SAVE, hInst, NULL);

      hButtPrint = CreateWindow("button", "Print",
         WS_CHILD | WS_VISIBLE |
	 BS_PUSHBUTTON,
	 240, 0, 80, 20,
	 hwnd, (HMENU) ID_PRINT, hInst, NULL);

      hButtExit = CreateWindow("button", "Exit",
         WS_CHILD | WS_VISIBLE |
	 BS_PUSHBUTTON,
	 320, 0, 80, 20,
	 hwnd, (HMENU) ID_EXIT, hInst, NULL);

      return 0;
    }

    case WM_SIZE:
    {
      //    
      // ( )  
      //     
      MoveWindow(hEdit, 0, 20, LOWORD(lParam),
	HIWORD(lParam) - 20, TRUE);
      return 0;
    }

    //     
    //  ,    
    case WM_SETFOCUS:
    {
      SetFocus(hEdit);
      return 0;
    }

    case WM_COMMAND:
    {
      //    
      if(wParam == ID_EDIT)
      {
        // 
	if(HIWORD(lParam) == EN_ERRSPACE)
	{
	   MessageBox(hwnd, " ",
	     szWindowTitle, MB_OK);
	}

	//    
        // 
	else if(HIWORD(lParam) == EN_UPDATE)
	{
           //    
           bUpdate = TRUE;
	}
	return 0;
      }

      //    
      else if(wParam == ID_SAVE)
      {
	WORD wSize;
	HANDLE hTxtBuf;
        NPSTR  npTextBuffer;

        //   
	hfDstFile = OpenSaveFile();
	if(!hfDstFile) return 0;

	//   
	wSize = GetWindowTextLength(hEdit);

	//    ,
        //     
	hTxtBuf = (HANDLE) SendMessage(hEdit, EM_GETHANDLE, 0, 0L);

	//      
        //  
	npTextBuffer = (NPSTR)LocalLock(hTxtBuf);

        //      
	if(wSize != _lwrite(hfDstFile, npTextBuffer, wSize))
	{
          //       
	  _lclose(hfDstFile);
	  MessageBox(hwnd, "   ",
	     szWindowTitle, MB_OK);
	  return 0;
	}

        //  
        _lclose(hfDstFile);

        //   
	LocalUnlock(hTxtBuf);

	//       ,
	//    
        bUpdate = FALSE;

        SetFocus(hEdit);
        return 0;
      }

      //   
      else if(wParam == ID_NEW)
      {
        //   
	if(bUpdate)
	{
	  if(IDYES == MessageBox(hwnd,
	   "  .  ?",
	   szWindowTitle, MB_YESNO | MB_ICONQUESTION))
	     return 0;
        }

        //    
	SetWindowText(hEdit, "\0");

	//   
	bUpdate = FALSE;

        SetFocus(hEdit);
	return 0;
      }

      //    
      else if(wParam == ID_OPEN)
      {
	LPSTR lpTextBuffer;
	DWORD dwFileSize, dwCurrentPos;

        //   
	if(bUpdate)
	{
	  if(IDYES == MessageBox(hwnd,
	   "  .  ?",
	   szWindowTitle, MB_YESNO | MB_ICONQUESTION))
	     return 0;
        }

	//   .
	hfSrcFile = OpenFile();
	if(!hfSrcFile) return 0;

        //   
	dwCurrentPos = _llseek(hfSrcFile, 0L, 1);
	dwFileSize   = _llseek(hfSrcFile, 0L, 2);
	_llseek(hfSrcFile, dwCurrentPos, 0);

        //      32000 
	if(dwFileSize >= 32000)
	{
	  _lclose(hfSrcFile);
	  MessageBox(hwnd, "   32000 ",
	     szWindowTitle, MB_OK);
	  return 0;
	}

        //     
        lpTextBuffer = (LPSTR)malloc(32000);
        if(lpTextBuffer == NULL)
           return 0;

        //      
	_lread(hfSrcFile, lpTextBuffer, dwFileSize);

        //    
        lpTextBuffer[(WORD)dwFileSize] = '\0';

        //  
	_lclose(hfSrcFile);

	//    
        //  
        SetWindowText(hEdit, lpTextBuffer);

        //  
        free((void *)lpTextBuffer);

        //   
	bUpdate = FALSE;

        SetFocus(hEdit);
        return 0;
      }

      else if(wParam == ID_PRINT)
      {
	WORD wSize;
	HANDLE hTxtBuf;
        NPSTR  npTextBuffer;

	//   
	wSize = GetWindowTextLength(hEdit);

	//    ,
        //     
	hTxtBuf = (HANDLE) SendMessage(hEdit, EM_GETHANDLE, 0, 0L);

	//      
        //  
	npTextBuffer = (NPSTR)LocalLock(hTxtBuf);

        PrintFile(hwnd, npTextBuffer, wSize);

        //   
	LocalUnlock(hTxtBuf);

        SetFocus(hEdit);
        return 0;
      }

      else if(wParam == ID_EXIT)
      {
	//   
	if(bUpdate)
	{
	  if(IDYES == MessageBox(hwnd,
	   "  .  ?",
	   szWindowTitle, MB_YESNO | MB_ICONQUESTION))
	     return 0;
        }

	//     
        //  WM_CLOSE
	SendMessage(hwnd, WM_CLOSE, 0, 0L);
        return 0;
      }
      return 0;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}



// -------------------------------
//  OpenFile
//  
// -------------------------------

HFILE OpenFile(void)
{
  //    
  OPENFILENAME ofn;

  //       
  char szFile[256];

  //      
  char szFileTitle[256];

  //    
  char szFilter[256] =
	 "Text Files\0*.txt;*.doc\0Any Files\0*.*\0";

  //   
  HFILE hf;

  //    
  //  ,    
  szFile[0] = '\0';

  //      
  // ,    
  //  
  memset(&ofn, 0, sizeof(OPENFILENAME));

  //    

  //  
  ofn.lStructSize       = sizeof(OPENFILENAME);

  //  
  ofn.hwndOwner         = NULL;

  //   
  ofn.lpstrFilter       = szFilter;

  //   
  ofn.nFilterIndex      = 1;

  //     
  //  
  ofn.lpstrFile         = szFile;

  //     
  //  
  ofn.nMaxFile          = sizeof(szFile);

  //     
  //  
  ofn.lpstrFileTitle    = szFileTitle;

  //     
  //  
  ofn.nMaxFileTitle     = sizeof(szFileTitle);

  //     
  //    
  ofn.lpstrInitialDir   = NULL;

  //    
  ofn.Flags =   OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST
				  | OFN_HIDEREADONLY;
  //   
  if (GetOpenFileName(&ofn)) {

    //   
    hf = _lopen(ofn.lpstrFile, OF_READ);

    //   
    return hf;
  }
  //     
  //  
  else return 0;
}

// -------------------------------
//  OpenSaveFile
//    
// -------------------------------

HFILE OpenSaveFile(void)
{
  OPENFILENAME ofn;

  char szFile[256];
  char szFileTitle[256];
  char szFilter[256] =
	 "Text Files\0*.txt\0Any Files\0*.*\0";

  HFILE hf;

  szFile[0] = '\0';

  memset(&ofn, 0, sizeof(OPENFILENAME));

  ofn.lStructSize       = sizeof(OPENFILENAME);
  ofn.hwndOwner         = NULL;
  ofn.lpstrFilter       = szFilter;
  ofn.nFilterIndex      = 1;
  ofn.lpstrFile         = szFile;
  ofn.nMaxFile          = sizeof(szFile);
  ofn.lpstrFileTitle    = szFileTitle;
  ofn.nMaxFileTitle     = sizeof(szFileTitle);
  ofn.lpstrInitialDir   = NULL;
  ofn.Flags             = OFN_HIDEREADONLY;

  //   
  if (GetSaveFileName(&ofn)) {

    //    
    hf = _lcreat(ofn.lpstrFile, 0);
    return hf;
  }
  else return 0;
}
