// (C)  .., 1995
//  E-mail: frolov@glas.apc.org

#define 	STRICT

#include	<windows.h>
#include <string.h>
#include <stdlib.h>
#include	<mem.h>
#include	<bwcc.h>
#include	"phone.h"


//  

HINSTANCE	hInst;			//  
int			idComDev;		//  COM-
char			sBufNum[20];	//    
BOOL			WaitFlag = FALSE;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine,
	int       nCmdShow)
{
	static DLGPROC lpfnDlgProc;

	hInst = hInstance;

	//     
	lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, hInst);

	//    
	DialogBox( hInstance, "PHONE", NULL, lpfnDlgProc );

	return 0;
}


// =====================================
//  DldProc
// =====================================

#pragma argsused

BOOL CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int	iErr;

	switch(msg)
	{
		//   
		case WM_INITDIALOG:
		{
			//   WM_CONNECT
			PostMessage( hdlg,WM_CONNECT,0,0L );
			return TRUE;
		}

		case WM_CONNECT:
		{
			EnableWindow(GetDlgItem(hdlg, IDCANCEL), FALSE);

			//  COM-   
			iErr = InitLine();

			EnableWindow(GetDlgItem(hdlg, IDCANCEL), TRUE);

			//     
			//    
			if( iErr < 0 )
			{
				ShowError( iErr );
				EndDialog( hdlg, 0 );
			}
			return TRUE;
		}

		case WM_COMMAND:
		{
			switch(wParam)
			{
				//   
				case	ID_1: case	ID_2: case	ID_3: case	ID_4: case	ID_5:
				case	ID_6:	case	ID_7: case	ID_8: case	ID_9: case	ID_0:
				{
					int	iNum;
					char	sTmp[10];

					//   
					iNum = wParam - ID_0;

					wsprintf( sTmp, "%d", iNum );

					//     
					lstrcat(sBufNum, sTmp);

					//    
					SetDlgItemText(hdlg, ID_NUMBER, sBufNum);

					return TRUE;
				}

				//   ""
				case ID_CLEAR:
				{
					EnableWindow(GetDlgItem(hdlg, IDCANCEL), FALSE);

					//  
					HangUpPhone();

					EnableWindow(GetDlgItem(hdlg, IDCANCEL), TRUE);

					return TRUE;
				}

				//    
				case ID_BACK:
				{
					if( lstrlen( sBufNum ) != 0 )
					{
						sBufNum[lstrlen( sBufNum ) - 1] = '\0';
						SetDlgItemText( hdlg, ID_NUMBER, sBufNum );
					}
					else MessageBeep( MB_ICONASTERISK );

					return TRUE;
				}

				//   ""
				case ID_DIAL:
				{
					EnableWindow(GetDlgItem(hdlg, IDCANCEL), FALSE);

					//  
					iErr = DialPhone();

					//     
					if( iErr < 0 )
						ShowError( iErr );

					EnableWindow(GetDlgItem(hdlg, IDCANCEL), TRUE);
					return TRUE;
				}

				//   ""
				case IDCANCEL:
				{
					//  COM-
					CloseLine();

					//   
					EndDialog( hdlg, 0 );

					return TRUE;
				}
			}
		}
	}
	return FALSE;
}

// =====================================
//  InitLine
// =====================================
int	InitLine()
{
	BYTE	bSet;
	DCB	dcb;
	int	iErr;
	char	sTmp[200];
	char	szModemAnswer[200];

	char	szInitMode[80];
	char	szTmpStrBool[3];
	char	szInitModem[100];
	long	lnModemTimeout;

	//    COM-,   
	//  Mode   Port  phone.ini
	GetPrivateProfileString( "Port", "Mode", "COM1:9600,n,8,1",
									 szInitMode, sizeof(szInitMode),
									 "phone.ini" );

	//  COM-,    szInitMode
	wsprintf( sTmp, "COM%c", szInitMode[3] );

	idComDev = OpenComm( sTmp, 4915, 4915 );
	if (idComDev < 0)
		return ERR_NO_OPEN;

	//   DCB    szInitMode
	iErr = BuildCommDCB( szInitMode, &dcb );
	if(iErr < 0)
		return ERR_DCB_BUILD;

	//     DCB 
	//	   phone.ini

	//   fOutxDsrFlow, fDtrflow, DsrTimeout
	GetPrivateProfileString( "Port", "DsrDtrFlow", "1",
									 szTmpStrBool, sizeof(szTmpStrBool),
									 "phone.ini" );
	
	dcb.fOutxDsrFlow = dcb.fDtrflow = bSet =
									(BYTE) atoi(szTmpStrBool);

	dcb.DsrTimeout = (bSet) ? 3 : 0 ;

	//   fOutxCtsFlow, fRtsflow, CtsTimeout
	GetPrivateProfileString( "Port", "CtsRtsFlow", "1",
									 szTmpStrBool, sizeof(szTmpStrBool),
									 "phone.ini" );

	dcb.fOutxCtsFlow = dcb.fRtsflow = bSet =
									(BYTE) atoi(szTmpStrBool);

	dcb.CtsTimeout = (bSet) ? 3 : 0 ;

	//   fBinary
	GetPrivateProfileString( "Port", "Binary", "1",
									 szTmpStrBool, sizeof(szTmpStrBool),
									 "phone.ini" );
	
	dcb.fBinary = (BOOL) atoi(szTmpStrBool);

	//   fRtsDisable
	GetPrivateProfileString( "Port", "RtsDisable", "0",
									 szTmpStrBool, sizeof(szTmpStrBool),
									 "phone.ini" );

	dcb.fRtsDisable = (BOOL) atoi(szTmpStrBool);


	//   fDtrDisable
	GetPrivateProfileString( "Port", "DtrDisable", "0",
									 szTmpStrBool, sizeof(szTmpStrBool),
									 "phone.ini" );
	
	dcb.fDtrDisable = (BOOL) atoi(szTmpStrBool);

	//     COM-
	iErr = SetCommState( &dcb );
	if( iErr < 0 )
		return ERR_DCB_SET;

	//        COM-
	FlushComm(idComDev, 1);
	FlushComm(idComDev, 0);

	//   DTR
	EscapeCommFunction(idComDev, SETDTR);

	//    ,   
	//  Init   Modem  phone.ini
	GetPrivateProfileString( "Modem", "Init", "ATZ",
									 szInitModem, sizeof(szInitModem),
									 "phone.ini" );

	//      
	wsprintf( sTmp, "%s\r", szInitModem );

	//    
	iErr = WriteComm( idComDev, sTmp, lstrlen( sTmp ) );
	if( iErr < 0 )
		return ERR_WRITE;

	//      
	GetPrivateProfileString( "Modem", "ModemTimeout", "1000",
									 sTmp, sizeof(sTmp),
									 "phone.ini" );

	lnModemTimeout = atol( sTmp );

	//     "OK"
	iErr = WaitModemAnswer(	idComDev, (LPSTR*)szOkString,
									szModemAnswer, 200, (DWORD)lnModemTimeout);
	if( iErr < 0 )
		return iErr;

	return 0;
}

// =====================================
// 
// =====================================

int	DialPhone()
{
	int	iErr;
	char	sTmp[80];
	char	szModemAnswer[200];
	char	szDialModem[80];
	long	lnModemTimeout;


	//    ,   
	//  Dial   Modem  phone.ini
	GetPrivateProfileString( "Modem", "Dial", "ATDP",
									 szDialModem, sizeof(szDialModem),
									 "phone.ini" );

	//     sTmp   
	wsprintf( sTmp, "%s%s\r", szDialModem, sBufNum );

	//        COM-
	FlushComm(idComDev, 1);
	FlushComm(idComDev, 0);

	//     
	iErr = WriteComm(idComDev, sTmp, lstrlen(sTmp) );
	if( iErr < 0 )
		return ERR_WRITE;

	//      
	GetPrivateProfileString( "Modem", "DialTimeout", "30000",
									 sTmp, sizeof(sTmp),
									 "phone.ini" );

	lnModemTimeout = atol( sTmp );

	//    
	iErr = WaitModemAnswer(	idComDev, (LPSTR*)szAnswer,
								szModemAnswer, 200, (DWORD)lnModemTimeout);

	BWCCMessageBox(NULL, szModemAnswer, " ", MB_OK );

	return iErr;
}

// =====================================
//  CloseLine
// =====================================

int	CloseLine()
{
	//   DTR
	EscapeCommFunction(idComDev, CLRDTR);

	//        COM-
	FlushComm(idComDev, 1);
	FlushComm(idComDev, 0);

	//  COM-
	CloseComm(idComDev);

	return 0;
}


// ===================================================================
//  HangUp
// ===================================================================

int	HangUpPhone()
{
	DWORD	StartTick;
	char	szHangUpString[80], sTmp[80];
	long	lnModemTimeout;

	//       "+++"
	GetPrivateProfileString( "Modem", "HangUpTimeout", "2000",
									 sTmp, sizeof(sTmp),
									 "phone.ini" );

	lnModemTimeout = atol( sTmp );


	//    ,   
	//  Dial   Modem  phone.ini
	GetPrivateProfileString( "Modem", "HangUp", "ATH0",
									 szHangUpString, sizeof(szHangUpString),
									 "phone.ini" );

	//     sTmp   
	wsprintf( sTmp, "%s\r", szHangUpString );

	//    
	StartTick = GetTickCount();

	//  
	while( StartTick + (DWORD)lnModemTimeout > GetTickCount() ) Idle();

	//    "+++"   
	//   
	WriteComm( idComDev, "+++", 3);

	//    
	StartTick = GetTickCount();

	//  
	while( StartTick + (DWORD)lnModemTimeout > GetTickCount() ) Idle();

	//        
	WriteComm( idComDev, sTmp, lstrlen( sTmp ) );

	EscapeCommFunction(idComDev, CLRDTR);

	return 0;
}

// =====================================
//  ShowError
// =====================================

void	ShowError( int iErr )
{
	int	iNum;
	char	szMsgBuff[40];


	//     
	if(( iErr < -6 ) || ( iErr >= 0 ))
		return;

	//     
	//   iErr
	LoadString( hInst, iErr, szMsgBuff, 40 );

	//      
	BWCCMessageBox( NULL, szMsgBuff, "",
						 MB_OK | MB_ICONSTOP	);

	//   
	MessageBeep( MB_ICONASTERISK );

	return;
}

// ===================================================================
//  ReadComPort
// ===================================================================

int ReadComPort(int idComDev, LPSTR szDest, int nLength)
{

	COMSTAT ComStat;
	int nTotalRead = 0, nRead = 0;

	while(nLength > nTotalRead)
	{
		//   COM-
		GetCommError(idComDev,&ComStat);

		//        
		if (ComStat.cbInQue == 0)
			break;

		//     szDest
		else
			nRead = ReadComm(idComDev,&(szDest[nTotalRead]),
													nLength - nTotalRead);
		//   ReadComm     -1

		if (nRead < 0)
			return -1;

		nTotalRead += nRead;
	}

	//     COM- 
	return nTotalRead;
}


// ===================================================================
//  WaitModemAnswer
// ===================================================================
int WaitModemAnswer(int idComDev, LPSTR *szWaitDest,
						  LPSTR szModemAnswer, int nLength,
						  DWORD dwTimeOut)
{
	int	nRead;
	int	nTotalChar = 0, i;
	DWORD	dwStartTick;
	BOOL	fFind = FALSE;

   //    
	dwStartTick = GetTickCount();

	do
	{
		//    COM-
		nRead = ReadComPort(idComDev, &szModemAnswer[nTotalChar],
								  nLength - lstrlen(szModemAnswer));

		//     ERR_READ
		if(nRead < 0)
			return ERR_READ;

		else if(nRead > 0)
		{
			nTotalChar += nRead;

			//       
			szModemAnswer[nTotalChar] = '\0';

			//         szWaitDest
			for(int i = 0; szWaitDest[i]; i++)
			{
				if(strstr(szModemAnswer, szWaitDest[i]))
				{
					//   ,   
					//   
					fFind = TRUE;
					break;
				}
			}
		}

		//      
		else
			Idle();

	//         ,
	//         
	//  (nTimeOut * 1000)

	} while (!fFind && nRead >= 0 &&
				dwStartTick + dwTimeOut > GetTickCount() );

	if(nRead >= 0 && !fFind)
		return ERR_TIMEOUT;

	//    
	return lstrlen( szModemAnswer );
}

// ===================================================================
//  Idle
// ===================================================================
void	Idle(void)
{
	MSG msg;

	while( PeekMessage( &msg, NULL, NULL, NULL, PM_REMOVE ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

   return;
}