// (C)  .., 1995
//  E-mail: frolov@glas.apc.org

#include <windows.h>
#include "tele.h"

// ===================================================================
//  InitComPort
// ===================================================================
int InitCommPort(HWND hwnd)
{
	DCB	dcb;					//  DCB
	int	idCommPort;			//  COM-

	char	szPort[6];			//  
	char	szInitMode[40];	//  

	int	nResult;				//  

	//    COM-,   
	//  Mode   Port  phone.ini
	GetPrivateProfileString("Port", "Mode", "COM2:2400,n,8,1",
									szInitMode, sizeof(szInitMode), "teletype.ini");

	//  COM-,    szInitMode
	wsprintf( szPort, "COM%c", szInitMode[3] );

	idCommPort = OpenComm(szPort, INQUEUE, OUTQUEUE);
	if (idCommPort < 0)
		return idCommPort;

	//   DCB    szInitMode
	nResult = BuildCommDCB(szInitMode,&dcb);
	if (nResult < 0)
		return nResult;

	//     COM-
	nResult = SetCommState(&dcb);
	if (nResult < 0)
		return nResult;

	//        COM-
	FlushComm(idCommPort, 1);
	FlushComm(idCommPort, 0);

	//    WM_COMMNOTIFY
	if(!EnableCommNotification(idCommPort,hwnd,32,-1))
		return -1;

	//   DTR
	EscapeCommFunction(idCommPort, SETDTR);

	return idCommPort;
}

// ===================================================================
//  CloseComPort
// ===================================================================
int CloseCommPort(int idCommPort)
{
	//   DTR
	EscapeCommFunction(idCommPort, CLRDTR);

   //  COM-
	CloseComm(idCommPort);

	return 0;
}


// ===================================================================
//  ReadComPort
// ===================================================================
int ReadCommPort(int idComDev, LPSTR szDest, int nLength)
{

	COMSTAT ComStat;
	int nTotalRead = 0, nRead = 0;

	//       COM-
	while(nLength > nTotalRead)
	{
   	//       
		GetCommError(idComDev,&ComStat);

		if (ComStat.cbInQue == 0)
			break;

		//      COM-
		nRead = ReadComm(idComDev,&(szDest[nTotalRead]),
													nLength - nTotalRead);
		//   
		if(nRead < 0)
		{
			nTotalRead = -nTotalRead - nRead;
			break;
		}

		nTotalRead += nRead;
	}

	return nTotalRead;
}

