// -----------------------------------------------------
//      DDEML
//  DDEML
// -----------------------------------------------------
#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <ddeml.h>
#include <dde.h>
#include <mem.h>
#include <string.h>
#pragma hdrstop

#include "ddemlsr.hpp"

HDDEDATA EXPENTRY _export
DDEServerCallback(WORD wType, WORD wFmt,
  HCONV hConv, HSZ hsz1, HSZ hsz2,
  HDDEDATA hData, DWORD dwData1, DWORD dwData2 );

//  ,    
//  DDEML
DWORD idInst = 0L;

FARPROC lpDdeProc;
HSZ hszService = NULL;
HSZ hszTopic   = NULL;
HSZ hszItem    = NULL;

//  
HCONV hConvApp = NULL;

//    
char szDDEData[200];

//  .   
//     
char szDDEServerVersion[] =
  "DDEML Server v.1.0, (C) Frolov A.V.";

//-----------------------------------------------------
//  DDEServerOpen
//   DDEML
//-----------------------------------------------------
BOOL DDEServerOpen(HINSTANCE hInst,
  LPSTR szService, LPSTR szTopic, LPSTR szItem)
{
  int rc;

  //      
  lpDdeProc =
    MakeProcInstance((FARPROC)DDEServerCallback, hInst);

  //  
  if(DdeInitialize((LPDWORD)&idInst, (PFNCALLBACK)lpDdeProc,
       APPCLASS_STANDARD, 0L))
  {
    return FALSE;
  }

  //     
  //   ,    
  else
  {
    hszService =
      DdeCreateStringHandle(idInst, szService, CP_WINANSI);
    hszTopic   =
      DdeCreateStringHandle(idInst, szTopic, CP_WINANSI);
    hszItem    =
      DdeCreateStringHandle(idInst, szItem, CP_WINANSI);

    //  
    DdeNameService(idInst, hszService, (HSZ)NULL, DNS_REGISTER);
    return TRUE;
  }
}

//-----------------------------------------------------
//  DDEServerClose
//    DDEML
//-----------------------------------------------------
void DDEServerClose(void)
{
  //    
  if(hConvApp != NULL)
  {
    DdeDisconnect(hConvApp);
    hConvApp = NULL;
  }

  //    
  DdeNameService(idInst, hszService, (HSZ)NULL,
    DNS_UNREGISTER);

  //   
  DdeFreeStringHandle(idInst, hszService);
  DdeFreeStringHandle(idInst, hszTopic);
  DdeFreeStringHandle(idInst, hszItem);

  //     
  FreeProcInstance(lpDdeProc);
}

//-----------------------------------------------------
//  DDEServerCallback
//      DDEML
//-----------------------------------------------------
#pragma argsused
HDDEDATA EXPENTRY _export
DDEServerCallback(WORD wType,
  WORD wFmt, HCONV hConv, HSZ hsz1, HSZ hsz2,
  HDDEDATA hData, DWORD dwData1, DWORD dwData2)
{
   switch(wType)
   {
      //    
      case XTYP_CONNECT:
      {
        //   , 
        //    
        if((HSZ)hsz2==(HSZ)hszService)
           return((HDDEDATA)TRUE);
        else
          return((HDDEDATA)FALSE);
      }

      //    
      case XTYP_REQUEST:
      {
        //   
        hData = DdeCreateDataHandle(idInst,
          szDDEServerVersion, lstrlen(szDDEServerVersion) + 1,
          0L, hszItem, CF_TEXT, 0);

        //      
        if(hData != NULL)
          return(hData);
        else
          return(NULL);
      }

      //    ,  
      case XTYP_EXECUTE:
         break;

      //   
      case XTYP_POKE:
      {
        //   
        if(hsz1 == hszTopic)
        {
          //  
          DdeGetData(hData, (LPBYTE) szDDEData, 200L, 0L);

          //     
          if(szDDEData != NULL)
          {
            MessageBox(NULL, szDDEData,
              "DDEML Server",
              MB_OK | MB_SYSTEMMODAL | MB_ICONINFORMATION);

            //    
            return((HDDEDATA)DDE_FACK);
          }
        }
        else
          return((HDDEDATA)NULL);
        break;
      }

      //   
      case XTYP_CONNECT_CONFIRM:
      {
        //    
        hConvApp = hConv;
        break;
      }

      //   
      case XTYP_DISCONNECT:
      {
        hConvApp = NULL;
        break;
      }

      // 
      case XTYP_ERROR:
      {
        break;
      }
   }
   return((HDDEDATA)NULL);
}
