// ----------------------------------------
//  DDEMLSR
//  DDEML
// ----------------------------------------
#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <mem.h>
#pragma hdrstop

#include "ddemlsr.hpp"

//  
BOOL DDEServerOpen(HINSTANCE hInst, LPSTR szService, LPSTR szTopic, LPSTR szItem);
void DDEServerClose(void);
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

//   
char const szClassName[]   = "DDEMLSERVER";

//  
char const szWindowTitle[] = "DDEML Server";

HWND hwnd;
HINSTANCE hInst;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpszCmdLine, int nCmdShow)
{
  MSG  msg;

  //      
  if(hPrevInstance)
    return FALSE;

  //  
  if(!InitApp(hInstance))
    return FALSE;

  //   
  hInst = hInstance;

  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_CAPTION | WS_BORDER |
    WS_MINIMIZEBOX | WS_OVERLAPPED | WS_SYSMENU,
    0, 0, 200, 100,
    0, 0, hInstance, NULL);      
                       
  //     ,  
  if(!hwnd)
    return FALSE;

  //      
  // ,   
  //   
  ShowWindow(hwnd, SW_SHOWNORMAL);

  while(GetMessage(&msg, 0, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   

  memset(&wc, 0, sizeof(wc));
  wc.lpszMenuName  = "APP_MENU";
  wc.style         = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc   = (WNDPROC) WndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon         = LoadIcon(hInstance, "APP_ICON");
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
  wc.lpszClassName = (LPSTR)szClassName;
  aWndClass = RegisterClass(&wc);
  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  HDC hdc;
  PAINTSTRUCT ps;

  switch (msg)
  {
    case WM_CREATE:
    {
      //  DDEML
      DDEServerOpen(hInst,
        (LPSTR)"BMPServer",
        (LPSTR)"BMPFile",
        (LPSTR)"DDEData");
      return 0;
    }

    //    
    case WM_COMMAND:
    {
      switch (wParam)
      {
        case CM_HELPABOUT:
        {
          MessageBox(hwnd,
            "DDEML Server\nVersion 1.0\n"
            "(C) Frolov A.V., 1995",
            "About DDEML Server", MB_OK | MB_ICONINFORMATION);
          return 0;
        }

        //   
        case CM_FILEEXIT:
        {
          DestroyWindow(hwnd);
          return 0;
        }
        default:
          return 0;
      }
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);

      //    DDEML
      DDEServerClose();
      return 0;
    }
    default:
      break;
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}
