#include <windows.h>
#include <windowsx.h>
#include "resource.h"

// -----------------------------------------------------
//  
// -----------------------------------------------------

//   
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

//     WM_CREATE
BOOL WndProc_OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct);

//     WM_LBUTTONDOWN
void WndProc_OnLButtonDown(HWND hWnd, BOOL fDoubleClick, 
  int x, int y, UINT keyFlags);

//     WM_DESTROY
void WndProc_OnDestroy(HWND hWnd);

// -----------------------------------------------------
//  
// -----------------------------------------------------

//  
HINSTANCE hInst;

//  
char szAppName[] = "Window";

//    
char szAppTitle[] = "Window Application";

// -----------------------------------------------------
//  WinMain
// -----------------------------------------------------
int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;
  
  hInst = hInstance;

  // ,       
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
  	//       ,
	//  
    if(IsIconic(hWnd))
	  ShowWindow(hWnd, SW_RESTORE);

	//      
	SetForegroundWindow(hWnd);
    return FALSE;
  }

  //   
  memset(&wc, 0, sizeof(wc));
  
  //  wc.cbSize	 wc.hIconSm   
  // WNDCLASSEX,    
  //     Windows 95
  wc.cbSize = sizeof(WNDCLASSEX);

  //  wc.hIconSm   
  // ,     
  //    (   ).
  //      
  //   LoadImage,   
  // LoadIcon     
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON_SM), IMAGE_ICON, 16, 16, 0);
  
  //    WNDCLASSEX
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  
  //      
  //   LoadImage
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 32, 32, 0);
  
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = NULL;
  wc.lpszClassName = szAppName;

  //   RegisterClassEx,  
  //  
  if(!RegisterClassEx(&wc))

    //      
	//  RegisterClass
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  //    
  hWnd = CreateWindow(szAppName, szAppTitle, WS_OVERLAPPEDWINDOW,
   	 CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);

  //  
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  //    
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// -----------------------------------------------------
//  WndProc
// -----------------------------------------------------
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    //   WM_CREATE  ,
	//    WndProc_OnCreate
    HANDLE_MSG(hWnd, WM_CREATE, WndProc_OnCreate);

    //   WM_LBUTTONDOWN  ,
	//    WndProc_OnLButtonDown
    HANDLE_MSG(hWnd, WM_LBUTTONDOWN, WndProc_OnLButtonDown);

    //   WM_DESTROY  ,
	//    WndProc_OnDestroy
    HANDLE_MSG(hWnd, WM_DESTROY, WndProc_OnDestroy);

	default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
//  WndProc_OnCreate
// -----------------------------------------------------
BOOL WndProc_OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct)
{
  return TRUE;
}

// -----------------------------------------------------
//  WndProc_OnDestroy
// -----------------------------------------------------
//     , 
//   void    
//  return.    
//   FORWARD_WM_LBUTTONDOWN
#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  PostQuitMessage(0);
  return FORWARD_WM_DESTROY(hWnd, DefWindowProc);
}

// -----------------------------------------------------
//  WndProc_OnLButtonDown
// -----------------------------------------------------

#pragma warning(disable: 4098)
void 
WndProc_OnLButtonDown(HWND hWnd, BOOL fDoubleClick, 
  int x, int y, UINT keyFlags)
{
  MessageBox(NULL, "Hello, 32-bit world!", "Window", MB_OK);

  return FORWARD_WM_LBUTTONDOWN(hWnd, fDoubleClick, 
           x, y, keyFlags, DefWindowProc);
}
