#include <windows.h>
#include <windowsx.h>
#include <winsock.h>
#include <commctrl.h>
#include "resource.h"

// -----------------------------------------------------
//  
// -----------------------------------------------------

//   
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

//     WM_CREATE
BOOL WndProc_OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct);

//     WM_DESTROY
void WndProc_OnDestroy(HWND hWnd);

//     WM_COMMAND
void WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify);

//     WM_SIZE
void WndProc_OnSize(HWND hWnd, UINT state, int cx, int cy);

//  
void SetConnection(HWND hWnd);

//  
void SendMsg(HWND hWnd);

//  
#define SERV_PORT 5000

#define IDS_STATUSBAR 802

// -----------------------------------------------------
//  
// -----------------------------------------------------

//  
HINSTANCE hInst;

//  
char szAppName[] = "WClientUDP";

//    
char szAppTitle[] = "Windows Socket UDP Client Demo";

//    Statusbar
HWND hwndSb;

//  
SOCKET srv_socket;

//  
SOCKADDR_IN dest_sin;

// -----------------------------------------------------
//  WinMain
// -----------------------------------------------------

int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;

  hInst = hInstance;

  // ,       
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
  	//       ,
	  //  
    if(IsIconic(hWnd))
	  ShowWindow(hWnd, SW_RESTORE);

    //      
	  SetForegroundWindow(hWnd);
    return FALSE;
  }

  //   
  memset(&wc, 0, sizeof(wc));
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON_SM), IMAGE_ICON, 16, 16, 0);
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 32, 32, 0);
  
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
  wc.lpszClassName = szAppName;

  //   RegisterClassEx,  
  //  
  if(!RegisterClassEx(&wc))
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  InitCommonControls();
  
  //    
  hWnd = CreateWindow(szAppName, szAppTitle, WS_OVERLAPPEDWINDOW,
   	 CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);

  //  
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  //    
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// -----------------------------------------------------
//  WndProc
// -----------------------------------------------------

LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hWnd, WM_CREATE, WndProc_OnCreate);
    HANDLE_MSG(hWnd, WM_COMMAND, WndProc_OnCommand);
    HANDLE_MSG(hWnd, WM_SIZE, WndProc_OnSize);
    HANDLE_MSG(hWnd, WM_DESTROY, WndProc_OnDestroy);

	  default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
//  WndProc_OnCreate
// -----------------------------------------------------

BOOL WndProc_OnCreate(HWND hWnd, 
                      LPCREATESTRUCT lpCreateStruct)
{
  int rc;
  WSADATA WSAData;
  char szTemp[128];

  //     Windows Sockets
  rc = WSAStartup(MAKEWORD(1, 1), &WSAData);
  if(rc != 0)
  {
    MessageBox(NULL, "WSAStartup Error", "Error", MB_OK);
    return FALSE;
  }

  //      Windows Sockets
  //     Statusbar
  wsprintf(szTemp, "Server use %s %s", 
    WSAData.szDescription,WSAData.szSystemStatus);

  hwndSb = CreateStatusWindow(WS_CHILD | WS_VISIBLE 
    | WS_BORDER | SBARS_SIZEGRIP, 
    szTemp, hWnd, IDS_STATUSBAR);

  return TRUE;
}

// -----------------------------------------------------
//  WndProc_OnDestroy
// -----------------------------------------------------

#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  //  ,  
  //   Windows Sockets
  WSACleanup();

  //    
  PostQuitMessage(0);
  return FORWARD_WM_DESTROY(hWnd, DefWindowProc);
}

// -----------------------------------------------------
//  WndProc_OnSize
// -----------------------------------------------------

#pragma warning(disable: 4098)
void 
WndProc_OnSize(HWND hWnd, UINT state, int cx, int cy)
{
  SendMessage(hwndSb, WM_SIZE, cx, cy);
  return FORWARD_WM_SIZE(hWnd, state, cx, cy, DefWindowProc);
}

// -----------------------------------------------------
//  WndProc_OnCommand
// -----------------------------------------------------

#pragma warning(disable: 4098)
void 
WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  switch (id)
  {
    case IDM_EXIT:

      //    
      DestroyWindow(hWnd);
      break;

    case IDM_CONNECT:
      
      //    
      SetConnection(hWnd);
      break;

    case IDM_SEND:
      
      //   
      SendMsg(hWnd);
      break;

	default:
      MessageBox(NULL, "Unknown command", "Error", MB_OK);
  }

  return FORWARD_WM_COMMAND(hWnd, id, hwndCtl,
    codeNotify, DefWindowProc);
}

// -----------------------------------------------------
//  SetConnection
// -----------------------------------------------------

void SetConnection(HWND hWnd)
{
  PHOSTENT phe;
	
  //   
  srv_socket = socket(AF_INET, SOCK_DGRAM, 0);
  if(srv_socket == INVALID_SOCKET)
  {
    MessageBox(NULL, "socket Error", "Error", MB_OK);
    return;
  }


  //   IP    
  dest_sin.sin_family = AF_INET;
  dest_sin.sin_addr.s_addr = INADDR_ANY;
  dest_sin.sin_port = 0;
   
  if(bind(srv_socket, (LPSOCKADDR)&dest_sin, 
    sizeof(dest_sin)) == SOCKET_ERROR)
  {
    //    
    closesocket(srv_socket);
    MessageBox(NULL, "bind Error", "Error", MB_OK);
    return;
  }
  
  //   IP   
  dest_sin.sin_family = AF_INET;

  //   

  //     
  phe = gethostbyname("localhost");
  
  //   
  //  phe = gethostbyname("maxsinev");
  
  if(phe == NULL)
  {
    closesocket(srv_socket);
    MessageBox(NULL, "gethostbyname Error", "Error", MB_OK);
    return;
  }

  //   
  memcpy((char FAR *)&(dest_sin.sin_addr), phe->h_addr,
	  phe->h_length);

  //     
  //  dest_sin.sin_addr.s_addr = inet_addr("200.200.200.201");

  //   
  dest_sin.sin_port = htons(SERV_PORT);

  //       
  //   
  SendMessage(hwndSb, SB_SETTEXT, 0, 
    (LPARAM)"Connected");
}

// -----------------------------------------------------
//  SendMsg
// -----------------------------------------------------

void SendMsg(HWND hWnd)
{
	char szBuf[80];
	lstrcpy(szBuf, "Test string");

  //  
  sendto(srv_socket, szBuf, lstrlen(szBuf), 0,
    (PSOCKADDR)&dest_sin, sizeof(dest_sin));

}
