#include <windows.h>
#include <windowsx.h>
#include <winsock.h>
#include <commctrl.h>
#include "resource.h"

// -----------------------------------------------------
//  
// -----------------------------------------------------

//   
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

//     WM_CREATE
BOOL WndProc_OnCreate(HWND hWnd, LPCREATESTRUCT lpCreateStruct);

//     WM_DESTROY
void WndProc_OnDestroy(HWND hWnd);

//     WM_COMMAND
void WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify);

//     WM_SIZE
void WndProc_OnSize(HWND hWnd, UINT state, int cx, int cy);

//  
void ServerStart(HWND hWnd);

//  
void ServerStop(HWND hWnd);

//   WSA_ACCEPT
void WndProc_OnWSAAccept(HWND hWnd, UINT msg, 
                         WPARAM wParam, LPARAM lParam);

//   WSA_NETEVENT
void WndProc_OnWSANetEvent(HWND hWnd, UINT msg, 
                       WPARAM wParam, LPARAM lParam);
//  
#define SERV_PORT 5000

#define IDS_STATUSBAR 802
//    
#define WSA_ACCEPT (WM_USER + 1)
#define WSA_NETEVENT   (WM_USER + 2)

// -----------------------------------------------------
//  
// -----------------------------------------------------

//  
HINSTANCE hInst;

//  
char szAppName[] = "WServer";

//    
char szAppTitle[] = "Windows Socket Server Demo";

//   Statusbar
HWND hwndSb;

//  
SOCKET srv_socket;

//   
int acc_sin_len;

//   
SOCKADDR_IN acc_sin;

//  
SOCKADDR_IN local_sin;

// -----------------------------------------------------
//  WinMain
// -----------------------------------------------------

int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;

  hInst = hInstance;

  // ,       
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
  	//       ,
	  //  
    if(IsIconic(hWnd))
	  ShowWindow(hWnd, SW_RESTORE);

    //      
	  SetForegroundWindow(hWnd);
    return FALSE;
  }

  //   
  memset(&wc, 0, sizeof(wc));
  
  //  wc.cbSize	 wc.hIconSm   
  // WNDCLASSEX,    
  //     Windows 95
  wc.cbSize = sizeof(WNDCLASSEX);

  //  wc.hIconSm   
  // ,     
  //    (   ).
  //      
  //   LoadImage,   
  // LoadIcon     
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON_SM), IMAGE_ICON, 16, 16, 0);
  
  //    WNDCLASSEX
  wc.style = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  
  //      
  //   LoadImage
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 32, 32, 0);
  
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
  wc.lpszClassName = szAppName;

  //   RegisterClassEx,  
  //  
  if(!RegisterClassEx(&wc))

    //      
    //  RegisterClass
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  //    
  //  .    
  //   Statusbar
  InitCommonControls();
  
  //    
  hWnd = CreateWindow(szAppName, szAppTitle, WS_OVERLAPPEDWINDOW,
   	 CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);

  //  
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);

  //    
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// -----------------------------------------------------
//  WndProc
// -----------------------------------------------------

LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    //    WSA_ACCEPT
    case WSA_ACCEPT:
      WndProc_OnWSAAccept(hWnd, msg, wParam, lParam);
      break;
    
    //    WSA_NETEVENT
    case WSA_NETEVENT:
      WndProc_OnWSANetEvent(hWnd, msg, wParam, lParam);
      break;
    
	  //   WM_CREATE  ,
	  //    WndProc_OnCreate
    HANDLE_MSG(hWnd, WM_CREATE, WndProc_OnCreate);

    //   WM_COMMAND  ,
	  //    WndProc_OnCommand
    HANDLE_MSG(hWnd, WM_COMMAND, WndProc_OnCommand);

    //   WM_SIZE  ,
	  //    WndProc_OnSize
    HANDLE_MSG(hWnd, WM_SIZE, WndProc_OnSize);

    //   WM_DESTROY  ,
	  //    WndProc_OnDestroy
    HANDLE_MSG(hWnd, WM_DESTROY, WndProc_OnDestroy);

	  default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
//  WndProc_OnCreate
// -----------------------------------------------------

BOOL WndProc_OnCreate(HWND hWnd, 
                      LPCREATESTRUCT lpCreateStruct)
{
  int rc;
  WSADATA WSAData;
  char szTemp[128];

  //     Windows Sockets
  rc = WSAStartup(MAKEWORD(1, 1), &WSAData);
  if(rc != 0)
  {
    MessageBox(NULL, "WSAStartup Error", "Error", MB_OK);
    return FALSE;
  }

  //      Windows Sockets
  //     Statusbar
  wsprintf(szTemp, "Server use %s %s", 
    WSAData.szDescription,WSAData.szSystemStatus);

  hwndSb = CreateStatusWindow(WS_CHILD | WS_VISIBLE 
    | WS_BORDER | SBARS_SIZEGRIP, 
    szTemp, hWnd, IDS_STATUSBAR);

  return TRUE;
}

// -----------------------------------------------------
//  WndProc_OnDestroy
// -----------------------------------------------------

//     , 
//   void    
//  return.    
//   FORWARD_WM_LBUTTONDOWN
#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  //  ,  
  //   Windows Sockets
  WSACleanup();

  //    
  PostQuitMessage(0);
  return FORWARD_WM_DESTROY(hWnd, DefWindowProc);
}

// -----------------------------------------------------
//  WndProc_OnSize
// -----------------------------------------------------

#pragma warning(disable: 4098)
void 
WndProc_OnSize(HWND hWnd, UINT state, int cx, int cy)
{
  SendMessage(hwndSb, WM_SIZE, cx, cy);
  return FORWARD_WM_SIZE(hWnd, state, cx, cy, DefWindowProc);
}

// -----------------------------------------------------
//  WndProc_OnCommand
// -----------------------------------------------------

#pragma warning(disable: 4098)
void 
WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  switch (id)
  {
    case IDM_EXIT:
      
      //    
      DestroyWindow(hWnd);
      break;

    case IDM_START:
      
      //  
      ServerStart(hWnd);
      break;
    
    case IDM_STOP:

      //  
      ServerStop(hWnd);
      break;

    default:
      MessageBox(NULL, "Unknown command", "Error", MB_OK);
  }

  return FORWARD_WM_COMMAND(hWnd, id, hwndCtl,
    codeNotify, DefWindowProc);
}

// -----------------------------------------------------
//  ServerStart
// -----------------------------------------------------

void ServerStart(HWND hWnd)
{
  struct sockaddr_in srv_address;
  int rc;
  
  //        
  srv_socket = socket(AF_INET, SOCK_STREAM, 0);
  if(srv_socket == INVALID_SOCKET)
  {
    MessageBox(NULL, "socket Error", "Error", MB_OK);
    return;
  }

  //   IP   
  srv_address.sin_family = AF_INET;
  srv_address.sin_addr.s_addr = INADDR_ANY;
  srv_address.sin_port = htons(SERV_PORT);

  //   IP    
  if(bind(srv_socket, (LPSOCKADDR)&srv_address, 
    sizeof(srv_address)) == SOCKET_ERROR)
  {
    //    
    closesocket(srv_socket);
    MessageBox(NULL, "bind Error", "Error", MB_OK);
    return;
  }

  //      
  //     
  if(listen(srv_socket, 1) == SOCKET_ERROR)
  {
    closesocket(srv_socket);
    MessageBox(NULL, "listen Error", "Error", MB_OK);
    return;
  }

  //       
  //   WSA_ACCEPT
  rc = WSAAsyncSelect(srv_socket, hWnd, WSA_ACCEPT, FD_ACCEPT);
  if(rc > 0)
  {
    closesocket(srv_socket);
    MessageBox(NULL, "WSAAsyncSelect Error", "Error", MB_OK);
    return;
  }

  //    Statusbar    
  SendMessage(hwndSb, SB_SETTEXT, 0, 
    (LPARAM)"Server started");
}

// -----------------------------------------------------
//  ServerStop
// -----------------------------------------------------

void ServerStop(HWND hWnd)
{
  //       
  //     , 
  //   Windows Sockets
  WSAAsyncSelect(srv_socket, hWnd, 0, 0);
  
  //    ,  
  if(srv_socket != INVALID_SOCKET)
  {
    closesocket(srv_socket);
  }

  //    Statusbar    
  SendMessage(hwndSb, SB_SETTEXT, 0, 
    (LPARAM)"Server stopped");
}

// -----------------------------------------------------
//  WndProc_OnWSAAccept
// -----------------------------------------------------

void WndProc_OnWSAAccept(HWND hWnd, UINT msg, 
                         WPARAM wParam, LPARAM lParam)
{
  int rc;

  //     
  //    
  if(WSAGETSELECTERROR(lParam) != 0)
  {
    MessageBox(NULL, "accept Error", "Error", MB_OK);
    WSAAsyncSelect(srv_socket, hWnd, 0, 0);
    return;
  }

  //    
  acc_sin_len = sizeof(acc_sin);

  //   
  srv_socket = accept(srv_socket, (LPSOCKADDR)&acc_sin,
    (int FAR *)&acc_sin_len);

  if(srv_socket == INVALID_SOCKET)
  {
    MessageBox(NULL, "accept Error, invalid socket",
      "Error", MB_OK);
    return;
  }

  //        
  // ,       WSA_NETEVENT.
  //       
  rc = WSAAsyncSelect(srv_socket, hWnd, WSA_NETEVENT, 
    FD_READ | FD_CLOSE);
  if(rc > 0)
  {
    closesocket(srv_socket);
    MessageBox(NULL, "WSAAsyncSelect Error", "Error", MB_OK);
    return;
  }
}

// -----------------------------------------------------
//  WndProc_OnWSANetEvent
// -----------------------------------------------------

void WndProc_OnWSANetEvent(HWND hWnd, UINT msg, 
                       WPARAM wParam, LPARAM lParam)
{
  char szTemp[256];
  int rc;
  
  //      ,
  //       
  //  
  if(WSAGETSELECTEVENT(lParam) == FD_READ)
  {
    rc = recv((SOCKET)wParam, szTemp, 256, 0);
    if(rc)
    {
      szTemp[rc] = '\0';
      MessageBox(NULL, szTemp, "Reeived data", MB_OK);
    }
    return;
  }
  
  //   ,    
  else if(WSAGETSELECTEVENT(lParam) == FD_CLOSE)
  {
    MessageBox(NULL, "Connection closed", "Server", MB_OK);
  }
}

