// SingleView.cpp

#include "stdafx.h"
#include "Single.h"

#include "SingleDoc.h"
#include "SingleView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//   CSingleView   
IMPLEMENT_DYNCREATE(CSingleView, CView)

//    CSingleView
BEGIN_MESSAGE_MAP(CSingleView, CView)
	//{{AFX_MSG_MAP(CSingleView)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	//      
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////
//   CSingleView 
CSingleView::CSingleView()
{
	// TODO:
}

//   CSingleView 
CSingleView::~CSingleView()
{
}

//  PreCreateWindow  CSingleView
BOOL CSingleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO:        cs

	//   PreCreateWindow   CView
	return CView::PreCreateWindow(cs);
}

//////////////////////////////////////////////////////////////
//  OnDraw   
void CSingleView::OnDraw(CDC* pDC)
{
	CSingleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: 

	int i;
	for (i=0; i<pDoc->arrayFig.GetSize(); i++)
	{
		if(pDoc->arrayFig[i].cType == 'E')
			pDC->Ellipse(pDoc->arrayFig[i].xyFigCenter.x-10,
							pDoc->arrayFig[i].xyFigCenter.y-10,
							pDoc->arrayFig[i].xyFigCenter.x+10,
							pDoc->arrayFig[i].xyFigCenter.y+10);

		else if (pDoc->arrayFig[i].cType == 'R')
			pDC->Rectangle(pDoc->arrayFig[i].xyFigCenter.x-10,
							pDoc->arrayFig[i].xyFigCenter.y-10,
							pDoc->arrayFig[i].xyFigCenter.x+10,
							pDoc->arrayFig[i].xyFigCenter.y+10);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////
//     

//  OnPreparePrinting  CSingleView
BOOL CSingleView::OnPreparePrinting(CPrintInfo* pInfo)
{
	//    
	return DoPreparePrinting(pInfo);
}

//  OnBeginPrinting  CSingleView
void CSingleView::OnBeginPrinting(CDC* /*pDC*/, 
	CPrintInfo* /*pInfo*/)
{
	// TODO:      
	//   
}

//  OnEndPrinting  CSingleView
void CSingleView::OnEndPrinting(CDC* /*pDC*/, 
	CPrintInfo* /*pInfo*/)
{
	// TODO:      
	// 
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//   
#ifdef _DEBUG

////////////////////////////////////////////////////////////////////////////////////////////////
//    CSingleView 

//  AssertValid  CSingleView
void CSingleView::AssertValid() const
{
	CView::AssertValid();
}

//  Dump  CSingleView
void CSingleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

//  GetDocument  CSingleView
CSingleDoc* CSingleView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSingleDoc)));
	return (CSingleDoc*)m_pDocument;
}
#endif //_DEBUG

//////////////////////////////////////////////////////////////
//  OnLButtonDown  CSingleView 
//     
void CSingleView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//     (  CSingleDoc)
	CSingleDoc* pDoc = GetDocument();

	//   pDoc
	ASSERT_VALID(pDoc);

	//    
	CClientDC dc(this);
	dc.Ellipse(point.x-10, point.y-10, 
		point.x+10,point.y+10);

	//   
	CFigure	OneFigure;
	OneFigure.xyFigCenter = point;
	OneFigure.cType = 'E';

	//   ,  ,  
	// 
	pDoc->arrayFig.Add(OneFigure);

	//    
	pDoc->SetModifiedFlag();

	//   OnLButtonDown   CView
	CView::OnLButtonDown(nFlags, point);
}

//////////////////////////////////////////////////////////////
//  OnRButtonDown  CSingleView 
//     
void CSingleView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	//     (  CSingleDoc)
	CSingleDoc* pDoc = GetDocument();

	//   pDoc
	ASSERT_VALID(pDoc);

	//    
	CClientDC dc(this);
	dc.Rectangle(point.x-10, point.y-10, 
				point.x+10,point.y+10);

	//   
	CFigure	OneFigure;
	OneFigure.xyFigCenter = point;
	OneFigure.cType = 'R';

	//   ,  ,  
	// 
	pDoc->arrayFig.Add(OneFigure);

	//    
	pDoc->SetModifiedFlag();

	//   OnRButtonDown   CView
	CView::OnRButtonDown(nFlags, point);
}
