// ==================================================
//  DLLCall
//    DLL-
//
// ()  .., 1996
// Email: frolov@glas.apc.org
// ==================================================

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "resource.h"
#include "afxres.h"

#include "dllcall.h"

//  :   
typedef HWND (WINAPI *MYDLLPROC)(LPSTR);

//   ,   
// DLL-
MYDLLPROC GetAppWindow;

//    ,  
//  
char szWindowTitle[512];

//  DLL-
HANDLE hDLL;

HINSTANCE hInst;
char szAppName[]  = "DLLCallApp";
char szAppTitle[] = "DLL Call Demo";

// -----------------------------------------------------
//  WinMain
// -----------------------------------------------------
int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;
  
  //   
  hInst = hInstance;

  // ,       
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
    //  ,    
    //  
    if(IsIconic(hWnd))
	    ShowWindow(hWnd, SW_RESTORE);
	  SetForegroundWindow(hWnd);
    return FALSE;
  }

  //   
  memset(&wc, 0, sizeof(wc));
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICONSM), 
    IMAGE_ICON, 16, 16, 0);
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), 
    IMAGE_ICON, 32, 32, 0);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_APPMENU);
  wc.lpszClassName = szAppName;
  if(!RegisterClassEx(&wc))
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  //    
  hWnd = CreateWindow(szAppName, szAppTitle, 
     WS_OVERLAPPEDWINDOW, 
     CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 
     NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);

  //      
  //  
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// -----------------------------------------------------
//  WndProc
// -----------------------------------------------------
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, 
        LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hWnd, WM_COMMAND, WndProc_OnCommand);
    HANDLE_MSG(hWnd, WM_DESTROY, WndProc_OnDestroy);

	  default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
//  WndProc_OnDestroy
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  PostQuitMessage(0);
  return 0L;
}

// -----------------------------------------------------
//  WndProc_OnCommand
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  switch (id)
  {
    case ID_FILE_EXIT:  
    {
	    //   
      PostQuitMessage(0);
	    return 0L;
	    break;
    }
	  
    case ID_FILE_FINDWINDOW:
    {
      //     
      //    ,
      //    
      if(DialogBox(hInst, MAKEINTRESOURCE(IDD_DLGFIND), 
        hWnd, DlgProc))
      {
        //      DLL-:
        //      

/*
        //     , 
        //    
        if(FindApplicationWindow(szWindowTitle) != NULL)
          MessageBox(NULL, "Application window was found",
            szAppTitle, MB_OK | MB_ICONINFORMATION);
        
          else
          MessageBox(NULL, "Application window was not found",
            szAppTitle, MB_OK | MB_ICONINFORMATION);
*/

        //      DLL-:
        //  DLL-  LoadLibrary

        //  DLL-
        hDLL = LoadLibrary("DLLDEMO.DLL");

        //    , 
        //  
        if(hDLL != NULL)
        {
          //     
          GetAppWindow = 
            (MYDLLPROC)GetProcAddress(hDLL, 
              "FindApplicationWindow");

          //   ,  
          if(GetAppWindow != NULL)
          {
            //     , 
            //    
            if(GetAppWindow(szWindowTitle) != NULL)
              MessageBox(NULL, "Application window was found",
                szAppTitle, MB_OK | MB_ICONINFORMATION);
            else
              MessageBox(NULL, "Application window was not found",
                szAppTitle, MB_OK | MB_ICONINFORMATION);
          }
          
          //  DLL-
          FreeLibrary(hDLL);
        }
      }
 
      break;      
    }
    
    case ID_HELP_ABOUT:
    {
      MessageBox(hWnd, 
        "DLL Call Demo\n"
        "(C) Alexandr Frolov, 1996\n"
        "Email: frolov@glas.apc.org",
        szAppTitle, MB_OK | MB_ICONINFORMATION);
	     return 0L;
	     break;
    }

  	default:
	    break;
  }
  return FORWARD_WM_COMMAND(hWnd, id, hwndCtl, codeNotify,
    DefWindowProc);
}


// -----------------------------------------------------
//  DlgProc
// -----------------------------------------------------
LRESULT WINAPI
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, 
        LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hdlg, WM_INITDIALOG, DlgProc_OnInitDialog);
    HANDLE_MSG(hdlg, WM_COMMAND,    DlgProc_OnCommand);

	default:
    return FALSE;
  }
}

// -----------------------------------------------------
//  DlgProc_OnInitDialog
// -----------------------------------------------------

BOOL DlgProc_OnInitDialog(HWND hdlg, HWND hwndFocus, 
                          LPARAM lParam)
{
  return TRUE;
}

// -----------------------------------------------------
//  DlgProc_OnCommand
// -----------------------------------------------------
#pragma warning(disable: 4098)
void DlgProc_OnCommand(HWND hdlg, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  switch (id)
  {
    case IDOK:
    {
      //     OK,
      //      
      //      szWindowTitle
      GetDlgItemText(hdlg, IDC_EDIT1, szWindowTitle, 512);  
      
      //    
      EndDialog(hdlg, 1);
      return TRUE;
    }

    //     Cancel,
    //    
    case IDCANCEL:
    {
      //    
      EndDialog(hdlg, 0);
      return TRUE;
    }
  	default:
	    break;
  }
  return FALSE;
}
