// ==================================================
//  OEM2CHAR
//    
//    
//
// ()  .., 1996
// Email: frolov@glas.apc.org
// ==================================================

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "resource.h"
#include "afxres.h"

//     

#define SYNCHRONOUS_IO  1 //  
#define ASYNCHRONOUS_IO 2 //  
#define MEMORYMAPPED_IO 3 //   

//      
//       
//    

#define FILEOP SYNCHRONOUS_IO
//#define FILEOP ASYNCHRONOUS_IO
//#define FILEOP MEMORYMAPPED_IO

#include "oem2char.h"

HINSTANCE hInst;
char szAppName[]  = "Oem2CharApp";
char szAppTitle[] = "Text File Converter";

//  :
//  OEM -> ANSI  ANSI -> OEM
BOOL fConversionType = OEM_TO_ANSI;

//  ,  
//     
//   fConversionType
HANDLE hSrcFile;

//      
//   ,    
#if FILEOP != MEMORYMAPPED_IO

  //  ,    
  //  
  HANDLE hDstFile; 
  
  //     
  CHAR   cBuf[2048];

#endif
  
// -----------------------------------------------------
//  WinMain
// -----------------------------------------------------
int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;
  
  //   
  hInst = hInstance;

  // ,       
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
    //  ,    
    //  
    if(IsIconic(hWnd))
	    ShowWindow(hWnd, SW_RESTORE);
	  SetForegroundWindow(hWnd);
    return FALSE;
  }

  //   
  memset(&wc, 0, sizeof(wc));
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICONSM), 
    IMAGE_ICON, 16, 16, 0);
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), 
    IMAGE_ICON, 32, 32, 0);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_APPMENU);
  wc.lpszClassName = szAppName;
  if(!RegisterClassEx(&wc))
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  //    
  hWnd = CreateWindow(szAppName, szAppTitle, 
     WS_OVERLAPPEDWINDOW, 
     CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 
     NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);

  //      
  //  
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// -----------------------------------------------------
//  WndProc
// -----------------------------------------------------
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, 
        LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hWnd, WM_COMMAND, WndProc_OnCommand);
    HANDLE_MSG(hWnd, WM_DESTROY, WndProc_OnDestroy);

	  default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
//  WndProc_OnDestroy
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  PostQuitMessage(0);
  return 0L;
}

// -----------------------------------------------------
//  WndProc_OnCommand
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  switch (id)
  {
    //   
    case ID_FILE_CONVERT:
    {
      //     , 
      //   
      if(!StartConversion(hWnd))
        MessageBox(hWnd, 
          "Conversion Error\n"
          "Unable to open file(s)",
          szAppTitle, MB_OK | MB_ICONEXCLAMATION);

      break;
    }

    case ID_FILE_OPTIONS:
    {
      //   , 
      //    
      DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG1), 
        hWnd, DlgProc);
      break;
    }
    
    case ID_FILE_EXIT:  
    {
	    //   
      PostQuitMessage(0);
	    return 0L;
	    break;
    }
	  
  	case ID_HELP_ABOUT:
    {
      MessageBox(hWnd, 
        "Text File Converter\n"
        "(C) Alexandr Frolov, 1996\n"
        "Email: frolov@glas.apc.org",
        szAppTitle, MB_OK | MB_ICONINFORMATION);
	     return 0L;
	     break;
    }

  	default:
	    break;
  }
  return FORWARD_WM_COMMAND(hWnd, id, hwndCtl, codeNotify,
    DefWindowProc);
}

// -----------------------------------------------------
//  DlgProc
// -----------------------------------------------------
LRESULT WINAPI
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, 
        LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hdlg, WM_INITDIALOG, DlgProc_OnInitDialog);
    HANDLE_MSG(hdlg, WM_COMMAND,    DlgProc_OnCommand);

	default:
    return FALSE;
  }
}

// -----------------------------------------------------
//  DlgProc_OnInitDialog
// -----------------------------------------------------

BOOL DlgProc_OnInitDialog(HWND hdlg, HWND hwndFocus, 
                          LPARAM lParam)
{
  //     
  //  "OEM -> ANSI"
  CheckDlgButton(hdlg, IDC_OEMANSI, 1);
  
  return TRUE;
}

// -----------------------------------------------------
//  DlgProc_OnCommand
// -----------------------------------------------------
#pragma warning(disable: 4098)
void DlgProc_OnCommand(HWND hdlg, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  switch (id)
  {
    //     
    case IDOK:
    {
      if(IsDlgButtonChecked(hdlg, IDC_OEMANSI))
      {
        //     
        // OEM   ANSI
        fConversionType = OEM_TO_ANSI;  
      }
      else if(IsDlgButtonChecked(hdlg, IDC_ANSIOEM))
      {
        //     
        // ANSI   OEM
        fConversionType = ANSI_TO_OEM;  
      }

      EndDialog(hdlg, 0);
      return TRUE;
    }

    //     Cancel,
    //     
    //   
    case IDCANCEL:
    {
      EndDialog(hdlg, 0);
      return TRUE;
    }
  	default:
	    break;
  }
  return FALSE;
}


// -----------------------------------------------------
//  StartConversion
// -----------------------------------------------------
BOOL StartConversion(HWND hwnd)
{
  OPENFILENAME ofn;
  char szFile[256];
  char szDirName[256];
  char szFileTitle[256];
  char szFilter[256] = 
    "Text Files\0*.txt\0Any Files\0*.*\0";
  char szDlgTitle[] = "Select source file";
  char szDlgTitleSave[] = "Select destination file";

  //      

  memset(&ofn, 0, sizeof(OPENFILENAME));
  GetCurrentDirectory(sizeof(szDirName), szDirName);
  szFile[0] = '\0';

  ofn.lStructSize     = sizeof(OPENFILENAME);
  ofn.hwndOwner       = hwnd;
  ofn.lpstrFilter     = szFilter;
  ofn.lpstrInitialDir = szDirName;
  ofn.nFilterIndex    = 1;
  ofn.lpstrFile       = szFile;
  ofn.nMaxFile        = sizeof(szFile);
  ofn.lpstrFileTitle  = szFileTitle;
  ofn.nMaxFileTitle   = sizeof(szFileTitle);
  ofn.lpstrTitle      = szDlgTitle;
  ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST
    | OFN_HIDEREADONLY;

  //     , 
  //    
  if(GetOpenFileName(&ofn))
  {
    //   ,  
    if (*ofn.lpstrFile)
    {

#if FILEOP == SYNCHRONOUS_IO
      
      //     
      // FILE_FLAG_SEQUENTIAL_SCAN
      hSrcFile = CreateFile(ofn.lpstrFile, GENERIC_READ,
        FILE_SHARE_READ, NULL, OPEN_EXISTING,
        FILE_FLAG_SEQUENTIAL_SCAN, NULL);

#elif FILEOP == ASYNCHRONOUS_IO
      
      //     
      //  FILE_FLAG_OVERLAPPED
      hSrcFile = CreateFile(ofn.lpstrFile, GENERIC_READ,
        FILE_SHARE_READ, NULL, OPEN_EXISTING,
        FILE_FLAG_OVERLAPPED, NULL);

#elif FILEOP == MEMORYMAPPED_IO

      //        
      //  ,  , 
      //       ,
      //    
      hSrcFile = CreateFile(ofn.lpstrFile, 
        GENERIC_READ | GENERIC_WRITE,
        0, NULL, OPEN_EXISTING,  0, NULL);

#endif

    }
    else
      return FALSE;
  }
  else 
    return FALSE;

  //      ,
  //   FALSE
  if(hSrcFile == INVALID_HANDLE_VALUE)
    return FALSE;

#if FILEOP == MEMORYMAPPED_IO

  //   ,   
  //   ,   
  // " ".    
  // Oem2Char   .

  Oem2Char(hSrcFile);
  CloseHandle(hSrcFile);
  
#elif FILEOP == SYNCHRONOUS_IO || FILEOP == ASYNCHRONOUS_IO 
  
  //     
  //      
  //     .   
  //       
  //    Oem2Char -  
  // 
  
  ofn.lpstrTitle = szDlgTitleSave;
  ofn.Flags      = OFN_HIDEREADONLY;
  
  if(GetSaveFileName(&ofn))
  {
    //   ,  
    if (*ofn.lpstrFile)
    {

#if FILEOP == SYNCHRONOUS_IO

      //     
      //  FILE_FLAG_SEQUENTIAL_SCAN
      hDstFile = CreateFile(ofn.lpstrFile, GENERIC_WRITE,
        0, NULL, CREATE_ALWAYS,
        FILE_FLAG_SEQUENTIAL_SCAN, NULL);

#elif FILEOP == ASYNCHRONOUS_IO

      //     
      //    FILE_FLAG_OVERLAPPED
      hDstFile = CreateFile(ofn.lpstrFile, GENERIC_WRITE,
        0, NULL, CREATE_ALWAYS,
        FILE_FLAG_OVERLAPPED,  NULL);

#endif
    
    }
    else
      return FALSE;
  }
  else 
    return FALSE;

  //      ,
  //   FALSE
  if(hDstFile == INVALID_HANDLE_VALUE)
    return FALSE;

  //    hSrcFile  
  //     hDstFile
  Oem2Char(hSrcFile, hDstFile);

  //     
  CloseHandle(hSrcFile);
  CloseHandle(hDstFile);

#endif
  
  //      TRUE
  return TRUE;
}

// -----------------------------------------------------
//  Oem2Char
// -----------------------------------------------------
//   
// -----------------------------------------------------

#if FILEOP == SYNCHRONOUS_IO

void Oem2Char(HANDLE hSrcFile, HANDLE hDstFile)
{
  DWORD dwBytesRead;
  DWORD dwBytesWritten;
  BOOL  bResult;

  //     
  while(TRUE)
  {
    //      
    //   cBuf
    bResult = ReadFile(hSrcFile, cBuf, 2048, 
      &dwBytesRead, NULL);
    
    // ,      
    if(bResult && dwBytesRead == 0) 
      break;

    //     
    //    fConversionType
    if(fConversionType == OEM_TO_ANSI)
      
      //   OEM  ANSI
      OemToCharBuff(cBuf, cBuf, dwBytesRead);
    
    else if(fConversionType == ANSI_TO_OEM)

      //   ANSI  OEM
      CharToOemBuff(cBuf, cBuf, dwBytesRead);

    //      
    WriteFile(hDstFile, cBuf, dwBytesRead,
      &dwBytesWritten, NULL);
  }
}

// -----------------------------------------------------
//  Oem2Char
// -----------------------------------------------------
//   
// -----------------------------------------------------

#elif FILEOP == ASYNCHRONOUS_IO

void Oem2Char(HANDLE hSrcFile, HANDLE hDstFile)
{
  DWORD dwBytesRead;
  DWORD dwBytesWritten;
  BOOL  bResult;
  DWORD dwError;

  //     
  OVERLAPPED ovRead;
  OVERLAPPED ovWrite;

  //     
  ovRead.Offset = 0;
  ovRead.OffsetHigh = 0;
  ovRead.hEvent = NULL;
  
  //     
  ovWrite.Offset = 0;
  ovWrite.OffsetHigh = 0;
  ovWrite.hEvent = NULL;

  //     
  while(TRUE)
  {
    //    
    bResult = ReadFile(hSrcFile, cBuf, sizeof(cBuf), 
      &dwBytesRead, &ovRead);
    
    //   
    if(!bResult) 
    { 
 	    //   ,    
      switch (dwError = GetLastError()) 
      { 
        //      
        //     
        case ERROR_HANDLE_EOF: 
        {
          return;
        }

        //      
        case ERROR_IO_PENDING: 
        { 
          //      ,
          //     
          //     
          //
          //  IdleWork();
          
          //      
          //    , 
          //   
          WaitForSingleObject(hSrcFile, INFINITE);

          //    
          //  
          bResult = GetOverlappedResult(hSrcFile, &ovRead, 
            &dwBytesRead, FALSE);
          
          if(!bResult) 
          { 
    				switch (dwError = GetLastError()) 
            { 
              //      
              //     
              case ERROR_HANDLE_EOF: 
              {
                return;
              }
              
              default:
                break;
            }
          }
        }

        default:
          break;        
      }
    }

    //    
    //  
    GetOverlappedResult(hSrcFile, &ovRead, 
        &dwBytesRead, FALSE);
 
    //  
    if(fConversionType == OEM_TO_ANSI)
      OemToCharBuff(cBuf, cBuf, dwBytesRead);
    
    else if(fConversionType == ANSI_TO_OEM)
      CharToOemBuff(cBuf, cBuf, dwBytesRead);

    //   ,  
    //    
    //     
    ovRead.Offset += dwBytesRead;

    //    
    bResult = WriteFile(hDstFile, cBuf, dwBytesRead,
      &dwBytesWritten, &ovWrite);

    //   ,   
    if(!bResult) 
    { 
 	    switch (dwError = GetLastError()) 
      { 
        //      
        case ERROR_IO_PENDING: 
        { 
          //      ,
          //     
          //     
          //
          //  IdleWork();
          
          //    
          //  
          GetOverlappedResult(hDstFile, &ovWrite, 
            &dwBytesWritten, TRUE);
          
          if(!bResult) 
          { 
            switch (dwError = GetLastError()) 
            { 
              
              default:
                break;
            }
          }
        }

        default:
          break;
      }
    }

    //   ,  
    //    
    //     
    ovWrite.Offset += dwBytesWritten;
  }
}

// -----------------------------------------------------
//  Oem2Char
// -----------------------------------------------------
//      
//  
// -----------------------------------------------------

#elif FILEOP == MEMORYMAPPED_IO

void Oem2Char(HANDLE hSrcFile)
{
  DWORD dwFileSize;
  HANDLE hFileMapping;
  LPVOID lpFileMap;

  //     
  dwFileSize = GetFileSize(hSrcFile, NULL);

  //  -   
  hFileMapping = CreateFileMapping(hSrcFile,
    NULL, PAGE_READWRITE, 0, dwFileSize, NULL);

  //    ,  
  if(hFileMapping == NULL)
    return;

  //     .
  //   lpFileMap    
  //   
  lpFileMap = MapViewOfFile(hFileMapping, 
    FILE_MAP_WRITE, 0, 0, 0);

  //     ,
  //  
  if(lpFileMap == 0)
    return;
    
  //      
  if(fConversionType == OEM_TO_ANSI)
    OemToCharBuff(lpFileMap, lpFileMap, dwFileSize);
    
  else if(fConversionType == ANSI_TO_OEM)
    CharToOemBuff(lpFileMap, lpFileMap, dwFileSize);

  //   
  UnmapViewOfFile(lpFileMap);

  //   
  // -
  CloseHandle(hFileMapping);
}

#endif
