// ==================================================
//  "Sample of simple service"
//    Windows NT
//
// ()  .., 1996
// Email: frolov@glas.apc.org
// ==================================================

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#include "small.h"

// -----------------------------------------------------
//  
// -----------------------------------------------------

//  
DWORD dwErrCode;

//   
SERVICE_STATUS ss;

//  
SERVICE_STATUS_HANDLE ssHandle;

// -----------------------------------------------------
//  main
//      
// -----------------------------------------------------
void main(int agrc, char *argv[])
{
  //   
  SERVICE_TABLE_ENTRY DispatcherTable[] =
  {
    {
      //  
      MYServiceName,
      
      //  main 
      (LPSERVICE_MAIN_FUNCTION)ServiceMain
    },
    {
      NULL,
      NULL
    }

  };

  printf("Sample of simple service\n"
    "(C) A. Frolov, 1996, Email: frolov@glas.apc.org\n");

  //  
  if(!StartServiceCtrlDispatcher(DispatcherTable))
  {
    fprintf(stdout,
      "StartServiceCtrlDispatcher: Error %ld\n", 
      GetLastError());
    getch();
    return;
  }
}

// -----------------------------------------------------
//  ServiceMain
//   main    
// -----------------------------------------------------
void WINAPI ServiceMain(DWORD argc, LPSTR *argv)
{
  //    
  ssHandle = 
    RegisterServiceCtrlHandler(MYServiceName, ServiceControl);

  if(!ssHandle)
    return;

  //   
  
  //     
  ss.dwServiceType = SERVICE_WIN32_OWN_PROCESS;

  //       
  //  
  ss.dwServiceSpecificExitCode = 0;

  //   .
  //     
  //  
  ReportStatus(SERVICE_START_PENDING, NO_ERROR, 4000);
  
  //  ,   
  //   
  //  ServiceStart(argc, argv);

  //    
  //   
  ReportStatus(SERVICE_RUNNING, NOERROR, 0);

  return;
}

// -----------------------------------------------------
//  ServiceControl
//      
// -----------------------------------------------------
void WINAPI ServiceControl(DWORD dwControlCode)
{
  //       
  switch(dwControlCode)
  {
    //   
    case SERVICE_CONTROL_STOP:
    {
      //    
      ss.dwCurrentState = SERVICE_STOP_PENDING;
      ReportStatus(ss.dwCurrentState, NOERROR, 0);

      //   ,  ,
      //       
      // ServiceStop();

      //     
      ReportStatus(SERVICE_STOPPED, NOERROR, 0);
      break;
    }

    //    
    case SERVICE_CONTROL_INTERROGATE:
    {
      //    
      ReportStatus(ss.dwCurrentState, NOERROR, 0);
      break;
    }

    //       
    //   
    default:
    {
      ReportStatus(ss.dwCurrentState, NOERROR, 0);
      break;
    }
  }
}

// -----------------------------------------------------
//  ReportStatus
//      
// -----------------------------------------------------
void ReportStatus(DWORD dwCurrentState,
       DWORD dwWin32ExitCode, DWORD dwWaitHint)
{
  //    
  static DWORD dwCheckPoint = 1;

  //       ,
  //   
  if(dwCurrentState == SERVICE_START_PENDING)
    ss.dwControlsAccepted = 0;
  else
    ss.dwControlsAccepted = SERVICE_ACCEPT_STOP;

  //  ,  
  //  
  ss.dwCurrentState  = dwCurrentState;
  ss.dwWin32ExitCode = dwWin32ExitCode;
  ss.dwWaitHint      = dwWaitHint;

  //       , 
  //    
  //  
  if((dwCurrentState == SERVICE_RUNNING) ||
     (dwCurrentState == SERVICE_STOPPED))
    ss.dwCheckPoint = 0;
  else
    ss.dwCheckPoint = dwCheckPoint++;

  //    
  SetServiceStatus(ssHandle, &ss);
}
