// ==================================================
//  SRVCTRL
//    "Sample of simple service"
//
// ()  .., 1996
// Email: frolov@glas.apc.org
// ==================================================

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "resource.h"
#include "afxres.h"

#include "srvctrl.h"

HINSTANCE hInst;
char szAppName[]  = "ServiceCtlApp";
char szAppTitle[] = "Simple Service Control";

//  
SERVICE_STATUS ss;

// -----------------------------------------------------
//  WinMain
// -----------------------------------------------------
int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;
  
  //   
  hInst = hInstance;

  // ,       
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
    //  ,    
    //  
    if(IsIconic(hWnd))
	    ShowWindow(hWnd, SW_RESTORE);
	  SetForegroundWindow(hWnd);
    return FALSE;
  }

  //   
  memset(&wc, 0, sizeof(wc));
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICONSM), 
    IMAGE_ICON, 16, 16, 0);
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), 
    IMAGE_ICON, 32, 32, 0);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_APPMENU);
  wc.lpszClassName = szAppName;
  if(!RegisterClassEx(&wc))
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  //    
  hWnd = CreateWindow(szAppName, szAppTitle, 
     WS_OVERLAPPEDWINDOW, 
     CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 
     NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);

  //      
  //  
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }

  return msg.wParam;
}

// -----------------------------------------------------
//  WndProc
// -----------------------------------------------------
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, 
        LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hWnd, WM_COMMAND, WndProc_OnCommand);
    HANDLE_MSG(hWnd, WM_DESTROY, WndProc_OnDestroy);

	  default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
//  WndProc_OnDestroy
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  PostQuitMessage(0);
  return 0L;
}

// -----------------------------------------------------
//  WndProc_OnCommand
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  //  
  SC_HANDLE schService;

  //    
  SC_HANDLE schSCManager;

  LPQUERY_SERVICE_CONFIG  lpBuf;
  DWORD dwBytesNeeded;
  char szBuf[1024];
  
  switch (id)
  {
    case ID_FILE_EXIT:  
    {
	    //   
      PostQuitMessage(0);
	    return 0L;
	    break;
    }
	  
    //    
    case ID_SERVICE_INSTALL:
    {
      //    
      schSCManager = OpenSCManager(NULL, NULL, 
        SC_MANAGER_ALL_ACCESS);

      if(!schSCManager)
        break;

      //     MYServiceName
      schService = CreateService(
        schSCManager,
        MYServiceName,
        MYServiceName,
        SERVICE_ALL_ACCESS,
        SERVICE_WIN32_OWN_PROCESS,
        SERVICE_DEMAND_START,
        SERVICE_ERROR_NORMAL,
        "c:\\ntbk2\\src\\service\\small\\debug\\small.exe",
        NULL,
        NULL,
        "",
        NULL,
        NULL);

      //    
      // 
      CloseServiceHandle(schSCManager);
	    break;
    }

    //    
    case ID_SERVICE_REMOVE:
    {
      //    
      schSCManager = OpenSCManager(NULL, NULL, 
        SC_MANAGER_ALL_ACCESS);

      if(!schSCManager)
        break;

      //     MYServiceName
      schService = OpenService(
        schSCManager, MYServiceName,
        SERVICE_ALL_ACCESS);

      if(!schService)
        break;

      //  
      ControlService(schService, 
        SERVICE_CONTROL_STOP, &ss);
      
      //      
      DeleteService(schService);

      //    
      // 
      CloseServiceHandle(schSCManager);
	    break;
    }

    case ID_SERVICE_START:
    {
      //    
      schSCManager = OpenSCManager(NULL, NULL, 
        SC_MANAGER_ALL_ACCESS);

      if(!schSCManager)
        break;

      //     MYServiceName
      schService = OpenService(
        schSCManager, MYServiceName,
        SERVICE_ALL_ACCESS);

      if(!schService)
        break;

      //  
      StartService(schService, 0, NULL);
      
      //    
      // 
      CloseServiceHandle(schSCManager);
      break;
    }

    case ID_SERVICE_STOP:
    {
      //    
      schSCManager = OpenSCManager(NULL, NULL, 
        SC_MANAGER_ALL_ACCESS);

      if(!schSCManager)
        break;

      //     MYServiceName
      schService = OpenService(
        schSCManager, MYServiceName,
        SERVICE_ALL_ACCESS);

      //  
      ControlService(schService, 
        SERVICE_CONTROL_STOP, &ss);
      
      //    
      // 
      CloseServiceHandle(schSCManager);
      break;
    }
    
    case ID_SERVICE_GETCONFIGURATION:
    {
      //    
      schSCManager = OpenSCManager(NULL, NULL, 
        SC_MANAGER_ALL_ACCESS);

      if(!schSCManager)
        break;

      //     MYServiceName
      schService = OpenService(
        schSCManager, MYServiceName,
        SERVICE_ALL_ACCESS);

      if(!schService)
        break;
      
      //     
      lpBuf = (LPQUERY_SERVICE_CONFIG)malloc(4096);
      
      if(lpBuf != NULL)
      {
        //    
        QueryServiceConfig(schService, 
           lpBuf, 4096, &dwBytesNeeded);
        
        //    
        wsprintf(szBuf, "Binary path: %s\n"
          "Start Name: %s\n"
          "Display Name: %s\n",
          lpBuf->lpBinaryPathName,
          lpBuf->lpServiceStartName,
          lpBuf->lpDisplayName);

        MessageBox(hWnd, szBuf, szAppTitle, 
          MB_OK | MB_ICONINFORMATION);

        //  
        free(lpBuf);
      }

      //    
      // 
      CloseServiceHandle(schSCManager);
      break;
    }
    
    case ID_HELP_ABOUT:
    {
      MessageBox(hWnd, 
        "Simple Service Control\n"
        "(C) Alexandr Frolov, 1996\n"
        "Email: frolov@glas.apc.org",
        szAppTitle, MB_OK | MB_ICONINFORMATION);
	     return 0L;
	     break;
    }

  	default:
	    break;
  }
  return FORWARD_WM_COMMAND(hWnd, id, hwndCtl, codeNotify,
    DefWindowProc);
}


