// MultiView.cpp 
//

#include "stdafx.h"
#include "Multi.h"

#include "MultiDoc.h"
#include "MultiView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
//   CMultiView  
IMPLEMENT_DYNCREATE(CMultiView, CView)

//    CMultiView 
BEGIN_MESSAGE_MAP(CMultiView, CView)
   //{{AFX_MSG_MAP(CMultiView)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
   ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
   ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
   ON_COMMAND(ID_FILE_PRINT_PREVIEW, 
                             CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//     CMultiView 

CMultiView::CMultiView()
{
	// TODO: 

}

CMultiView::~CMultiView()
{
}


/////////////////////////////////////////////////////////////////////////////
//  PreCreateWindow  CMultiView 

BOOL CMultiView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: 

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
//  OnDraw  CMultiView 

void CMultiView::OnDraw(CDC* pDC)
{
   CMultiDoc* pDoc = GetDocument();
   ASSERT_VALID(pDoc);

   int i;
   for (i=0; i<pDoc->pointFigCenter.GetSize(); i++)
      pDC->Rectangle(
         pDoc->pointFigCenter[i].x-10,
         pDoc->pointFigCenter[i].y-10, 
         pDoc->pointFigCenter[i].x+10, 
         pDoc->pointFigCenter[i].y+10
      );
}

/////////////////////////////////////////////////////////////////////////////
//   CMultiView,   

BOOL CMultiView::OnPreparePrinting(CPrintInfo* pInfo)
{
	return DoPreparePrinting(pInfo);
}

void CMultiView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: 
}

void CMultiView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: 
}

/////////////////////////////////////////////////////////////////////////////
//   

#ifdef _DEBUG
void CMultiView::AssertValid() const
{
	CView::AssertValid();
}

void CMultiView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

/////////////////////////////////////////////////////////////////////////////
//    GetDocument CMultiView 

CMultiDoc* CMultiView::GetDocument() 
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMultiDoc)));
	return (CMultiDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////


void CMultiView::OnLButtonDown(UINT nFlags, CPoint point) 
{
   //     (  CSingleDoc)
   CMultiDoc* pDoc = GetDocument();

   //   pDoc
   ASSERT_VALID(pDoc);

   //    
   CClientDC dc(this);
   dc.Rectangle(
         point.x-10, point.y-10, point.x+10, point.y+10);

   //   ,  ,  
   // 
   pDoc->pointFigCenter.Add(point);

   //    
   pDoc->SetModifiedFlag();

   //    nNewFig   
   //   pointFigCenter
   int nNewFig;
   nNewFig = pDoc->pointFigCenter.GetUpperBound();

   //        
   //  ,     
   // ,  
   pDoc->UpdateAllViews(this, nNewFig);

   //   OnLButtonDown   CView
   CView::OnLButtonDown(nFlags, point);

}

void CMultiView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	   //    ,   
   //  
   CMultiDoc* pDoc = GetDocument();
   ASSERT_VALID(pDoc);

   //  lHint  ,    
   if (lHint==0L) 
      CView::OnUpdate(pSender, lHint, pHint);

   //       
   else
   {
      //     
      CClientDC dc(this);

      //  ,    
      // pointFigCenter   lHint
      dc.Rectangle(
            pDoc->pointFigCenter[lHint].x-10,
            pDoc->pointFigCenter[lHint].y-10,
            pDoc->pointFigCenter[lHint].x+10,
            pDoc->pointFigCenter[lHint].y+10
      );
   }

}
