//       
#define VC_EXTRALEAN		

//    MFC
#include <afxwin.h>
#include <afxext.h> 
#include <afxcmn.h>

//     
#include "resource.h"

//========================================================
//  CMultiBarApp -    
//========================================================
class CMultiBarApp : public CWinApp
{
public:
   //     InitInstance
   virtual BOOL InitInstance();
};
 
//     CMultiBarApp
CMultiBarApp MultiBarApp;
 
//========================================================
//  CExtendedBar -    Extended
//========================================================
class CExtendedBar : public CToolBar
{
public:
   //     Extended
   CEdit m_edit;                          //  
   CComboBox m_combo_box; //    
};


//========================================================
//  CMultiBarWindow -    
//========================================================
class CMultiBarWindow : public CFrameWnd
{
//   
protected: 
   //   Player
   CToolBar       m_wndPlayerBar;
   //   Style
   CToolBar       m_wndStyleBar;
   //   Extended
   CExtendedBar   m_wndExtendedBar;
   
protected:
   //  OnCreate     
   afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

public:
   //    CMultiBarWindow
   CMultiBarWindow();

   //       
   afx_msg void BarCommandOne();
   afx_msg void BarCommandRange(UINT nID);
   afx_msg void AddStringToComboBox();

   //        View
   afx_msg BOOL ShowStyle(UINT nID);

   //  ,    
   // CMultiBarWindow  
   DECLARE_MESSAGE_MAP()    
}; 

//========================================================
//  BarCommandRange
//     
//========================================================
void CMultiBarWindow::BarCommandRange( UINT nID )
{
   //     
}

//========================================================
//  BarCommand
//      
//========================================================
void CMultiBarWindow::BarCommandOne()
{
   //    ,    
   MessageBox("Command not implemented");	
}

//========================================================
//  AddStringToComboBox
//     Add   Extended
//========================================================
void CMultiBarWindow::AddStringToComboBox()
{
   //  ,     m_edit
   char  tmpStr[39];
   m_wndExtendedBar.m_edit.GetLine(0, tmpStr,40);	

   //      m_combo_box
   m_wndExtendedBar.m_combo_box.AddString(tmpStr);
}

//========================================================
//  ShowStyle
//     View
//========================================================
BOOL CMultiBarWindow::ShowStyle(UINT nID)
{
   //     ,  
   //  nID
   CControlBar* pBar = GetControlBar(nID);

   // ,        
   //   
   BOOL bShow = (( pBar -> GetStyle() & WS_VISIBLE) != 0);
   
   //    :    
   //   ,    ,   - 
   ShowControlBar( pBar, !bShow, FALSE);
      
   return TRUE;
}

//========================================================
//    CMultiBarWindow
//========================================================
BEGIN_MESSAGE_MAP(CMultiBarWindow, CFrameWnd)

   //    OnCreate
   ON_WM_CREATE()

   //      Player
   ON_COMMAND(ID_STOP, BarCommandOne)
   ON_COMMAND(ID_PLAY, BarCommandOne)
   ON_COMMAND(ID_PAUSE, BarCommandOne)
   ON_COMMAND_RANGE(ID_LEFT, ID_RIGHT, 
                                                  BarCommandRange)
   ON_COMMAND_RANGE(ID_TYPE, ID_WAVE, 
                                                  BarCommandRange)

   //      Extended
   ON_COMMAND(ID_ADD, AddStringToComboBox)
   ON_COMMAND_RANGE(ID_FOTO, ID_DISK, 
                                                  BarCommandRange)

   //      Style
   ON_COMMAND_RANGE(ID_UNDERLINE, ID_MARK_4, 
                                                  BarCommandRange)

   //    View
   ON_COMMAND_EX(ID_Style, ShowStyle)
   ON_COMMAND_EX(ID_Extended, ShowStyle)
   ON_COMMAND_EX(ID_Player, ShowStyle)

END_MESSAGE_MAP()

//========================================================
//  InitInstance  CMultiBarApp
//         
//========================================================
BOOL CMultiBarApp::InitInstance()
{
   m_pMainWnd = new CMultiBarWindow();
   m_pMainWnd -> ShowWindow(m_nCmdShow);
   m_pMainWnd -> UpdateWindow();

   return TRUE;
}

//========================================================
//   CMultiBarWindow
//========================================================
CMultiBarWindow::CMultiBarWindow()
{ 
   //   ,  
   //    CMultiBarWindow
   Create(NULL, "Multi Bar", WS_OVERLAPPEDWINDOW,
         rectDefault, NULL, MAKEINTRESOURCE(IDR_MENU)); 
}

//========================================================
//  OnCreate  CMultiBarWindow
//     
//========================================================
int CMultiBarWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
   //   OnCreate  
   if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
      return -1;

   //      
   //    CMultiBarWindow
	EnableDocking(CBRS_ALIGN_ANY);
   
   //       
   UINT nBarStyle;
   int nIndex;
//========================================================
//      Player
//========================================================
   //    toolbar
   if (!m_wndPlayerBar.Create(this, WS_CHILD | WS_VISIBLE | 
      CBRS_SIZE_DYNAMIC | CBRS_BOTTOM  | 
      CBRS_TOOLTIPS, ID_Player))
   {
      //     
      TRACE0("Failed to create toolbar\n");
      return -1;
   }
	
   //     Player
   if (!m_wndPlayerBar.LoadToolBar(IDR_PLAYER))
   {
      //       
      TRACE0("Failed to load toolbar\n");
      return -1;
   }
   
   //     Player
   m_wndPlayerBar.SetWindowText("Player");      
   
   //     ID_TYPE, ID_CD_DRV  ID_WAVE
   //      .
   //      TBBS_CHECKGROUP
   nIndex = m_wndPlayerBar.CommandToIndex(ID_TYPE);
   nBarStyle =  m_wndPlayerBar.GetButtonStyle(nIndex) | TBBS_CHECKGROUP;
   m_wndPlayerBar.SetButtonStyle(nIndex, nBarStyle);

   nIndex = m_wndPlayerBar.CommandToIndex(ID_CD_DRV);
   nBarStyle =  m_wndPlayerBar.GetButtonStyle(nIndex) | TBBS_CHECKGROUP;
   m_wndPlayerBar.SetButtonStyle(nIndex, nBarStyle);

   nIndex = m_wndPlayerBar.CommandToIndex(ID_WAVE);
   nBarStyle =  m_wndPlayerBar.GetButtonStyle(nIndex) | TBBS_CHECKGROUP;
   m_wndPlayerBar.SetButtonStyle(nIndex, nBarStyle);
    
   //     ID_PAUSE  .
   //      TBBS_CHECKBOX
   nIndex = m_wndPlayerBar.CommandToIndex(ID_PAUSE);
   nBarStyle =  m_wndPlayerBar.GetButtonStyle(nIndex) | TBBS_CHECKBOX;
   m_wndPlayerBar.SetButtonStyle(nIndex, nBarStyle);
   
   //     Player  
   //    
   m_wndPlayerBar.EnableDocking(CBRS_ALIGN_ANY );

   //    Player   
   // 
	DockControlBar(&m_wndPlayerBar);

//========================================================
//      Style
//========================================================
   //    toolbar
   if (!m_wndStyleBar.Create(this, WS_CHILD | WS_VISIBLE | 
      CBRS_SIZE_FIXED | CBRS_TOP | CBRS_TOOLTIPS, ID_Style))
   {
      //     
      TRACE0("Failed to create toolbar\n");
      return -1;
   }

   //     Style
   if (!m_wndStyleBar.LoadToolBar(IDR_STYLE))
   {
      //      
      TRACE0("Failed to load toolbar\n");
      return -1;
   }

   //     Style
   m_wndStyleBar.SetWindowText("Style");   

   //     Player  
   //  
   m_wndStyleBar.EnableDocking(0);

   //    ID_SUBSCRIPT  TBBS_WRAPPED
   nIndex = m_wndStyleBar.CommandToIndex(ID_SUBSCRIPT);
   nBarStyle =  m_wndStyleBar.GetButtonStyle(nIndex) | TBBS_WRAPPED;
   m_wndStyleBar.SetButtonStyle(nIndex, nBarStyle);
 
   //    ID_TEXT_JUSTIFY  TBBS_WRAPPED
   nIndex = m_wndStyleBar.CommandToIndex(ID_TEXT_JUSTIFY);
   nBarStyle =  m_wndStyleBar.GetButtonStyle(nIndex) | TBBS_WRAPPED;
   m_wndStyleBar.SetButtonStyle(nIndex, nBarStyle);
 
   //    Style  -.
   //      
   //   pointStyleBar  CPoint 
   CPoint pointStyleBar(100, 100);
   FloatControlBar(&m_wndStyleBar, pointStyleBar);
  
//========================================================
//      Extended
//========================================================
   //    Extended
   if (!m_wndExtendedBar.Create(this, WS_CHILD | WS_VISIBLE | 
      CBRS_SIZE_DYNAMIC | CBRS_TOP | CBRS_TOOLTIPS, ID_Extended))
   {
      //     
      TRACE0("Failed to create toolbar\n");
      return -1;
   }
	
   //     Extended
   if (!m_wndExtendedBar.LoadToolBar(IDR_EXTENDED))
   {
      //      
      TRACE0("Failed to load toolbar\n");
      return -1;
   }

   //     Extended
   m_wndExtendedBar.SetWindowText("Extended");      

	//    . 
   //     2
	m_wndExtendedBar.SetButtonInfo(2, IDW_EDIT, TBBS_SEPARATOR, 130);

   //      ,
   //  
	CRect rectEdit;
	m_wndExtendedBar.GetItemRect(2, &rectEdit);

   //       
   rectEdit.left += 6;
   rectEdit.right -= 6;
   
   //     Extended,   rectEdit
   //   
   if (!m_wndExtendedBar.m_edit.Create(WS_CHILD |
      ES_AUTOHSCROLL|WS_VISIBLE|WS_TABSTOP|WS_BORDER,
      rectEdit, &m_wndExtendedBar, IDW_EDIT))
	{
      //     
      TRACE0("Failed to create edit-box\n");
		return FALSE;
	}

	//    . 
   //     4
	m_wndExtendedBar.SetButtonInfo(4, IDW_SPIN, TBBS_SEPARATOR, 150);

   //      ,
   //  
	CRect rectComboBox;
	m_wndExtendedBar.GetItemRect(4, &rectComboBox);

   //       
   rectComboBox.left += 6;
   rectComboBox.right -= 6;

   //    ,     
   //      
   rectComboBox.bottom = rectComboBox.top + 80;

   //     Extended,   rectComboBox
   //    
   if (!m_wndExtendedBar.m_combo_box.Create(
			CBS_DROPDOWN | WS_CHILD | WS_VISIBLE | WS_VSCROLL |
         CBS_AUTOHSCROLL|CBS_DISABLENOSCROLL,
			rectComboBox, &m_wndExtendedBar, IDW_SPIN))
	{
      //       
		TRACE0("Failed to create combo-box\n");
		return FALSE;
	}

   //      m_combo_box
   m_wndExtendedBar.m_combo_box.AddString("One");
   m_wndExtendedBar.m_combo_box.AddString("Two");
   m_wndExtendedBar.m_combo_box.AddString("Third");
   
   //     Player  
   // ,      
   m_wndExtendedBar.EnableDocking(
         CBRS_ALIGN_LEFT | CBRS_ALIGN_TOP | CBRS_ALIGN_BOTTOM );
	
   //    Player   
   // 
   DockControlBar(&m_wndExtendedBar);

   return 0;
}
