// ===============================================
//  ISAPI fileupl.c
//     
//     WWW
//   HTML
//
// (C)  .., 1997
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//         
//         http://www.dials.ccas.ru/frolov
// ===============================================

#include <windows.h>
#include <httpext.h>

//  ,   
LPVOID ReadClientMIME(EXTENSION_CONTROL_BLOCK *lpECB, 
                      int *nStatus);
BOOL GetMIMEBoundary(LPVOID lpDataMIME, LPSTR lpBuffer, 
                     DWORD dwBufSize);

// =============================================================
//  GetExtensionVersion
//    ISAPI 
//   
// =============================================================
BOOL WINAPI GetExtensionVersion(HSE_VERSION_INFO *pVer)
{
  //    ISAPI
  pVer->dwExtensionVersion = 
    MAKELONG(HSE_VERSION_MINOR,HSE_VERSION_MAJOR );

  //    
  lstrcpyn(pVer->lpszExtensionDesc,
    "Remote File Upload", HSE_MAX_EXT_DLL_NAME_LEN);

  return TRUE;
}

// =============================================================
//  HttpExtensionProc
// =============================================================
DWORD WINAPI HttpExtensionProc(EXTENSION_CONTROL_BLOCK *lpECB)
{
  CHAR   szBuff[4096];
  HANDLE hOutFile;
  DWORD  dwWritten;
  LPVOID lpDataMIME;
  int    nStatus;

  //    -   
  lpECB->dwHttpStatusCode = 0;

  //       MIME
  lpDataMIME = ReadClientMIME(lpECB, &nStatus);

  if(lpDataMIME != NULL)
  {
    //      
    hOutFile = CreateFile("e:\\InetPub\\scripts\\uploaded.dat", 
      GENERIC_WRITE, FILE_SHARE_READ, NULL,
      CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	  
	  if(hOutFile != INVALID_HANDLE_VALUE)
    {
	    //     
      WriteFile(hOutFile, lpDataMIME, 
        lpECB->cbTotalBytes, &dwWritten, NULL);
	    
      //  
      CloseHandle(hOutFile);
    }
      
    //  ,   
    //   ReadClientMIME
    LocalFree(lpDataMIME);
  }
  
  //   HTML   
  //   
  wsprintf(szBuff,
    "Content-Type: text/html\r\n\r\n"
    "<HTML><HEAD><TITLE>Remote File Upload</TITLE></HEAD>\n"
    "<BODY BGCOLOR=#FFFFFF><H1>Make your file upload!</H1>\n"
    "<HR>\n");

  strcat(szBuff, "<P>Upload finished");
  strcat(szBuff, "</BODY></HTML>");  

  //    HTML
  if(!lpECB->ServerSupportFunction(lpECB->ConnID,
    HSE_REQ_SEND_RESPONSE_HEADER, NULL, NULL, (LPDWORD)szBuff))
  {
    return HSE_STATUS_ERROR;
  }

  lpECB->dwHttpStatusCode = 200;
  return HSE_STATUS_SUCCESS;
}

// =============================================================
//  ReadClientMIME
//     MIME
// =============================================================
LPVOID ReadClientMIME(
	EXTENSION_CONTROL_BLOCK *lpECB, 
	int *nStatus)
{
  DWORD cbReaded;
  DWORD nBufferPos;
  DWORD nBytesToCopy;

  LPVOID lpTemp = NULL;
  
  //  
  *nStatus = 0;

  // ,     
  if(lpECB->cbTotalBytes != 0)
  {
    //       
    if(!(lpTemp = (LPVOID)LocalAlloc(LPTR, 
      lpECB->cbTotalBytes)))
	  {
      //    ,  
      //      
      //  NULL
      *nStatus = HSE_STATUS_ERROR;
      return NULL;
    }

    //      
    memcpy(lpTemp, lpECB->lpbData, lpECB->cbAvailable);
    
    //    
    //     
    nBufferPos = lpECB->cbAvailable;
 
	  // ,    
    //     ReadClient
    nBytesToCopy = lpECB->cbTotalBytes - lpECB->cbAvailable;
	  
    // cbReaded = nBytesToCopy;

    //         
    // ,     
    if(nBytesToCopy > 0)
    {
      while(1)
	    {
        //      
        //  
        lpECB->ReadClient(lpECB->ConnID, 
			    (LPVOID)((LPSTR)lpTemp + nBufferPos), &cbReaded);
		
		    //    nBytesToCopy,
        //      
        nBytesToCopy -= cbReaded;

        //      
        //     
        nBufferPos   += cbReaded;
		
        //    ,  
        if(nBytesToCopy <= 0l)
		      break;
	    }
	  }

	  //     
    //     
    return lpTemp;
  }
  
  //     , 
  //     
  else
  {
    *nStatus = HSE_STATUS_ERROR;

    //      
    //    
    //  NULL
    return NULL;
  }
}

// =============================================================
//  GetMIMEBoundary
//    .
// :
//   lpDataMIME -     MIME
//   lpBuffer   -     
//   dwBufSize  -     MIME
// =============================================================
BOOL GetMIMEBoundary(LPVOID lpDataMIME, LPSTR lpBuffer, DWORD dwBufSize)
{
  LPSTR lpCurrent;
  DWORD dwOffset;
  BOOL  fFound;
  
  //    
  fFound = TRUE;

  //    
  for(lpCurrent = lpDataMIME, 
    dwOffset = 0;;lpCurrent++, dwOffset++)
  {
    //    
    if(!memcmp(lpCurrent,"\r\n",2))
      break;
    
    //    ,
    //    
    //    
    if(dwOffset >= dwBufSize)
    {
      fFound = FALSE;
      break;
    }

    //    
    *(lpBuffer + dwOffset) = *lpCurrent;
  }
  
  //   ,  
  //   
  if(fFound)
    *lpBuffer = '\0';  

  //    
  //  
  return fFound;
}







