// ===============================================
//  ISAPI isform.c
//  ,   ,
//    ISAPI
//
// (C)  .., 1997
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//         
//         http://www.dials.ccas.ru/frolov
// ===============================================

#include <windows.h>
#include <httpext.h>

//   
void DecodeStr(char *szString);
char DecodeHex(char *str);

// =============================================================
//  GetExtensionVersion
//    ISAPI 
//   
// =============================================================
BOOL WINAPI GetExtensionVersion(HSE_VERSION_INFO *pVer)
{
  //    ISAPI
  pVer->dwExtensionVersion = 
    MAKELONG(HSE_VERSION_MINOR,HSE_VERSION_MAJOR );

  //    
  lstrcpyn(pVer->lpszExtensionDesc,
    "Form Parser ISAPI DLL", HSE_MAX_EXT_DLL_NAME_LEN);

  return TRUE;
}

// =============================================================
//  HttpExtensionProc
// =============================================================
DWORD WINAPI HttpExtensionProc(EXTENSION_CONTROL_BLOCK *lpECB)
{
  CHAR  szBuff[4096];
  CHAR  szTempBuf[4096];
  char * szPtr;
  char * szParam;
  
  //    -   
  lpECB->dwHttpStatusCode = 0;

  //     HTTP  
  //     HTML
  wsprintf(szBuff,
    "Content-Type: text/html\r\n\r\n"
    "<HTML><HEAD><TITLE>Simple ISAPI Extension</TITLE></HEAD>\n"
    "<BODY BGCOLOR=#FFFFFF><H2>Information from ECB</H2>\n");

  //    ISAPI
  wsprintf(szTempBuf, "<P>Extension Version: %d.%d", 
    HIWORD(lpECB->dwVersion), LOWORD(lpECB->dwVersion));
  strcat(szBuff, szTempBuf);
  
  //    
  wsprintf(szTempBuf, "<BR>Method: %s", lpECB->lpszMethod);
  strcat(szBuff, szTempBuf);
  
  //     ISAPI
  wsprintf(szTempBuf, "<BR>QueryString: %s", 
    lpECB->lpszQueryString);
  strcat(szBuff, szTempBuf);
  
  //       ISAPI
  wsprintf(szTempBuf, "<BR>PathTranslated: %s", 
    lpECB->lpszPathTranslated);
  strcat(szBuff, szTempBuf);

  //   ,   
  wsprintf(szTempBuf, "<BR>TotalBytes: %d", 
    lpECB->cbTotalBytes);
  strcat(szBuff, szTempBuf);

  //     
  wsprintf(szTempBuf, "<BR>Available: %d", 
    lpECB->cbAvailable);
  strcat(szBuff, szTempBuf);

  //  
  wsprintf(szTempBuf, "<BR>ContentType: %s", 
    lpECB->lpszContentType);
  strcat(szBuff, szTempBuf);

  lstrcpyn(szTempBuf, lpECB->lpbData, lpECB->cbAvailable + 1);
  szTempBuf[lpECB->cbAvailable + 1] = '\0';
  
  strcat(szBuff, "<H2> </H2>");
  strcat(szBuff, szTempBuf);

  //     
  // 
  DecodeStr(szTempBuf);

  strcat(szBuff, "<H2>  </H2>");
  strcat(szBuff, szTempBuf);

  //       
  strcat(szBuff, "<H2>  </H2>");

  szTempBuf[lpECB->cbAvailable] = '&';
  szTempBuf[lpECB->cbAvailable + 1] = '\0';
  
  for(szParam = szTempBuf;;)
  {
      szPtr = strchr(szParam, '&');
      if(szPtr != NULL)
      {
        *szPtr = '\0';
        DecodeStr(szParam);
        strcat(szBuff, szParam);
        strcat(szBuff, "<BR>");

        szParam = szPtr + 1;
        if(szParam >= (szTempBuf + lpECB->cbAvailable))
          break;
      }
      else
        break;
    }


  //    HTML
  strcat(szBuff, "</BODY></HTML>");  

  //     
  if(!lpECB->ServerSupportFunction(lpECB->ConnID,
    HSE_REQ_SEND_RESPONSE_HEADER, NULL, NULL, 
    (LPDWORD)szBuff))
  {
    //     , 
    //     ISAPI 
    //   
    return HSE_STATUS_ERROR;
  }

  //    
  lpECB->dwHttpStatusCode = 200;
  
  //      
  return HSE_STATUS_SUCCESS;
}

// ------------------------------------------------
//  DecodeStr
//     URL
// ------------------------------------------------
void DecodeStr(char *szString)
{
  int src;
  int dst;
  char ch;

  //   
  for(src=0, dst=0; szString[src]; src++, dst++)
  {
    //     
    ch = szString[src];

    //   "+"  
    ch = (ch == '+') ? ' ' : ch;
    
    //  
    szString[dst] = ch;
    
    //     "%xx"
    if(ch == '%')
    {
      //    "%xx"
      //   
      szString[dst] = DecodeHex(&szString[src + 1]);
      src += 2;
    }
  }
  
  //    
  szString[dst] = '\0';
}

// ------------------------------------------------
//  DecodeHex
//   "%xx"
// ------------------------------------------------
char DecodeHex(char *str)
{
  char ch;

  //   
  if(str[0] >= 'A')
    ch = ((str[0] & 0xdf) - 'A') + 10;
  else
    ch = str[0] - '0';

  //     4 
  ch <<= 4;

  //     
  //   
  if(str[1] >= 'A')
    ch += ((str[1] & 0xdf) - 'A') + 10;
  else
    ch += str[1] - '0';

  //   
  return ch;
}
