// =========================================================
//        RandomAccessFile
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.io.*;
import java.util.*;

// =========================================================
//  DirectFileAccess
//   
// =========================================================
public class DirectFileAccess
{
  // -------------------------------------------------------
  // main
  // ,     
  // -------------------------------------------------------
  public static void main(String args[])
  {
    //      
    byte bKbdInput[] = new byte[256];

    try
    {
      //    
      SimpleDBMS db = new SimpleDBMS("dbtest.idx", "dbtest.dat");
      
      //     
      db.AddRecord("Ivanov",   1000);
      db.AddRecord("Petrov",   2000);
      db.AddRecord("Sidoroff", 3000);
 
      //      
      //    2, 1  0
      System.out.println(db.GetRecordByNumber(2));
      System.out.println(db.GetRecordByNumber(1));
      System.out.println(db.GetRecordByNumber(0));

      //   
      db.close();
      
      //       
      System.out.println("Press <Enter> to terminate...");
      System.in.read(bKbdInput);
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }
}

// =========================================================
//  SimpleDBMS
//   
// =========================================================
class SimpleDBMS
{
  //  
  RandomAccessFile idx;

  //  
  RandomAccessFile dat;

  //     
  long idxFilePointer = 0;

  // -------------------------------------------------------
  // SimpleDBMS
  // .      
  // -------------------------------------------------------
  public SimpleDBMS(String IndexFile, String DataFile)
  {
    try
    {
      //     
      idx = new RandomAccessFile(IndexFile, "rw");

      //     
      dat = new RandomAccessFile(DataFile, "rw");
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }

  // -------------------------------------------------------
  // close
  //  close.    
  // -------------------------------------------------------
  public void close()
  {
    try
    {
      //   
      idx.close();

      //   
      dat.close();
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }

  // -------------------------------------------------------
  // AddRecord
  //     
  // -------------------------------------------------------
  public void AddRecord(String name, int account)
  {
    try
    {
      //     
      //      
      idx.seek(idx.length());
      dat.seek(dat.length());

      //        ,
      //     
      idxFilePointer = dat.getFilePointer();

      //      
      idx.writeLong(idxFilePointer);

      //        
      dat.writeBytes(name + "\r\n");
      dat.writeInt(account);
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }

  // -------------------------------------------------------
  // GetRecordByNumber
  //      
  // -------------------------------------------------------
  public String GetRecordByNumber(long nRec)
  {
    // ,      
    String sRecord = "<empty>";
 
    try
    {
      //   account
      Integer account;

      //   name
      String str = null;

      //       
      //  
      idx.seek(nRec * 8);

      //      
      //   
      idxFilePointer = idx.readLong();

      //     
      //   
      dat.seek(idxFilePointer);
  
      //   
      str = dat.readLine();
      account = new Integer(dat.readInt());

      //      
      sRecord = new String("> " + account + ", " + str);
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }

    //   
    return sRecord;
  }
}