// =========================================================
//     
//
// (C)  ., 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.applet.*;
import java.awt.*;

public class HorzScroll extends Applet implements Runnable
{
	//      
  Thread m_HorzScroll = null;

	//    
  private String m_Str   = "Hello from Java!";
	private String m_Fnt   = "Helvetica";
	private String m_style = "BOLD";
	private int m_size     = 12;
	private String m_color = "red";
	private int m_delay    = 50;

	//  
  private final String PARAM_str   = "str";
	private final String PARAM_font  = "font";
	private final String PARAM_style = "style";
	private final String PARAM_size  = "size";
	private final String PARAM_color = "color";
	private final String PARAM_delay = "delay";

	// -------------------------------------------------------
  // getAppletInfo
  // ,     
  // -------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: HorzScroll\r\n" +
      "Author: Alexandr Frolov\r\n" +
      "E-mail: frolov@glas.apc.org" +
      "WWW:    http://www.glasnet.ru/~frolov" +
      "Created with Microsoft Visual J++ Version 1.0";
	}

	// -------------------------------------------------------
  // getParameterInfo
  //   
  // -------------------------------------------------------
	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_str,   "String", "String to draw" },
			{ PARAM_font,  "String", "Font name" },
			{ PARAM_style, "String", "Font style" },
			{ PARAM_size,  "String", "Font size" },
			{ PARAM_color, "String", "String color" },
			{ PARAM_delay, "int",    "Output delay" },
		};
		return info;		
	}

	// -------------------------------------------------------
  // init
  // ,     
  // -------------------------------------------------------
	public void init()
	{
    //  
    String param;

		//   
    param = getParameter(PARAM_str);
		if (param != null)
			m_Str = param;

		param = getParameter(PARAM_font);
		if (param != null)
			m_Fnt = param;

		param = getParameter(PARAM_style);
		if (param != null)
			m_style = param;

		param = getParameter(PARAM_size);
		if (param != null)
			m_size = Integer.parseInt(param);

		param = getParameter(PARAM_color);
		if (param != null)
			m_color = param;

		param = getParameter(PARAM_delay);
		if (param != null)
			m_delay = Integer.parseInt(param);
	}

  // -------------------------------------------------------
  // paint
  //  paint,     
  // -------------------------------------------------------
	public void paint(Graphics g)
	{
    //     
    Dimension dimAppWndDimension = size();

    //     
    dimAppWndDimension = size();
    
    //      
    g.setColor(Color.yellow);
    
    //     
    g.fillRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);

    //      
    g.setColor(Color.black);

    //     
    g.drawRect(0, 0, 
      dimAppWndDimension.width  - 1, 
      dimAppWndDimension.height - 1);
	}

  // -------------------------------------------------------
  // start
  //       
  // -------------------------------------------------------
	public void start()
	{
		if (m_HorzScroll == null)
		{
			m_HorzScroll = new Thread(this);
			m_HorzScroll.start();
		}
	}
	
  // -------------------------------------------------------
  // stop
  //  ,      
  // -------------------------------------------------------
	public void stop()
	{
		if (m_HorzScroll != null)
		{
			m_HorzScroll.stop();
			m_HorzScroll = null;
		}
	}

	// -------------------------------------------------------
  // run
  // ,      
  //       
  // -------------------------------------------------------
	public void run()
	{
    //   
    Graphics g = getGraphics();

    //     
    if(m_style.equals("BOLD"))
      g.setFont(new Font(m_Fnt, Font.BOLD, m_size));

    else if(m_style.equals("ITALIC"))
      g.setFont(new Font(m_Fnt, Font.ITALIC, m_size));

    else 
      g.setFont(new Font(m_Fnt, Font.PLAIN, m_size));

    //     
    if(m_color.equals("red"))
      g.setColor(Color.red);

    else if(m_color.equals("green"))
      g.setColor(Color.green);

    else 
      g.setColor(Color.black);
    
    //    
    Dimension dimAppWndDimension = size();

    //    
    FontMetrics fm = g.getFontMetrics();

    //     
    int nCurrentChar = 0;

    //     
    int yPos = fm.getHeight() + 5;

    //      
    int nCurrentXPos = 10;

    //     
    int nCurrentCharWidth;
    
    //   
    while (true)
		{
			try
			{
        try
        {
          //    
          nCurrentCharWidth = 
            fm.charWidth(m_Str.charAt(nCurrentChar));

          //       
          char[] ch;
    
          //  
          String s;

          //     
          ch = new char[1];

          //      
          ch[0] = m_Str.charAt(nCurrentChar);
    
          //   
          s = new String(ch);

          //      
          g.drawString(s, nCurrentXPos, yPos);

          //     
          //  
          nCurrentXPos += nCurrentCharWidth;

          //      
          nCurrentChar++;
        }
        //     
        catch (StringIndexOutOfBoundsException e)
        {
          //     
          //  
          nCurrentChar = 0;
          nCurrentXPos = 10;

          //   
          repaint();

          //    
          try
          {
            Thread.sleep(500);
          }
          catch (InterruptedException ee)
          {
            stop();
          }
        }

        //             
				Thread.sleep(m_delay);
			}
			catch (InterruptedException e)
			{
				stop();
			}
		}
	}
}
