#include <dos.h>
#include <bios.h>
#include <alloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <ctype.h>

typedef struct _DFCB_
{
  unsigned handl_num;
  unsigned char access_mode;
  unsigned reserv1;
  unsigned dev_info;
  void far *driver;
  unsigned first_clu;
  unsigned time;
  unsigned date;
  unsigned long fl_size;
  unsigned long offset;
  unsigned reserv2;
  unsigned reserv7;
  unsigned reserv3;
  char reserv4;
  char filename[11];
  char reserv5[6];
  unsigned ownr_psp;
  unsigned reserv6;
  unsigned last_clu;
  char reserv8[4];
} DFCB;
typedef DFCB far* LPDFCB;

typedef struct _DFT_
{
  struct _DFT_ far *next;
  unsigned file_count;
  DFCB dfcb;
} SFT;
typedef SFT far* LPSFT;

typedef struct
{
  unsigned mcb_seg;
  void far *dev_cb;
  void far *file_tab;
  void far *clock_dr;
  void far *con_dr;
  unsigned max_btbl;
  void far *disk_buf;
  void far *drv_info;
  void far *fcb_tabl;
  unsigned fcb_size;
  unsigned char num_bdev;
  unsigned char lastdriv;
} CVT;
typedef CVT far* LPCVT;

typedef struct _EBPB_
{
  unsigned sectsize;
  char clustsize;
  unsigned ressecs;
  char fatcnt;
  unsigned rootsize;
  unsigned totsecs;
  char media;
  unsigned fatsize;
  unsigned seccnt;
  unsigned headcnt;
  unsigned hiddensec_low;
  unsigned hiddensec_hi;
  unsigned long drvsecs;
} EBPB;

typedef struct _BOOT_
{
  char jmp[3];
  char oem[8];
  EBPB bpb;
  char drive;
  char reserved;
  char signature;
  unsigned volser_lo;
  unsigned volser_hi;
  char label[11];
  char fat_format[8];
  char boot_code[450];
} BOOT;

LPSFT get_fsft(LPCVT cvt);
LPSFT get_nsft(LPSFT sft);
void show(DFCB far *);
int getboot(BOOT far *boot, int drive);

union REGS   regs;
struct SREGS sregs;

int main(int argc, char *argv[])
{
  CVT far *cvt;
  SFT far *sft;
  unsigned i,j,k;
  DFCB far *dfcb, far *file_dfcb;
  int handle, flag, disk;

  BOOT far *boot_rec;
  int status;
  char *buf;

  char drive[128], dir[128];
  char fname[20], ext[10];
  char name[12];

  printf("ଠ   䠩 DOS, "
    "Frolov A., (C) 1995\n");

  // 뢠 䠩,  ண 㤥
  //  ᯨ᮪ ஢
  handle = open(argv[1], O_BINARY);
  if(handle == 0)
  {
    printf("訡  ⨨ 䠩\n");
    return(-1);
  }

  //    䠩  :
  //   - ;
  //   - ⠫;
  //   -  䠩;
  //   - ७ 
  _splitpath(argv[1], drive, dir, fname, ext);

  if(drive[0] == '\0' || dir[0] == '\0' || argc < 2)
  {
    printf("\n    䠩\n");
    return(-1);
  }

  printf("᫥㥬 ᯮ 䠩 '%s'",
    argv[1]);

  // 㥬 ப    ७
  strcpy(name, fname);
  for(i = 0; i < 8; i++)
  {
    if(name[i] == 0) break;
  }
  for(; i < 8; i++) name[i] = ' ';
  name[8] = 0;

  strcat(name, &ext[1]);
  for(i = 8; i < 12; i++)
  {
    if(name[i] == 0) break;
  }
  for(; i < 12; i++) name[i] = ' ';
  name[12] = 0;

  // ८ࠧ㥬 ப    㪢
  strupr(name);

  // 塞  ᪠
  drive[0] = toupper(drive[0]);
  disk = drive[0] - 'A';

  // 砥  ୮ ⠡ 裡
  regs.h.ah = 0x52;
  intdosx(&regs, &regs, &sregs);

  // । 㪠⥫   msb_seg
  cvt = (LPCVT)MK_FP(sregs.es, regs.x.bx - 2);

  //  砫 ⠡ 䠩
  sft = get_fsft(cvt);

  // 뢠 䫠 ᪠ 䠩
  flag = 0;

  for(;;)
  {
    //  ⠡ 䠩
    if(sft == (SFT far *)NULL) break;
    i = sft->file_count;

    for(j=0;j<i;j++)
    {
      dfcb = (&(sft->dfcb)) + j;

      // 饬 䠩  ⠡  䠩
      k = _fmemcmp((const void far*)name,
        (const void far*)dfcb->filename, 11);
      if(k == 0)
      {
	printf("\nDFCB 䠩:                   "
               " %Fp", dfcb);

        //   ⠡
        //   䠩
        file_dfcb = dfcb;

        // 뢠 ᮤন ⠡
        show(file_dfcb);
	flag = 1;
	break;
      }
    }
    if(flag == 1) break;

    sft = get_nsft(sft);
  }

  if(flag == 0)
  {
    printf("  ");
    close(handle);
    return(-1);
  }

  // 뢠   ⥭ 㧮筮 
  boot_rec = (BOOT far*)farmalloc(sizeof(*boot_rec));
  if(boot_rec == NULL)
  {
    printf(" ");
    close(handle);
    return(-1);
  }

  // ⠥ 㧮   
  status = getboot((BOOT far*)boot_rec, disk);

  // 塞 ࠧ   
  i = boot_rec->bpb.clustsize * boot_rec->bpb.sectsize;
  printf(" ,  :        %d",i);

  // ᫨ ந諠 訡 (ਬ, ࠢ쭮 㪠
  // 祭 ᪠), 蠥 ࠡ ணࠬ
  if(status)
  {
    printf("\n訡  ⥭ 㧮筮 ᥪ");
    close(handle);
    return(-1);
  }

  buf = (char*)malloc(i);
  if(buf == NULL)
  {
    printf(" ");
    close(handle);
    return(-1);
  }

  printf("\n᮪ ஢ 䠩:\n");

  // ⠥ 䠩  ࠬ, 뢮 
  // ᫥ ⠭ , 
  // ६  ⠡ 䠩
  for(;;)
  {
    read(handle, buf, i);
    if(eof(handle)) break;
    printf("%u ",file_dfcb->last_clu);
  }

  close(handle);
  farfree(boot_rec);
  free(buf);
  return(0);
}

// 㭪  ⮡ࠦ ᮤন ⠡ 䠩
void show(DFCB far *dfcb)
{
  int k;

  printf("\n 䠩:                     ");
  for(k = 0; k < 11; k++)
  {
    putchar(dfcb->filename[k]);
  }

  printf("\n⢮ 䨪஢:    %d\n"
    " 㯠:                 %d\n"
    " reserv1:                  %04X\n"
    "ଠ  ன⢥:      %04X\n"
    " ࠩ:                %Fp\n"
    "砫 :             %u\n"
    "६:                         %04X\n"
    ":                          %04X\n"
    " 䠩  :         %ld\n"
    "饥 ᬥ饭  䠩:      %ld\n"
    " reserv2:                  %04X\n"
    "᫥ ⠭ : %u\n"
    " PSP  䠩:   %04X\n"
    " reserv7:                  %u\n",
    dfcb->handl_num, dfcb->access_mode,
    dfcb->reserv1, dfcb->dev_info,
    dfcb->driver, dfcb->first_clu,
    dfcb->time,	dfcb->date, dfcb->fl_size,
    dfcb->offset, dfcb->reserv2, dfcb->last_clu,
    dfcb->ownr_psp, dfcb->reserv7);
}

LPSFT get_nsft(LPSFT sft)
{
  LPSFT sft_next;

  sft_next = sft->next;
  if(FP_OFF(sft_next) == 0xffff)
    return((LPSFT)NULL);

  return(sft_next);
}

LPSFT get_fsft(LPCVT cvt)
{
  LPSFT sft;
  sft = (LPSFT)cvt->file_tab;
  return(sft);
}

int getboot(BOOT far *boot, int drive)
{
  struct
  {
    unsigned long first_sect;
    unsigned nsect;
    void far* buf;
  } cb;

  cb.first_sect = 0;
  cb.nsect = 1;
  cb.buf = (void far*)boot;

  _BX  = FP_OFF(&cb);
  _DS = FP_SEG(&cb);
  _CX  = 0xffff;
  _DX  = 0;
  _AX  = drive;
  asm int 25h
  asm pop ax
  asm jc err

  return 0;
err:
  return 1;
}
