#include <dos.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct
{
  unsigned mcb_seg;
  void far *dev_cb;
  void far *file_tab;
  void far *clock_dr;
  void far *con_dr;
  unsigned max_btbl;
  void far *disk_buf;
  void far *drv_info;
  void far *fcb_tabl;
  unsigned fcb_size;
  unsigned char num_bdev;
  unsigned char lastdriv;
} CVT;
typedef CVT far* LPCVT;

typedef struct _DDCB_
{
  unsigned char drv_num;
  unsigned char drv_numd;
  unsigned sec_size;
  unsigned char clu_size;
  unsigned char clu_base;
  unsigned boot_siz;
  unsigned char fat_num;
  unsigned max_dir;
  unsigned data_sec;
  unsigned hi_clust;
  unsigned char fat_size;
  char reserv1;
  unsigned root_sec;
  void far *drv_addr;
  unsigned char media;
  unsigned char acc_flag;
  struct _DDCB_ far *next;
  unsigned reserv2;
  unsigned built;
} DDCB;
typedef DDCB far* LPDDCB;

void main(void);
LPDDCB get_fddcb(LPCVT cvt);
LPDDCB get_nddcb(LPDDCB ddcb);

void main(void)
{
  union REGS regs;
  struct SREGS sregs;
  LPCVT     lpCVT;
  LPDDCB    lpDDCB;

  printf("\n ࠢ ᪮묨 ன⢠ DDCB"
    "\n(C) ஫ .., 1995\n\n");

  // 砥  ୮ ⠡ 裡
  regs.h.ah = 0x52;
  intdosx(&regs, &regs, &sregs);

  // । 㪠⥫   msb_seg
  lpCVT = (LPCVT)MK_FP(sregs.es, regs.x.bx - 2);

  // 砥  ࢮ  DDCB
  lpDDCB = get_fddcb(lpCVT);

  for(;;)
  {
    // ᫨  ᫥ , 蠥 横
    if(lpDDCB == NULL) break;
      printf(" DDCB:                         %Fp\n"
	" ன⢠:                   %d\n"
	"⥫ :               %d\n"
	" ᥪ:                     %d\n"
	"   ᥪ:         %d\n"
	" ࠧ :              %d\n"
	"१ࢨ஢ ᥪ஢:           %d\n"
	"᫮  FAT:                    %d\n"
	". 䠩  ୥ ⠫ :  %d\n"
	"  :              %d\n"
	"ᥣ ஢:                    %ld\n"
	" FAT  ᥪ:              %d\n"
	" ᥪ ୥ ⠫:   %d\n"
	" reserv1:                       %01X\n"
	" ࠩ:                     %Fp\n"
	" ⥫ । ⥫:      %01X\n"
	" 㯠:                       %01X\n"
	" ᫥饣 DDCB:              %Fp\n"
	" reserv2:                       %04X\n"
	" :                      %04X\n"
	"-------------------------------------\n\n",
	 lpDDCB, lpDDCB->drv_num,  lpDDCB->drv_numd,
	 lpDDCB->sec_size, lpDDCB->clu_size,
	 lpDDCB->clu_base, lpDDCB->boot_siz,
	 lpDDCB->fat_num,  lpDDCB->max_dir,
	 lpDDCB->data_sec, lpDDCB->hi_clust,
	 lpDDCB->fat_size, lpDDCB->root_sec,
	 lpDDCB->reserv1,  lpDDCB->drv_addr,
	 lpDDCB->media,    lpDDCB->acc_flag,
	 lpDDCB->next,     lpDDCB->reserv2,
	 lpDDCB->built);

      // 砥  ᫥饣  DDCB
      lpDDCB = get_nddcb(lpDDCB);
  }
}

// ---------------------------------------------
// get_fddcb
// 㭪 頥  ࢮ  DDCB.
//  ⢥ ࠬ  ᫥ ।
//  ୮ ⠡ 裡
// ---------------------------------------------
LPDDCB get_fddcb(LPCVT cvt)
{
  LPDDCB ddcb;
  ddcb = (LPDDCB)cvt->dev_cb;
  return(ddcb);
}

// ---------------------------------------------
// get_nddcb
// 㭪 頥  ᫥饣  DDCB
// ---------------------------------------------
LPDDCB get_nddcb(LPDDCB ddcb)
{
  LPDDCB ddcb_n;

  ddcb_n = (LPDDCB)ddcb->next;
  if(FP_OFF(ddcb_n) == 0xffff)
    return((LPDDCB)NULL);
  return(ddcb_n);
}

