// -----------------------------------------------------
//      DDEML
//  DDEML
// -----------------------------------------------------
#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <ddeml.h>
#include <dde.h>
#include <mem.h>
#include <string.h>
#pragma hdrstop

#include "ddemlcl.hpp"

HDDEDATA EXPENTRY _export
DDEClientCallback(WORD wType, WORD wFmt, HCONV hConv,
  HSZ hsz1, HSZ hsz2, HDDEDATA hData,
  DWORD dwData1, DWORD dwData2);

//    DDEML
DWORD   idInst;

//     DDE
FARPROC lpDdeProc;

HSZ hszService;
HSZ hszTopic;
HSZ hszItem;

HDDEDATA hData;
DWORD    dwResult;
WORD     wFmt = CF_TEXT;

//-----------------------------------------------------
//  DDEClientOpen
//  DDEML,   
//-----------------------------------------------------
HCONV DDEClientOpen(HINSTANCE hInst,
  LPSTR szService, LPSTR szTopic, LPSTR szItem)
{
  HCONV hConv = NULL;
  
  //      
  lpDdeProc =
    MakeProcInstance((FARPROC)DDEClientCallback, hInst);

  //  DDEML
  if(DdeInitialize((LPDWORD)&idInst, (PFNCALLBACK)lpDdeProc,
       APPCMD_CLIENTONLY, 0L))
  {
    return NULL;
  }
  else
  {
    //    
    //    , 
    //   
    hszService =
      DdeCreateStringHandle(idInst, szService, CP_WINANSI);
    hszTopic   =
      DdeCreateStringHandle(idInst, szTopic, CP_WINANSI);
    hszItem    =
      DdeCreateStringHandle(idInst, szItem, CP_WINANSI);

    //   
    hConv =
      DdeConnect(idInst, hszService, hszTopic, (PCONVCONTEXT)NULL);

    //     
    return hConv;
  }
}

//-----------------------------------------------------
//  DDEClientClose
//     DDEML
//-----------------------------------------------------
void DDEClientClose(HCONV hConv)
{
  //   
  if(hConv != NULL)
  {
    DdeDisconnect(hConv);
    hConv = NULL;
  }

  //   
  DdeFreeStringHandle(idInst, hszService);
  DdeFreeStringHandle(idInst, hszTopic);
  DdeFreeStringHandle(idInst, hszItem );

  //       
  FreeProcInstance(lpDdeProc);
}

//-----------------------------------------------------
//  DDESend
//    
//-----------------------------------------------------
BOOL DDESend(HCONV hConv, LPSTR szString)
{
  if(hConv != NULL)
  {
    //   
    hData = DdeCreateDataHandle (idInst, szString,
       lstrlen(szString) + 1, 0L, hszItem, CF_TEXT, 0);

    //    
    if(hData != NULL)
      hData = DdeClientTransaction((LPBYTE)hData, -1, hConv,
        hszItem, CF_TEXT, XTYP_POKE, 1000, &dwResult);
      if(hData != NULL)
        return TRUE;
      else
        return FALSE;
  }
  else
    return FALSE;
}

//-----------------------------------------------------
//  DDEReceive
//     
//-----------------------------------------------------
BOOL DDEReceive(HCONV hConv, LPSTR szBuf, int nBufSize)
{
  //    
  if(hConv != NULL)
  {
    hData = DdeClientTransaction(NULL, 0, hConv,
       hszItem, CF_TEXT, XTYP_REQUEST, 1000, &dwResult);

    //     
    if(hData != NULL)
    {
      DdeGetData(hData, szBuf, nBufSize, 0L);
      return TRUE;
    }
    else
      return FALSE;
  }
  else
    return FALSE;
}

//-----------------------------------------------------
//  DDEClientCallback
//      DDEML
//-----------------------------------------------------
#pragma argsused
HDDEDATA EXPENTRY
DDEClientCallback(WORD wType, WORD wFmt, HCONV hConvX, HSZ hsz1,
    HSZ hsz2, HDDEDATA hData, DWORD dwData1, DWORD dwData2)
{
  switch(wType)
  {
    case XTYP_DISCONNECT:
      return((HDDEDATA) NULL);

    case XTYP_ERROR:
      break;

    case XTYP_XACT_COMPLETE:
      break;
  }
  return((HDDEDATA)NULL);
}

