#include <stdio.h>
#include <dos.h>

typedef struct _DISK_CONFIG_
{
  int  n_floppy;
  int  n_hard;
  int  t_floppy1;
  int  t_floppy2;
  int  t_hard1;
  int  t_hard2;
} DISK_CONFIG;

typedef struct _DPT_
{
  unsigned char srt_hut;
  unsigned char dma_hlt;
  unsigned char motor_w;
  unsigned char sec_size;
  unsigned char eot;
  unsigned char gap_rw;
  unsigned char dtl;
  unsigned char gap_f;
  unsigned char fill_char;
 unsigned char hst;
 unsigned char mot_start;
} DPT;

typedef struct _HDPT_
{
  unsigned max_cyl;
  unsigned char max_head;
  unsigned srwcc;
  unsigned swpc;
  unsigned char max_ecc;
  unsigned char dstopt;
  unsigned char st_del;
  unsigned char fm_del;
  unsigned char chk_del;
  char reserve[4];
} HDPT;

void disk_cfg(DISK_CONFIG* cfg);
DPT far *get_dpt(void);
HDPT far *get_hdp1(void);
HDPT far *get_hdp2(void);

void main(void)
{
  DISK_CONFIG cfg;
  DPT  far *dpt_ptr;
  HDPT far *hdpt1_ptr;
  HDPT far *hdpt2_ptr;

  printf("\n"
    "\n䨣 ᪮ ⥬"
    "\n  (C)஫ ., 1995\n");

  // ।塞 䨣 ᪮ ⥬
  disk_cfg(&cfg);

  printf("\n⠭:"
    "\n   : %d"
    "\n   :  %d",
    cfg.n_floppy, cfg.n_hard);

  printf("\n :  A: - %d, B: - %d"
         "\n :   C: - %d, D: - %d",
    cfg.t_floppy1, cfg.t_floppy2,
    cfg.t_hard1,   cfg.t_hard2);

  // 砥  ⠡ ࠬ஢ ᪥
  dpt_ptr = get_dpt();

  printf("\n"
    "\n ࠧ ᥪ ᪥:           %d"
    "\n騩 ᨬ  ଠ஢: %2.2X",
    dpt_ptr->sec_size, dpt_ptr->fill_char);

  // 砥  ࢮ  ன ⠡
  // ࠬ஢ ⪮ ᪠
  hdpt1_ptr = get_hdp1();
  hdpt2_ptr = get_hdp2();

  printf("\n"
    "\nࠬ ࢮ :"
    "\n   ⢮ ஦:       %d"
    "\n   ⢮ :       %d"
    "\n"
    "\nࠬ ண ᪠:"
    "\n   ⢮ ஦:       %d"
    "\n   ⢮ :       %d",
    hdpt1_ptr->max_cyl,  hdpt1_ptr->max_head,
    hdpt2_ptr->max_cyl,  hdpt2_ptr->max_head);
}

/**
* disk_cfg
*
* । 䨣 ᪮ ⥬
*
* 㭪  , 뢠
* 䨣 ᪮ ⥬:
*
* typedef struct _DISK_CONFIG_
* {
*   int  n_floppy;
*   int  n_hard;
*   int  t_floppy1;
*   int  t_floppy2;
*   int  t_hard1;
*   int  t_hard2;
* } DISK_CONFIG;
*
**/

void disk_cfg(DISK_CONFIG* cfg)
{
  char unsigned far *modptr;
  char unsigned pc_type;
  char cfg_byte;
  int  cfg_word;

  union REGS inregs, outregs;

  // ।塞 ⨯ 
  modptr = (char unsigned far*)MK_FP(0xf000, 0xfffe);
  pc_type = *modptr;

  //  ᨬ  ⨯  롨ࠥ
  // ᯮᮡ । 䨣樨 ᪮
  // ⥬
  switch (pc_type)
  {
    case 0xfc:

      //  IBM AT 뢠 䨣 ᪮
      // ⥬  -

      // 뢠  䨣樨
      outp(0x70, 0x14);
      cfg_byte = inp(0x71);

      // ।塞 ⢮ ⠭ 
      if((cfg_byte & 1) == 0)
      {
        // ᫨ 訩   䨣樨 ࠢ 0,
        //  
        cfg->n_floppy  = 0;
        cfg->t_floppy1 = 0;
        cfg->t_floppy2 = 0;
      }
      else
      {
        // ।塞 ⢮ ⠭ 
	cfg->n_floppy = ((cfg_byte >> 6) & 3) + 1;

        // ।塞 ⨯ 
        outp(0x70, 0x10);
        cfg_byte = inp(0x71);

        cfg->t_floppy2 = cfg_byte & 0xf;
        cfg->t_floppy1 = (cfg_byte >> 4) & 0xf;
      }

      // ।塞 䨣 
      outp(0x70, 0x12);
      cfg_byte = inp(0x71);

      if(cfg_byte == 0)
      {
        // ᫨  ࠤ ࠢ , ⥬
        //  ᮤন 
	cfg->n_hard  = 0;
	cfg->t_hard1 = 0;
	cfg->t_hard2 = 0;
      }
      else
      {
        // ।塞 ⨯ ࢮ ᪠ - ᪠ C:
	if((cfg_byte & 0xf) != 0xf)
	  cfg->t_hard1 = cfg_byte & 0xf;
	else
        {
	  outp(0x70, 0x19);
	  cfg->t_hard1 = inp(0x71);
	}

        // ।塞 ⨯ ண ᪠ - ᪠ D:
	if((cfg_byte & 0xf0) != 0xf0)
	  cfg->t_hard2 = (cfg_byte >> 4) & 0xf;
        else
        {
	  outp(0x70, 0x1a);
	  cfg->t_hard2 = inp(0x71);
	}
      }

      // 塞 ⢮ , ⠭
      //  ⥬
      cfg->n_hard = 0;
      if(cfg->t_hard1 != 0) cfg->n_hard++;
      if(cfg->t_hard2 != 0) cfg->n_hard++;

      //   ᮢ⨬  IBM AT 設 
      // । ⨯ ᪠, ⠪   - 
      // ⨯ ᪠ ⠭ 祭 0, ᬮ  ,
      //   .  ⠪   ।
      // 稥 ⪮ ᪠, ᯮ ᫮
      // 䨣樨, 頥 뢠 INT 11h.

      if(cfg->n_hard == 0)
      {
        int86(0x11, &inregs, &outregs);
	cfg_word = outregs.x.ax;

        // ஢塞,   
	if((cfg_word & 1) != 0)
        {
	  cfg->n_hard =  1;

          // ⠥,  ⨯ ᯮ㥬 ⪮
          // ᪠ ।
	  cfg->t_hard1 = 0;
	  cfg->t_hard2 = 0;
	}
      }
      break;

    default:

      //  ⠫ ⨯ ஢ 뢠
      // 뢠 INT 11h, ᯮ㥬 頥
      // ⨬ 뢠  䨣樨
      int86(0x11, &inregs, &outregs);
      cfg_word = outregs.x.ax;

      // ।塞 ⢮ ⠭
      // 
      cfg->n_floppy = ((cfg_word >> 6) & 3) + 1;

      // ⠥,  ⨯ ᯮ㥬 
      // ।
      cfg->t_floppy1 = 0;
      cfg->t_floppy2 = 0;

      // ।塞 稥 
      if((cfg_word & 1) != 0)
      {
        cfg->n_hard =  1;

        // ⠥,  ⨯ ᯮ㥬 
        // ।
        cfg->t_hard1 = 0;
        cfg->t_hard2 = 0;
      }
      break;
  }
}

/**
* get_dpt
*
* ᫨  ⠡ ࠬ஢ ᪥
*
* 㭪 頥 㪠⥫  ⠡
* ࠬ஢ ᪥
*
**/

DPT far *get_dpt(void)
{
  void far * far *ptr;

  ptr = (void far * far *)MK_FP(0x0, 0x78);
  return(DPT far*)(*ptr);
}

/**
* get_hdp1
*
* ᫨  ࢮ ⠡ ࠬ஢ ᪠
*
* 㭪 頥 㪠⥫   ⠡
* ࠬ஢ ᪠
*
**/

HDPT far *get_hdp1(void)
{
  void far * far *ptr;

  ptr = (void far * far *)MK_FP(0x0, 0x104);
  return(HDPT far*)(*ptr);
}

/**
* get_hdp2
*
* ᫨  ࢮ ⠡ ࠬ஢ ᪠
*
* 㭪 頥 㪠⥫   ⠡
* ࠬ஢ ᪠
*
**/

HDPT far *get_hdp2(void)
{
  void far * far *ptr;

  ptr = (void far * far *)MK_FP(0x0, 0x118);
  return(HDPT far*)(*ptr);
}
