// ----------------------------------------
//     
//  
// ----------------------------------------

#define STRICT
#include <windows.h>
#include "dlgtab.hpp"

//  
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL    CALLBACK _export DlgProc(HWND, UINT, WPARAM, LPARAM);

//   
char const szClassName[]   = "DlgTabAppClass";

//  
char const szWindowTitle[] = "DlgTab Box Demo";

HINSTANCE hInst;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  //  
  if(!InitApp(hInstance))
      return FALSE;

  hInst = hInstance;

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,    
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 
  //     ,  
  if(!hwnd)
    return FALSE;

  //    
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    case WM_CREATE:
    {
      //    
      DialogBox(hInst, "SELECT", hwnd, (DLGPROC)DlgProc);

      //     
      //   
      DestroyWindow(hwnd);
      return 0;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// =====================================
//  DldProc
// =====================================
#pragma argsused

BOOL CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    //   
    case WM_INITDIALOG:
    {
      return TRUE;
    }

    case WM_COMMAND:
    {
      switch(wParam)
      {
        char Buffer[256];

        //    "OK"
        case IDOK:
        {
          //      
          GetDlgItemText(hdlg, IDC_NAME, Buffer, 80);

          lstrcat(Buffer, "\n\n:\n");

          //   
          //  RadioButton
          if(IsDlgButtonChecked(hdlg, IDC_PROGRAMMER))
          {
            lstrcat(Buffer, "");
          }
          else if(IsDlgButtonChecked(hdlg, IDC_ENGINIER))
          {
            lstrcat(Buffer, "");
          }
          else if(IsDlgButtonChecked(hdlg, IDC_SENGINIER))
          {
            lstrcat(Buffer, " ");
          }

          lstrcat(Buffer, "\n\n :\n");

          //   
          //  CheckBox
          if(IsDlgButtonChecked(hdlg, IDC_ENGLISH))
          {
            lstrcat(Buffer, "\n");
          }
          if(IsDlgButtonChecked(hdlg, IDC_C))
          {
            lstrcat(Buffer, "\n");
          }
          if(IsDlgButtonChecked(hdlg, IDC_PASCAL))
          {
            lstrcat(Buffer, "\n");
          }

          MessageBox(hdlg, Buffer, " ", MB_OK);
          return TRUE;
        }

        //   .
        case IDCANCEL:
        {
          //    
          EndDialog(hdlg, FALSE);
          return TRUE;
        }
      }
    }
  }
  return FALSE;
}
