// ----------------------------------------
//   
//   
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mmsystem.h>
#include <stdio.h>
#include <string.h>

// ===========================================
//  WinMain
// ===========================================

#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
		HINSTANCE hPrevInstance,
		LPSTR     lpszCmdLine,
		int       nCmdShow)
{
  FILE *out;     //   
  int i;         //  
  char buf[512];  //  

  UINT nMMSystemVersion;

  UINT nNumInDevs, nNumOutDevs;
  UINT nNumAuxDevs;
  UINT nNumMidiInDevs, nNumMidiOutDevs;
  UINT nNumJoyDevs;

  WAVEOUTCAPS wcapsOutCaps;
  WAVEINCAPS  wcapsInCaps;
  AUXCAPS     auxcaps;
  MIDIINCAPS  midicapsInCaps;
  MIDIOUTCAPS midicapsOutCaps;
  JOYCAPS     joycaps;
  TIMECAPS    timecaps; 

  DWORD dwFmt, dwSup;
  UINT wTech;

  //     
  //  
  if ((out = fopen("drvlist.txt", "wt")) == NULL)
  {
    MessageBox(NULL,
     "    drvlist.txt",
     "", MB_OK | MB_ICONSTOP);
    return 1;
  }

  //   
  fputs("* ================================= *\n", out);
  fputs("*   DRVLIST, (C) Frolov A.V., 1994  *\n", out);
  fputs("* ================================= *\n", out);

  nMMSystemVersion = mmsystemGetVersion();
  wsprintf(buf, "\n mmsystem.dll: %d.%d\n\n",
    HIBYTE(nMMSystemVersion),
    LOBYTE(nMMSystemVersion));

  //    
  fputs(buf, out);


  nNumInDevs      = waveInGetNumDevs();
  nNumOutDevs     = waveOutGetNumDevs();
  nNumAuxDevs     = auxGetNumDevs();
  nNumMidiInDevs  = midiInGetNumDevs();
  nNumMidiOutDevs = midiOutGetNumDevs();
  nNumJoyDevs     = joyGetNumDevs();

  for(i=0; i<nNumOutDevs; i++)
  {

    waveOutGetDevCaps(i, &wcapsOutCaps, sizeof(WAVEOUTCAPS));

    wsprintf(buf, "\n%s, v. %X, "
                  "wMid=%d, wPid=%d, wChannels=%d\n",
      (LPSTR)wcapsOutCaps.szPname,
      wcapsOutCaps.vDriverVersion,
      wcapsOutCaps.wMid,
      wcapsOutCaps.wPid,
      wcapsOutCaps.wChannels);

    dwFmt = wcapsOutCaps.dwFormats;
    dwSup = wcapsOutCaps.dwSupport;

    if(dwFmt & WAVE_FORMAT_1M08)
      strcat(buf, "11025 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_1S08)
      strcat(buf, "11025 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_1M16)
      strcat(buf, "11025 , ,\t16 \n");
    if(dwFmt & WAVE_FORMAT_1S16)
      strcat(buf, "11025 , ,\t16 \n");

    if(dwFmt & WAVE_FORMAT_2M08)
      strcat(buf, "22050 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_2S08)
      strcat(buf, "22050 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_2M16)
      strcat(buf, "22050 , ,\t16 \n");
    if(dwFmt & WAVE_FORMAT_2S16)
      strcat(buf, "22050 , ,\t16 \n");

    if(dwFmt & WAVE_FORMAT_4M08)
      strcat(buf, "44100 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_4S08)
      strcat(buf, "44100 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_4M16)
      strcat(buf, "44100 , ,\t16 \n");
    if(dwFmt & WAVE_FORMAT_4S16)
      strcat(buf, "44100 , ,\t16 \n");

    if(dwSup & WAVECAPS_PITCH)
      strcat(buf, "  \n");
    if(dwSup & WAVECAPS_PLAYBACKRATE)
      strcat(buf, "  \n");
    if(dwSup & WAVECAPS_SYNC)
      strcat(buf, " \n");
    if(dwSup & WAVECAPS_VOLUME)
      strcat(buf, " \n");
    if(dwSup & WAVECAPS_LRVOLUME)
      strcat(buf, "  \n");

    //    
    fputs(buf, out);
  }

  for(i=0; i<nNumInDevs; i++)
  {
    waveInGetDevCaps(i, &wcapsInCaps, sizeof(WAVEINCAPS));
    wsprintf(buf, "\n%s, v. %X, "
                  "wMid=%d, wPid=%d, wChannels=%d\n",
      (LPSTR)wcapsInCaps.szPname,
      wcapsInCaps.vDriverVersion,
      wcapsInCaps.wMid,
      wcapsInCaps.wPid,
      wcapsInCaps.wChannels);

    dwFmt = wcapsInCaps.dwFormats;

    if(dwFmt & WAVE_FORMAT_1M08)
      strcat(buf, "11025 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_1S08)
      strcat(buf, "11025 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_1M16)
      strcat(buf, "11025 , ,\t16 \n");
    if(dwFmt & WAVE_FORMAT_1S16)
      strcat(buf, "11025 , ,\t16 \n");

    if(dwFmt & WAVE_FORMAT_2M08)
      strcat(buf, "22050 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_2S08)
      strcat(buf, "22050 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_2M16)
      strcat(buf, "22050 , ,\t16 \n");
    if(dwFmt & WAVE_FORMAT_2S16)
      strcat(buf, "22050 , ,\t16 \n");

    if(dwFmt & WAVE_FORMAT_4M08)
      strcat(buf, "44100 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_4S08)
      strcat(buf, "44100 , ,\t8 \n");
    if(dwFmt & WAVE_FORMAT_4M16)
      strcat(buf, "44100 , ,\t16 \n");
    if(dwFmt & WAVE_FORMAT_4S16)
      strcat(buf, "44100 , ,\t16 \n");

    //    
    fputs(buf, out);
  }

  for(i=0; i<nNumAuxDevs; i++)
  {

    auxGetDevCaps(i, &auxcaps, sizeof(AUXCAPS));

    wsprintf(buf, "\n%s, v. %X, wMid=%d, wPid=%d\n",
      (LPSTR)auxcaps.szPname,
      auxcaps.vDriverVersion,
      auxcaps.wMid,
      auxcaps.wPid);

    wTech = auxcaps.wTechnology;
    dwSup = auxcaps.dwSupport;

    if(wTech & AUXCAPS_CDAUDIO)
      strcat(buf, "    CD-ROM\n");
    if(wTech & AUXCAPS_AUXIN)
      strcat(buf, "  \n");

    if(dwSup & AUXCAPS_VOLUME)
      strcat(buf, " \n");
    if(dwSup & AUXCAPS_LRVOLUME)
      strcat(buf, "  \n");

    //    
    fputs(buf, out);
  }


 for(i=0; i<nNumMidiInDevs; i++)
  {
    midiInGetDevCaps(i, &midicapsInCaps, sizeof(MIDIINCAPS));

    wsprintf(buf, "\n%s, v. %X, wMid=%d, wPid=%d\n",
      (LPSTR)midicapsInCaps.szPname,
      midicapsInCaps.vDriverVersion,
      midicapsInCaps.wMid,
      midicapsInCaps.wPid);

    //    
    fputs(buf, out);
  }

 for(i=0; i<nNumMidiOutDevs; i++)
  {
    midiOutGetDevCaps(i, &midicapsOutCaps, sizeof(MIDIOUTCAPS));

    wsprintf(buf, "\n%s, v. %X, wMid=%d, wPid=%d\n",
      (LPSTR)midicapsOutCaps.szPname,
      midicapsOutCaps.vDriverVersion,
      midicapsOutCaps.wMid,
      midicapsOutCaps.wPid);

    //    
    fputs(buf, out);
  }

 for(i=0; i<nNumJoyDevs; i++)
  {
    joyGetDevCaps(i, &joycaps, sizeof(JOYCAPS));

    wsprintf(buf, "\n%s, wMid=%d, wPid=%d\n",
      (LPSTR)joycaps.szPname,
      joycaps.wMid,
      joycaps.wPid);

    //    
    fputs(buf, out);
  }

  timeGetDevCaps(&timecaps, sizeof(TIMECAPS));

  wsprintf(buf, "\n: wPeriodMin=%u, wPeriodMax=%u\n",
    (UINT)timecaps.wPeriodMin,
    (UINT)timecaps.wPeriodMax);

  //    
  fputs(buf, out);


  //  
  fclose(out);

  MessageBox(NULL,
    "   "
    "  drvlist.txt", "DRVLIST", MB_OK);

  return 0;
}