#include <stdio.h>
#include <stdlib.h>

typedef struct
{
  unsigned signature;
  unsigned part_pag;
  unsigned file_size;
  unsigned rel_item;
  unsigned hdr_size;
  unsigned min_mem;
  unsigned max_mem;
  unsigned ss_reg;
  unsigned sp_reg;
  unsigned chk_summ;
  unsigned ip_reg;
  unsigned cs_reg;
  unsigned relt_off;
  unsigned overlay;
} EXE_HDR;

typedef struct 
{
  unsigned offset;
  unsigned segment;
} RELOC_TAB;

void main(int, char *[]);
int get_exeh(EXE_HDR *exeh, RELOC_TAB **rtb,
	     FILE *exe_file);
int listhdr(char *path);

void main(int argc, char *argv[])
{
  printf("ᬮ  exe-䠩\n"
    "(C) ஫ .., 1995\n\n");

  if(argc != 2)
  {
    printf("     exe-䠩  ⢥"
		      "ࠬ\n" );
    return;
  }

  if(listhdr(argv[1]) != 0)
  {
    printf("訡  ଠ 䠩   ⠪"
      "䠩\n");
    return;
  }
}

// -------------------------------------------
// listhdr
// ⮡ࠦ  exe-䠩
// -------------------------------------------

int listhdr(char *path)
{
  EXE_HDR     header;
  RELOC_TAB   *reloc;
  FILE        *inpfile;
  int         i;

  if((inpfile = fopen(path,"rb")) == 0)
    return(-1);

  if(get_exeh(&header,&reloc,inpfile) != 0)
  {
    fclose(inpfile);
    return(-1);
  }
  printf("᪮ ᫮:                   %04X\n"
	 " ᫥ ࠭ 䠩:      %d\n"
	 "⢮ ࠭  䠩:          %d\n"
	 ". ⮢ ⠡. ६饭:    %d\n"
	 "   ࠣ:       %d\n"
	 "쭠   ணࠬ:    %04X\n"
	 "ᨬ쭠   ணࠬ:   %04X\n"
	 "祭  ⥪ SS:SP:         %04X:%04X\n"
	 "஫쭠 㬬:                   %04X\n"
	 "祭  ॣ஢ CS:IP:        %04X:%04X\n"
	 "饭 ⠡. ६饭:          %02X\n"
	 " ૥:                       %d\n",
	 header.signature, header.part_pag,
	 header.file_size, header.rel_item,
	 header.hdr_size,  header.min_mem,
	 header.max_mem,   header.ss_reg,
	 header.sp_reg,    header.chk_summ,
	 header.cs_reg,    header.ip_reg,
	 header.relt_off,  header.overlay);

  if(reloc != 0)
  {
    printf("\nন ⠡ ६饭:\n\n");

      for(i=0; i < header.rel_item; i++)
      {
	printf("%04X:%04X\n",
	  (reloc+i)->segment, (reloc+i)->offset);
      }

      free(reloc);
   }

   fclose(inpfile);
   return(0);
}

// -------------------------------------------
// get_exeh
//   exe-䠩
//
// 㭪 ⠥  exe-䠩  
// ⨯ exe_HDR, 뢠   ⠡
// ࠧ饭 ᥣ⮢  뢠 ⠡
//   .   
// 頥  , 㪠 १
// ࠬ rtb.
// ᫨ ⠡ ࠧ饭 ,  
//   뢠.
//
// ࠬ:
//   exeh -  㪠⥫  , 
//              ଠ樥
//             exe-䠩
//
//   rtb  -  㪠⥫  ᫮ ,  ஬
//           ࠭ 㪠⥫  ⠡
//           ࠧ饭 ᥣ⮢ ணࠬ
//
//   exe_file - 㪠⥫   exe-䠩
//
// 頥 祭:
//   0  ᯥ譮 뢠 ;
//  -1  砥 ࠢ쭮 ଠ 
// -------------------------------------------

int get_exeh(EXE_HDR *exeh, RELOC_TAB **rtb,
	     FILE *exe_file)
{
  int i, j, k;

  // 뢠 ଠ஢  
  for(i=0; i < sizeof(EXE_HDR); i++)
  {
    *(((char*)exeh) + i) = fgetc(exe_file);
    if(feof(exe_file)) break;
  }

  // ,   EXE-䠩
  if(exeh->signature != 0x5a4d) return(-1);

  // E᫨  ⠡ ६饭,
  // 뢠   
  if((i = exeh->rel_item) != 0)
  {
    *rtb =
      (RELOC_TAB*)malloc(i * sizeof(RELOC_TAB) + 16);

    // 뢠 ⠡ ६饭
    for(k=0; k<i; k++)
    {
      for(j=0; j < sizeof(RELOC_TAB); j++)
      {
	*((char*)(*rtb)+j+k*sizeof(RELOC_TAB)) =
	   fgetc(exe_file);
	if(feof(exe_file)) break;
      }
    }
  }
  else
    *rtb = (RELOC_TAB *)NULL;
  return(0);
}

