//
//  ⮩ ணࠬ ॡ 
//  Large
//
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <malloc.h>
#include <dos.h>
#include <bios.h>
#include <ctype.h>
#include <string.h>

typedef struct _EBPB_
{
  unsigned sectsize;
  char clustsize;
  unsigned ressecs;
  char fatcnt;
  unsigned rootsize;
  unsigned totsecs;
  char media;
  unsigned fatsize;
  unsigned seccnt;
  unsigned headcnt;
  unsigned hiddensec_low;
  unsigned hiddensec_hi;
  unsigned long drvsecs;
} EBPB;

typedef struct _BOOT_
{
  char jmp[3];
  char oem[8];
  EBPB bpb;
  char drive;
  char reserved;
  char signature;
  unsigned volser_lo;
  unsigned volser_hi;
  char label[11];
  char fat_format[8];
  char boot_code[450];
} BOOT;

typedef struct _FTIME_
{
  unsigned sec : 5, min : 6, hour : 5;
} FTIME;
typedef struct _FDATE_
{
  unsigned day : 5, month : 4, year : 7;
} FDATE;
typedef struct _FITEM_
{
  char name[8];
  char ext[3];
  char attr;
  char reserved[10];
  FTIME time;
  FDATE date;
  unsigned cluster_nu;
  unsigned long size;
} FITEM;

int getboot(BOOT far *boot, int drive);
int fat(char far *b_fat, int t_fat, unsigned idx);

union REGS reg;
struct SREGS segreg;

struct
{
  unsigned long first_sect;
  unsigned nsect;
  void far* buf;
} cb;

int main(void)
{
  BOOT *boot_rec;
  int i,j, k, status, fat_sectors;
  unsigned total_sectors;
  int ffat, root_begin, root_sectors;
  char drive;
  unsigned far *fat_buffer;
  FITEM far *root_buffer, far *rptr;
  char cbuf[128];
  char far *clust_buffer;
  unsigned cur_clust;

  printf("\n\n⥭ ⠫ ᪮ ᪠"
    "\n  (C)஫ ., 1995\n");

  // 뢠   ⥭ BOOT-
  boot_rec = (BOOT*)malloc(sizeof(BOOT));
  if(boot_rec == NULL)
  {
    printf("\n ");
    return -1;
  }

  // 訢 ,  ண 室
  // 믮 ⥭ 㧮筮 .
  printf("\n 祭 ᪠ (C, D, ...):");
  drive = getche();
  drive = toupper(drive) - 'A';
  if(drive < 2)
  {
    printf("\n 㪠뢠 ⮫쪮 ");
    free(boot_rec);
    return(-1);
  }

  // ⠥ 㧮   
  status = getboot((BOOT _far*)boot_rec, drive);
  if(status)
  {
    printf("\n訡  ⥭ 㧮筮 ᥪ");
    free(boot_rec);
    return(-1);
  }

  // ।塞 ଠ ⠡ FAT
  total_sectors = boot_rec->bpb.totsecs;

  // ᫨  ࠡ⠥  ७ ࠧ ᪠,
  // 饥 ⢮ ᥪ஢  ᪠ ६ 
  // ७ PBP
  if(total_sectors == 0)
    total_sectors = boot_rec->bpb.drvsecs;

  // ।塞 ଠ FAT
  if(!strncmp(boot_rec->fat_format, "FAT16", 5))
  {
    printf("\nFAT  16-⮢ ଠ");
    ffat = 16;
  }
  else
  {
    printf("\nFAT  12-⮢ ଠ");
    ffat = 12;
  }

  // ।塞 ⢮ ᥪ஢,  FAT
  fat_sectors = boot_rec->bpb.fatsize;

  // 뢠   FAT
  fat_buffer = (unsigned int*)
    farmalloc((long)fat_sectors * boot_rec->bpb.sectsize);
  if(fat_buffer == NULL)
  {
    printf("\n ");
    free(boot_rec);
    return -1;
  }

  // 塞  ࢮ ᥪ FAT
  j = boot_rec->bpb.ressecs;

  // ⠥ FAT   fat_buffer
  // 塞 ॣ஢   맮
  // 뢠 DOS INT 25h
  cb.first_sect = j;
  cb.nsect = fat_sectors;
  cb.buf = (void far*)fat_buffer;

  _BX  = FP_OFF(&cb);
  _DS  = FP_SEG(&cb);
  _CX  = 0xffff;
  _DX  = 0;
  _AX  = drive;
  asm int 25h
  asm pop ax

  // 塞  ࢮ ᥪ ୥ ⠫
  root_begin = j + fat_sectors * boot_rec->bpb.fatcnt;

  // 塞  ୥ ⠫
  root_sectors = (boot_rec->bpb.rootsize * 32) /
    boot_rec->bpb.sectsize;

  // 뢠   ୥ ⠫
  root_buffer = (FITEM far *)
    farmalloc(root_sectors * boot_rec->bpb.sectsize);
  if(root_buffer == NULL)
  {
    printf("\n ");
    free(boot_rec);
    farfree(fat_buffer);
    return -1;
  }

  cb.first_sect = root_begin;
  cb.nsect = root_sectors;
  cb.buf = (void far*)root_buffer;
  _BX  = FP_OFF(&cb);
  _DS = FP_SEG(&cb);
  _CX  = 0xffff;
  _DX  = 0;
  _AX  = drive;
  asm int 25h
  asm pop ax

  // 뢠 ᮤন ୥ ⠫
  printf("\n"
   "\n 䠩    .         ६      "
   "\n------------ ----- ----------  --------  ------- ------");

  for(rptr = root_buffer;;rptr++)
  {
    printf("\n");

    // ਧ  ⠫ - 㫥   砫
    //  䠩
    if(rptr->name[0] == 0) break;

    // 뢮 ᮤন ਯ 䠩
    for(i=0; i<8; i++) printf("%c",rptr->name[i]);
    printf(".");
    for(i=0; i<3; i++) printf("%c",rptr->ext[i]);
    printf(" %02X    %02d-%02d-%02d  %02d:%02d:%02d ",
      rptr->attr, rptr->date.day, rptr->date.month,
      rptr->date.year + 1980, rptr->time.hour,
      rptr->time.min, rptr->time.sec * 2);
    printf(" %-6ld   %lu",
      (long)rptr->cluster_nu, (long)rptr->size);
  }

  // 砥   ⥭ ஢ ⠫
  clust_buffer = (char far*)
    farmalloc(boot_rec->bpb.clustsize
    * boot_rec->bpb.sectsize);

  if(clust_buffer == NULL)
  {
    printf("\n ");
    farfree(root_buffer);
    free(boot_rec);
    farfree(fat_buffer);
    return -1;
  }

  printf("\n ࢮ  ⠫:");
  gets(cbuf);
  cur_clust = atol(cbuf);

  // ६ k ᯮ  ⢥ 䫠.
  //  ࢮ ᬮ ⠫  祭 ࠢ 0,
  // ⥬  ६ ⠭  1.
  k = 0;

  for(;;)
  {
    // ࠭塞   ⠫
    unsigned long j = cur_clust;

    // 塞  ᫥饣 , ।
    // ⠫
    cur_clust = fat((char far*)fat_buffer, ffat, cur_clust);
    printf("%d ", cur_clust);

    // ⠥    clust_buffer
    cb.first_sect = root_begin + root_sectors
	+ ((j-2)*boot_rec->bpb.clustsize);
    cb.nsect = boot_rec->bpb.clustsize;
    cb.buf = (void far*)clust_buffer;

    _BX  = FP_OFF(&cb);
    _DS = FP_SEG(&cb);
    _CX  = 0xffff;
    _DX  = 0;
    _AX  = drive;
    asm int 25h
    asm pop ax

    // 뢠 ᮤন ⠫
    rptr = (FITEM far *)clust_buffer;

    //  ਯ  ⠫ 㪠뢠 
    //   ⠫.    ࢮ ਯ
    // 室 ப ".       ".  䠪  ᯮ짮
    //  ஢ન ⠫. ᫨   訡 㪠
    //  ,  ਭ饣 ⠫,
    // ணࠬ  ࠡ  ᮮ饭  訡.
     if(k == 0)
     {
       k = 1;
       if(_fstrncmp(rptr->name,".       ",8) != 0)
       {
         printf("\n  ⠫ !");
         farfree(root_buffer);
         free(boot_rec);
         farfree(fat_buffer);
         farfree(clust_buffer);
	 return(-1);
       }
     }

     printf("\n"
 "\n 䠩    .         ६      "
 "\n------------ ----- ----------  --------  ------- ------");

    for(;;rptr++)
    {
      printf("\n");

      // ਧ  ⠫ - 㫥   砫
      //  䠩
      if(rptr->name[0] == 0) break;

      // 뢮 ᮤন ਯ 䠩
      for(i=0; i<8; i++) printf("%c",rptr->name[i]);
      printf(".");
      for(i=0; i<3; i++) printf("%c",rptr->ext[i]);
      printf(" %02X    %02d-%02d-%02d  %02d:%02d:%02d ",
        rptr->attr,	rptr->date.day,	rptr->date.month,
         rptr->date.year + 1980, rptr->time.hour,
         rptr->time.min, rptr->time.sec * 2);
      printf(" %-6ld   %lu",
        (long)rptr->cluster_nu, (long)rptr->size);
    }

    // ᫨   - ᫥  । ⠫,
    // 蠥 ࠡ ணࠬ
    if((cur_clust == 0xfff) || (cur_clust == 0xffff)) break;
  }

  farfree(root_buffer);
  free(boot_rec);
  farfree(fat_buffer);
  farfree(clust_buffer);
  return 0;
}

int getboot(BOOT far *boot, int drive)
{
  cb.first_sect = 0;
  cb.nsect = 1;
  cb.buf = (void far*)boot;

  _BX  = FP_OFF(&cb);
  _DS = FP_SEG(&cb);
  _CX  = 0xffff;
  _DX  = 0;
  _AX  = drive;
  asm int 25h
  asm pop ax
  asm jc err

  return 0;
err:
  return 1;
}

/**
* fat
*
*    FAT
*
* 㭪 롨ࠥ    ஬  ⠡
* ࠧ饭 䠩 FAT. ଠ FAT ।
* 㭪樨  ࠬ
*
* int fat(b_fat, t_fat, idx);
*
*    char far *b_fat  - , ᮤঠ騩 FAT
*
*    int t_fat         - ଠ FAT (12  16)
*
*    unsigned idx      -   FAT, 
*                          ࠭
*
**/

int fat(char far *b_fat, int t_fat, unsigned idx)
{
  div_t clust_nu ;
  int cluster;

  if(t_fat == 12)
  {
    clust_nu = div(idx * 3, 2);

    if(clust_nu.rem != 0)
       cluster =
         (*((int far*)(b_fat +
         clust_nu.quot)) >> 4) & 0xfff;
    else
       cluster = *((int far*)(b_fat + clust_nu.quot)) & 0xfff;
  }
  else if(t_fat == 16)
  {
    cluster = *((int far*)(b_fat + idx * 2));
  }
  else
  {
    printf("訡  ଠ FAT\n");
    exit(-100);
  }
  return(cluster);
}
