#include "stdafx.h"
#include "FtpView.h"
#include "FtpViewDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//============================================================
//   CFtpViewDlg 
//============================================================
CFtpViewDlg::CFtpViewDlg(CWnd* pParent /*=NULL*/)
   : CDialog(CFtpViewDlg::IDD, pParent)
{
   //{{AFX_DATA_INIT(CFtpViewDlg)
   m_FtpAddress = _T("");
   //}}AFX_DATA_INIT

   //    LoadIcon   
   //  DestroyIcon 
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//============================================================
//   CFtpViewDlg 
//============================================================
CFtpViewDlg::~CFtpViewDlg()
{
  //     FTP ,  
   if (m_FtpConnection != NULL)
   {
      m_FtpConnection -> Close();
      delete m_FtpConnection;
   }
   //     Internet
   if (m_InternetSession != NULL)
   {
      m_InternetSession -> Close();
      delete m_InternetSession;
   }
   //   
   delete m_ImageList;
}

//============================================================
//  DoDataExchange  CFtpViewDlg
//       
// IDD_FTPVIEW_DIALOG     
// CFtpViewDlg
//============================================================
void CFtpViewDlg::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CFtpViewDlg)
   DDX_Control(pDX, IDC_STATUS, m_Status);
   DDX_Control(pDX, IDOK, m_Ok);
   DDX_Control(pDX, IDC_ON_TOP, m_OnTop);
   DDX_Control(pDX, IDC_CONNECT, m_Connect);
   DDX_Control(pDX, IDC_FTP_LIST, m_FtpList);
   DDX_Text(pDX, IDC_FTP_ADDRESS, m_FtpAddress);
   //}}AFX_DATA_MAP
}

//============================================================
//    CFtpViewDlg 
//============================================================
BEGIN_MESSAGE_MAP(CFtpViewDlg, CDialog)
   //{{AFX_MSG_MAP(CFtpViewDlg)
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()

   //    Connect
   ON_BN_CLICKED(IDC_CONNECT, OnConnect)
   //    On Top
   ON_BN_CLICKED(IDC_ON_TOP, OnOnTop)
   //     NM_DBLCLK  
   ON_NOTIFY(NM_DBLCLK, IDC_FTP_LIST, OnDblclkFtpList)
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

//============================================================
//  OnInitDialog  CFtpViewDlg 
//    ,   
//   Internet (   CInternetSession)
//============================================================
BOOL CFtpViewDlg::OnInitDialog()
{
   //   OnInitDialog   CDialog
   CDialog::OnInitDialog();

   //  ,    
   //      
   SetIcon(m_hIcon,TRUE);  //   
   SetIcon(m_hIcon,FALSE); //   
   
   //=========================================================
   //    IDC_FTP_LIST
   //=========================================================

   // ,     
   LV_COLUMN   lv_column;
   //     
   CRect       rectList;

   //    
   TCHAR szColHeader[COL_NUM][10] = { 
         _T("Name"), 
         _T("Length"), 
         _T("Date"),
         _T("Time"), 
   };

   //   ,    
   // IDC_FTP_LIST    
   m_FtpList.GetWindowRect(&rectList);

   //    lv_column,   
   // 
   lv_column.mask = LVCF_FMT |   //   fmt
                LVCF_SUBITEM |   //   iSubItem
                   LVCF_TEXT |   //   pszText
                  LVCF_WIDTH;    //   cx

   //     
   lv_column.fmt = LVCFMT_LEFT;

   //  
   lv_column.cx = (rectList.Width() / COL_NUM) - 1; 

   //     
   for (int i = 0; i < COL_NUM; i++)  
   {
      //  
      lv_column.iSubItem = i;
      //   
      lv_column.pszText = szColHeader[i];
      //       
      m_FtpList.InsertColumn(i, &lv_column);
   }

   //       16  16
   m_ImageList = new CImageList();
   m_ImageList -> Create(16, 16, TRUE, 2, 2);

   //      - 
   // IDI_DIRECTORY ( )  
   // IDI_FILE(  ) 
   m_ImageList -> Add(AfxGetApp()->LoadIcon(IDI_DIRECTORY));
   m_ImageList -> Add(AfxGetApp()->LoadIcon(IDI_FILE));

   //    m_ImageList  
   //    IDC_FTP_LIST
   m_FtpList.SetImageList(m_ImageList, LVSIL_SMALL);

   //=========================================================
   //    FTP,    
   // 
   //=========================================================

   m_FtpAddress = "dials.ccas.ru"; //  FTP ""
   //    
   UpdateData(FALSE);

   //=========================================================
   //     Internet
   //=========================================================

   //     Internet,    
   //  -   FtpView
   m_InternetSession = new CInternetSession("FtpView");

   //        
   // 
   if(!m_InternetSession)
   {
      AfxMessageBox("New Session Error", MB_OK);
      OnOK();
   }
   //   m_FtpConnection
   m_FtpConnection = NULL;

   return TRUE;
}

//============================================================
//  OnPaint  CFtpViewDlg 
//       
//    
//============================================================
void CFtpViewDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); 

      SendMessage(WM_ICONERASEBKGND, 
         (WPARAM) dc.GetSafeHdc(), 0);

      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);

      CRect rect;
      GetClientRect(&rect);
      
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}

//============================================================
//  OnQueryDragIcon  CFtpViewDlg 
//   ,    
//  
//============================================================
HCURSOR CFtpViewDlg::OnQueryDragIcon()
{
   return (HCURSOR) m_hIcon;
}

//============================================================
//  OnOnTop  CFtpViewDlg 
//     
//============================================================
void CFtpViewDlg::OnOnTop() 
{
   //   IDC_FTP_LIST
   m_FtpList.EnableWindow(FALSE);

   //     sCurentDirectory , 
   //       .
   //     /     
   //  
   int iNum = sCurentDirectory.ReverseFind('/');
   if(iNum == -1)
   {
      //   /  ,     
      //  
      AfxMessageBox("No top directory");
   }
   else
   {
      //         
      //  
      sCurentDirectory = sCurentDirectory.Left(iNum);

      //    ( "")
      CWaitCursor wait;   
   
      //     
      DirectoryView();   
   }

   //    IDC_FTP_LIST
   m_FtpList.EnableWindow(TRUE);

   //       
   m_Status.SetWindowText(sCurentDirectory);

   return;
}

//============================================================
//  OnDblclkFtpList  CFtpViewDlg 
//    
//============================================================
void CFtpViewDlg::OnDblclkFtpList(NMHDR* pNMHDR, 
   LRESULT* pResult) 
{
   int       iTotalNumber; //   
   CString   sSelItem;     //  
   CString   sLength_Dir;   //     Dir

   //   IDC_FTP_LIST
   m_FtpList.EnableWindow(FALSE);

   //      IDC_FTP_LIST
   iTotalNumber = m_FtpList.GetItemCount();

   // ,    
   for(int i = 0; i < iTotalNumber; i++)
   {
      //  LVIS_SELECTED 
      //     
      if(LVIS_SELECTED == m_FtpList.GetItemState( i, 
         LVIS_SELECTED ))
      {
         //     
         // (   )
         sSelItem = m_FtpList.GetItemText( i, 0 );

         //     Length
         sLength_Dir = m_FtpList.GetItemText( i, 1 );

         if(sLength_Dir == "Dir") //  
            //    
            sCurentDirectory  = 
               sCurentDirectory + "/" + sSelItem;

         else                     //  
            AfxMessageBox("You select file " + sSelItem);
         
         break;
      }
   }
   
   //    ( "")
   CWaitCursor wait;   

   //     
   DirectoryView();

   //       
   m_Status.SetWindowText(sCurentDirectory);

   //    IDC_FTP_LIST
   m_FtpList.EnableWindow(TRUE);

   *pResult = 0;
}

//============================================================
//  OnConnect  CFtpViewDlg 
//     FTP
//============================================================
void CFtpViewDlg::OnConnect() 
{
   //     FTP
   CString  sCurrentFtpDirectory = "";

   //   Connect, OK  On Top
   m_Connect.EnableWindow(FALSE);
   m_Ok.EnableWindow(FALSE);
   m_OnTop.EnableWindow(FALSE);

   //        FTP,  
   //      m_FtpConnection
   if (m_FtpConnection != NULL)
   {
      m_FtpConnection -> Close();
      
      delete m_FtpConnection;   
      m_FtpConnection = NULL;
   }

   //       FTP,  
   //      
   UpdateData(TRUE);

   //     FTP 
   try
   {
      //    ( "")
      CWaitCursor wait;   

      //    FTP.  
      //    CInternetException
      m_FtpConnection = 
         m_InternetSession->GetFtpConnection(m_FtpAddress);
   }
   catch (CInternetException* pEx)
   {
      //   CInternetException
      TCHAR szErr[1024];  //    

      //    
      if (pEx->GetErrorMessage(szErr, 1024))
         AfxMessageBox(szErr);
      else
         AfxMessageBox("GetFtpConnection Error");

      //  
      pEx->Delete();

      //   m_FtpConnection
      m_FtpConnection = NULL;
   }

   //       
   if( m_FtpConnection == NULL )
      m_Status.SetWindowText("Connect not established");

   //   ,    
   //      
   else
   {
      //     FTP 
      BOOL fResult= 
         m_FtpConnection -> 
            GetCurrentDirectory(sCurrentFtpDirectory);
      if(fResult)
         sCurentDirectory = sCurrentFtpDirectory;
      else 
         AfxMessageBox("GetCurrentDirectory Error");

      //    ( "")
      CWaitCursor wait;   

      //     
      DirectoryView();

      //       
      m_Status.SetWindowText(sCurentDirectory);
}

   //    Connect, OK  On Top
   m_Connect.EnableWindow(TRUE);
   m_Ok.EnableWindow(TRUE);
   m_OnTop.EnableWindow(TRUE);
}

//============================================================
//  DirectoryView  CFtpViewDlg 
//        
//  m_FtpList
//============================================================
BOOL CFtpViewDlg::DirectoryView()
{
   // ,     
   //  
   BOOL     fResult; 

   //  ,    -
   //    
   BOOL     fDirectory;

   //       
   LV_ITEM   lv_item;   

   //      IDC_FTP_LIST
   m_FtpList.DeleteAllItems();

   //    CFtpFileFind,  
   // ,    
   //   FTP 
   CFtpFileFind m_FtpFileFind(m_FtpConnection);

   //      
   if(fResult = 
      m_FtpFileFind.FindFile(_T(sCurentDirectory + "/*")))
   {
      for(int n = 0;fResult; n++)
      {
         //     
         fResult = m_FtpFileFind.FindNextFile();

         //    -   
         fDirectory = m_FtpFileFind.IsDirectory();

         //=============    ==============
         //       
         CString   fileName;

         //   
         fileName = m_FtpFileFind.GetFileName();

         //   lv_item,   
         //     FTP. , 
         //       
         lv_item.mask = LVIF_TEXT | LVIF_IMAGE; 
         //     
         lv_item.iItem = n;
         //   
         lv_item.iSubItem = 0;
         //        
         //     
         lv_item.iImage = (fDirectory) ? DIRECTORY : FILE;
         //     
         lv_item.pszText = fileName.GetBuffer(MIN_LEN_BUF);

         //      IDC_FTP_LIST
         m_FtpList.InsertItem(&lv_item);

         //=============    =============
         //  
         DWORD dwLength = 0;
         //      
         //   
         CString sLength;

         //   Length     
         //        Dir,  
         //   - .
         //     
         lv_item.mask = LVIF_TEXT; 
         //     
         lv_item.iItem = n;
         //   
         lv_item.iSubItem = 1;
         //     ,  
         //    Length   Dir
         if(fDirectory)
         {
            lv_item.pszText = "Dir";
         }

         //     ,  
         //      Length 
         else
         {
            //   
            dwLength = m_FtpFileFind.GetLength();
            //     
				sLength.FormatMessage("%d", dwLength);
            lv_item.pszText = sLength.GetBuffer(MIN_LEN_BUF);
         }
        
         //       ( 
         // Length)
         m_FtpList.SetItem(&lv_item);

         //========      =========
         //       
         CTime mTime;  
         //      
         //     
         CString sDate;
         CString sTime;

         //      
         if(!m_FtpFileFind.GetLastWriteTime(mTime))
            break;

         //     
         lv_item.mask = LVIF_TEXT; 
         //     
         lv_item.iItem = n;
         //   
         lv_item.iSubItem = 2;
         //    mTime ,    
         sDate = mTime.Format("%d.%m.%y");
         //      lv_item
         lv_item.pszText = sDate.GetBuffer(MIN_LEN_BUF);

         //       ( 
         // Date)
         m_FtpList.SetItem(&lv_item);

         //   ,    
         //     ()
         lv_item.iSubItem = 3;
         //    mTime ,    
         sTime = mTime.Format("%H:%M:%S");
         //   ,  
         lv_item.pszText = sTime.GetBuffer(MIN_LEN_BUF);

         //       ( 
         // Time)
         m_FtpList.SetItem(&lv_item);
      }
      //     ,  
      //  m_FtpFileFind
      m_FtpFileFind.Close();
   }
   //       -   
   // ,   
   else
      AfxMessageBox("File's not found or error");

   return TRUE;
}
