#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <dos.h>

#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
   HINSTANCE hPrevInstance,
   LPSTR     lpszCmdLine, int nCmdShow)
{
  BYTE szBuf[100];
  HGLOBAL hmemGlobal;
  HGLOBAL hmemGlDiscard;
  LPVOID  lpvoidGlobal;
  LPVOID  lpvoidGlDiscard;
  DWORD   dwMaxFreeMem;

  //    
  dwMaxFreeMem = GlobalCompact(-1l);

  wsprintf(szBuf, " :\t%lu\n",
        dwMaxFreeMem);
  MessageBox(NULL, (LPSTR)szBuf, "Global Block", MB_OK);

  // --------------------------------------------------------
  //     
  // --------------------------------------------------------

  //     
  //  100000 
  dwMaxFreeMem = GlobalCompact(100000l);

  //    100000 
  hmemGlobal = GlobalAlloc(GHND, 100000l);

  if(hmemGlobal != NULL)
  {
    //   ,    
    lpvoidGlobal = GlobalLock(hmemGlobal);
    if(lpvoidGlobal != (LPVOID) NULL)
    {
      //    ,
      //    
      //    
      wsprintf(szBuf, "hmemGlobal=\t%04.4X\n"
        "lpvoidGlobal=\t%04.4X:%04.4X",
        hmemGlobal,
        FP_SEG(lpvoidGlobal), FP_OFF(lpvoidGlobal));

      MessageBox(NULL, (LPSTR)szBuf, "Global Block", MB_OK);

      // -----------------------------------------
      //      
      //       S
      *(LPSTR)lpvoidGlobal = 'S';
      // -----------------------------------------

      //   
      GlobalUnlock(hmemGlobal);
    }
    else
    {
      MessageBox(NULL, "   ",
        "Global Block", MB_OK);
    }
    //     
    GlobalFree(hmemGlobal);
  }
  else
  {
    MessageBox(NULL, "    ",
      "Global Block", MB_OK);
  }

  // --------------------------------------------------------
  //     
  // --------------------------------------------------------

  //      200000 
  hmemGlDiscard =
      GlobalAlloc(GMEM_MOVEABLE | GMEM_DISCARDABLE, 200000l);

  if(hmemGlDiscard != NULL)
  {
    //    ,  
    GlobalDiscard(hmemGlDiscard);

    //    
    lpvoidGlDiscard = GlobalLock(hmemGlDiscard);

    if(lpvoidGlDiscard != (LPVOID) NULL)
    {
      //   (   ,  
      //     ), 
      //     
      wsprintf(szBuf, "hmemGlDiscard=\t%04.4X\n"
        "lpvoidGlDiscard=\t%04.4X:%04.4X",
        hmemGlDiscard,
        FP_SEG(lpvoidGlDiscard), FP_OFF(lpvoidGlDiscard));
      MessageBox(NULL, (LPSTR)szBuf, "Global Block", MB_OK);

      //   
      GlobalUnlock(hmemGlDiscard);
    }
    else
    {
      //      ,
      // ,     
      if(GlobalFlags(hmemGlDiscard) & GMEM_DISCARDED)
      {
         MessageBox(NULL, "     ",
           "Global Block", MB_OK);

         //    
         hmemGlDiscard = GlobalReAlloc(hmemGlDiscard, 200000l,
           GMEM_MOVEABLE | GMEM_DISCARDABLE);

         //   
         lpvoidGlDiscard = GlobalLock(hmemGlDiscard);

         if(lpvoidGlDiscard != (LPVOID) NULL)
         {
           //     
           //   
           wsprintf(szBuf, "hmemGlDiscard=\t%04.4X\n"
             "lpvoidGlDiscard=\t%04.4X:%04.4X",
             hmemGlDiscard,
             FP_SEG(lpvoidGlDiscard), FP_OFF(lpvoidGlDiscard));
           MessageBox(NULL, (LPSTR)szBuf, "Global Block", MB_OK);

           //   
           GlobalUnlock(hmemGlDiscard);
         }
         else
         {
           MessageBox(NULL, "   ",
           "Global Block", MB_OK);
         }
      }
    }

    //      
    GlobalFree(hmemGlDiscard);
  }
  else
  {
    MessageBox(NULL, "    ",
      "Global Block", MB_OK);
  }

  return 0;
}