#define  STRICT
#include <windows.h>
#include <mem.h>
#include <time.h>

#include "hlpmore.h"

BOOL RegisterEWclass(HMODULE hModule);
extern "C" LRESULT CALLBACK _export
EWWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
char const szClassName[]   = "EWHlpMoreClass";

// ========================================================
//  LibMain
//      
//  DLL-  
// ========================================================
#pragma argsused
int FAR PASCAL
LibMain(HINSTANCE hModule, WORD wDataSegment,
  WORD wHeapSize, LPSTR lpszCmdLine)
{
  //     
  //  LibEntry   .
  //   .
  if(wHeapSize != 0)
    //   
    UnlockData(0);

  //     
  if(!RegisterEWclass(hModule))
    return FALSE;
  else
    //  TRUE.  ,  
    // DLL-  
    return TRUE;
}

// ========================================================
//  WEP
//      
//  DLL-  
// ========================================================
#pragma argsused
int FAR PASCAL WEP(int bSystemExit)
{
  return 1;
}

// ========================================================
//  MsgBox
//       
// ========================================================
extern "C" void FAR PASCAL _export
MsgBox(HWND hwnd, LPSTR szMsg)
{
  MessageBox(hwnd, szMsg, "Message from DLL", MB_OK);
}

// ========================================================
//  RegisterEWclass
//     
// ========================================================
BOOL RegisterEWclass(HMODULE hModule)
{
  ATOM aWndClass;
  WNDCLASS wc;

  memset(&wc, 0, sizeof(wc));

  //      
  wc.style         = CS_GLOBALCLASS;

  wc.lpszMenuName  = NULL;
  wc.lpfnWndProc   = (WNDPROC) EWWndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hModule;
  wc.hIcon         = NULL;
  wc.hCursor       = LoadCursor(hModule, "AppCursor");
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszClassName = (LPSTR)szClassName;

  aWndClass = RegisterClass(&wc);
  return (aWndClass != 0);
}

// ========================================================
//  EWWndProc
//   
// ========================================================
extern "C" LRESULT CALLBACK _export
EWWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  HDC hdc;
  PAINTSTRUCT ps;
  RECT rc;
  TEXTMETRIC tm;
  int cxChar, cyChar;
  QCI  qci;
  QRI  qri;
  static BYTE szCustomData[80];
  static BYTE szBuf[80];

  #define CLOCK_TIMER 1

  switch (msg)
  {
    //   
    case WM_CREATE:
    {
      //   
      qci = (QCI)((CREATESTRUCT FAR *)lParam)->lpCreateParams;
      if(lstrlen(qci->szAuthorData) < 80)
        lstrcpy(szCustomData, qci->szAuthorData);

      //      
      SetWindowLong(hwnd, GWL_STYLE,
        GetWindowLong(hwnd,GWL_STYLE) | WS_BORDER);

      //    
      SetTimer(hwnd, CLOCK_TIMER, 1000, NULL);
      return 0;
    }

    //   
    case WM_TIMER:
    {
      //   
      InvalidateRect(hwnd, NULL, FALSE);
      return 0;
    }

    //   WM_PAINT
    case WM_PAINT:
    {
      int    nBufSize;
      time_t t;
      struct tm *ltime;
      RECT    rc;

      hdc = BeginPaint(hwnd, &ps);

      //      
      time(&t);
      ltime = localtime(&t);

      //  ,  
      //    
      nBufSize = wsprintf(szBuf, "%02d:%02d:%02d",
        ltime->tm_hour,	ltime->tm_min,	ltime->tm_sec);

      //      
      SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));

      //     
      GetClientRect(hwnd, &rc);

      //     
      SetTextColor(ps.hdc, RGB(0,100,0));

      //     
      DrawText(hdc, (LPSTR)szBuf, nBufSize, &rc,
        DT_CENTER | DT_VCENTER | DT_NOCLIP | DT_SINGLELINE);

      EndPaint(hwnd, &ps);
      return 0L;
    }

    //     
    //   
    case EWM_QUERYSIZE:
    {
      //    
      hdc = GetDC(hwnd);
      SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
      GetTextMetrics(hdc, &tm);
      cxChar = tm.tmMaxCharWidth;
      cyChar = tm.tmHeight + tm.tmExternalLeading;
      ReleaseDC(hwnd, hdc);

      //    
      ((LPPOINT)lParam)->x = 10 * cxChar;
      ((LPPOINT)lParam)->y = 2  * cyChar;

      return 1;
    }

    //        
    //     
    //      
    case EWM_RENDER:
    {
      long lPtr = 0l;

      switch(wParam)
      {
        //     
        case CF_TEXT:
        {
          //    
          HGLOBAL hglb = GlobalAlloc(GMEM_MOVEABLE, 50);
          if(hglb)
          {
            //   
            LPSTR lpszTempBuf = (LPSTR)GlobalLock(hglb);

            //  ,   
            lstrcpy(lpszTempBuf,"\r\n");
            lstrcat(lpszTempBuf,szBuf);
            lstrcat(lpszTempBuf,"\r\n");

            //   
            GlobalUnlock(hglb);

            //    ,
            //   
            lPtr = (long)hglb;
          }
          break;
        }

        //  
        //     
        case CF_BITMAP:
        {
          POINT pt;
          RECT rc;
          HBITMAP hbmp, hbmpOld;
          HBRUSH hbrush;

          //     RENDERINFO
          qri = (QRI)lParam;

          //   , 
          //   
          hdc = CreateCompatibleDC(NULL);

          //    
          SendMessage(hwnd, EWM_QUERYSIZE,
            (WPARAM)hdc, (long)(LPPOINT)&pt);

          //   ,  ,
          //     
          rc.left = rc.top = 0;
          rc.right = pt.x;
          rc.bottom = pt.y;
          hbmp = CreateCompatibleBitmap(qri->hdc, pt.x, pt.y);

          //      
          hbmpOld = (HBITMAP)SelectObject(hdc,hbmp);

          //     
          hbrush = CreateSolidBrush(GetBkColor(hdc));
          FillRect(hdc, &rc, hbrush);
          DeleteObject(hbrush);

          //      
          Rectangle(hdc, rc.left, rc.top, rc.right, rc.bottom);

          //      
          DrawText(hdc, (LPSTR)szBuf, lstrlen(szBuf), &rc,
	          DT_CENTER | DT_VCENTER | DT_NOCLIP | DT_SINGLELINE);

          //    
          hbmp = (HBITMAP)SelectObject(hdc, hbmpOld);
          DeleteDC(hdc);

          //   
          //  
          lPtr = (long)hbmp;

          break;
        }
      }

      return lPtr;
    }

    //      
    case WM_LBUTTONDOWN:
    {
      if(IDYES == MessageBox(hwnd, " clock.exe?",
       "Help Sample", MB_YESNO | MB_ICONQUESTION))
        WinExec("clock.exe", SW_SHOW);

      #define IDN_CLOCK 200

      //      
      //    ,  IDN_CLOCK
      WinHelp(hwnd, "hlpmore.hlp", HELP_CONTEXTPOPUP,
          (DWORD)IDN_CLOCK);

      return 0;
    }

    //      
    case WM_DESTROY:
    {
      KillTimer(hwnd, CLOCK_TIMER);
      return 0;
    }

    default:
      break;
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}