#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <dos.h>

#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
   HINSTANCE hPrevInstance,
   LPSTR     lpszCmdLine, int nCmdShow)
{
  BYTE szBuf[100];
  HLOCAL hmemLocal;
  HLOCAL hmemLoDiscard;
  void*  pLocal;
  void*  pLoDiscard;
  UINT   uMaxFreeMem;

  //    
  uMaxFreeMem = LocalCompact(0);

  wsprintf(szBuf, " :\t%u\n",
        uMaxFreeMem);
  MessageBox(NULL, (LPSTR)szBuf, "Local Block", MB_OK);

  // --------------------------------------------------------
  //     
  // --------------------------------------------------------

  //     
  //  1000 
  uMaxFreeMem = LocalCompact(1000);

  //    1000 
  hmemLocal = LocalAlloc(GHND, 1000);

  if(hmemLocal != NULL)
  {
    //   ,    
    pLocal = LocalLock(hmemLocal);
    if(pLocal != NULL)
    {
      //    ,
      //    
      //    
      wsprintf(szBuf, "hmemLocal=\t%04.4X\n"
        "pLocal=\t\t%04.4X",
        hmemLocal, pLocal);

      MessageBox(NULL, (LPSTR)szBuf, "Local Block", MB_OK);

      // -----------------------------------------
      //      
      //       S
      *(PSTR)pLocal = 'S';
      // -----------------------------------------

      //   
      LocalUnlock(hmemLocal);
    }
    else
    {
      MessageBox(NULL, "   ",
        "Local Block", MB_OK);
    }
    //     
    LocalFree(hmemLocal);
  }
  else
  {
    MessageBox(NULL, "    ",
      "Local Block", MB_OK);
  }

  // --------------------------------------------------------
  //     
  // --------------------------------------------------------

  //      2000 
  hmemLoDiscard =
      LocalAlloc(LMEM_MOVEABLE | LMEM_DISCARDABLE, 2000);

  if(hmemLoDiscard != NULL)
  {
    //    ,  
    LocalDiscard(hmemLoDiscard);

    //    
    pLoDiscard = LocalLock(hmemLoDiscard);

    if(pLoDiscard != NULL)
    {
      wsprintf(szBuf, "hmemLoDiscard=\t%04.4X\n"
        "pLoDiscard=\t%04.4X",
        hmemLoDiscard, pLoDiscard);
      MessageBox(NULL, (LPSTR)szBuf, "Local Block", MB_OK);

      //   
      LocalUnlock(hmemLoDiscard);
    }
    else
    {
      //      ,
      // ,     
      if(LocalFlags(hmemLoDiscard) & LMEM_DISCARDED)
      {
         MessageBox(NULL, "     ",
           "Local Block", MB_OK);

         //    
         hmemLoDiscard = LocalReAlloc(hmemLoDiscard, 256,
           LMEM_MOVEABLE | LMEM_DISCARDABLE);

         //   
         pLoDiscard = LocalLock(hmemLoDiscard);

         if(pLoDiscard != NULL)
         {
           //     
           //   
           wsprintf(szBuf, "hmemLoDiscard=\t%04.4X\n"
             "pLoDiscard=\t%04.4X",
             hmemLoDiscard, pLoDiscard);
           MessageBox(NULL, (LPSTR)szBuf, "Local Block", MB_OK);

           //   
           LocalUnlock(hmemLoDiscard);
         }
         else
         {
           MessageBox(NULL, "   ",
           "Local Block", MB_OK);
         }
      }
    }

    //      
    LocalFree(hmemLoDiscard);
  }
  else
  {
    MessageBox(NULL, "    ",
      "Local Block", MB_OK);
  }

  return 0;
}