//    MFC
#include <afxwin.h>

//===================================================== 
//    CMFStartApp
//===================================================== 
class CMFStartApp : public CWinApp
{
public:
	virtual BOOL	InitInstance();
	void					FileSystemInfo();
};
 
//     CMFStartApp
CMFStartApp MFStartApp;
 
//===================================================== 
//    InitInstance
//  CWinApp
//===================================================== 
BOOL CMFStartApp::InitInstance()
{
	//    
	FileSystemInfo();	

	//  
	return FALSE;
}

//===================================================== 
//  FileSystemInfo   
//       
//    
//===================================================== 
void CMFStartApp::FileSystemInfo() 
{

	//  
	CString	VolumeNameBuffer;

	//    
	DWORD	nVolumeNameSize = 100;	

	//   
	DWORD	VolumeSerialNumber;

	//    
	DWORD	MaximumComponentLength;

	//   
	DWORD	FileSystemFlags;

	//   
	CString	FileSystemNameBuffer;

	//      
	DWORD	nFileSystemNameSize = 100;

	//        
	GetVolumeInformation(
		NULL, 
		VolumeNameBuffer.GetBuffer(nVolumeNameSize), 
		nVolumeNameSize, 
		&VolumeSerialNumber,
		&MaximumComponentLength, &FileSystemFlags,
		FileSystemNameBuffer.GetBuffer(nFileSystemNameSize),
		nFileSystemNameSize );

	//    
	VolumeNameBuffer.ReleaseBuffer();
	FileSystemNameBuffer.ReleaseBuffer();

	//   ,   
	//     
	try
	{
		//   fsystem.dat     
		CStdioFile file("fsystem.dat", 
			CFile::modeCreate | 
			CFile::modeWrite | 
			CFile::typeText);

		//  ,     
		CString	strTmpOut;

		//     512 
		strTmpOut.GetBuffer(512);

		//     
		strTmpOut.Format(" : %s \n", VolumeNameBuffer);
		file.WriteString(strTmpOut);

		//     
		strTmpOut.Format(" : %X \n", 
			VolumeSerialNumber);

		file.WriteString(strTmpOut);

		//      
		strTmpOut.Format("  : %s \n", 
			FileSystemNameBuffer);

		file.WriteString(strTmpOut);
	
		//       
		strTmpOut.Format("   : %d \n", 
			MaximumComponentLength);

		file.WriteString(strTmpOut);
		
		//      
		strTmpOut = "   \n";

		if(FileSystemFlags & FS_CASE_IS_PRESERVED)
			strTmpOut += "   FS_CASE_IS_PRESERVED\n";

		if(FileSystemFlags & FS_CASE_SENSITIVE)
			strTmpOut += "   FS_CASE_SENSITIVE\n";
	
		if(FileSystemFlags & FS_UNICODE_STORED_ON_DISK)
			strTmpOut += "   FS_UNICODE_STORED_ON_DISK\n";
	
		if(FileSystemFlags & FS_PERSISTENT_ACLS)
			strTmpOut += "   FS_PERSISTENT_ACLS\n";
	
		if(FileSystemFlags & FS_FILE_COMPRESSION)
			strTmpOut += "   FS_FILE_COMPRESSION\n";

		if(FileSystemFlags & FS_VOL_IS_COMPRESSED)
			strTmpOut += "   FS_VOL_IS_COMPRESSED\n";

		file.WriteString(strTmpOut);	
	
		//  
		file.Close();
		//      
		MessageBox(NULL, "File fsystem.dat", "Message", MB_OK);
	}

	//  .    
	//   
	catch(...)
	{
		//      
		MessageBox(NULL, "File I/O Error", "Error", MB_OK);
	}

	return;
}
