//============================================================
//  DialogBar
// (c) Frolov G.V., 1996
// E-mail: frolov@glas.apc.org
//============================================================
//      
//  
#define VC_EXTRALEAN		

//    MFC
#include <afxwin.h>
#include <afxext.h> 
#include <afxcmn.h>

//     
#include "resource.h"

//============================================================
//  CDlgBarApp -    
//============================================================
class CDlgBarApp : public CWinApp
{
public:
   //     InitInstance
   virtual BOOL InitInstance();
};
 
//     CDlgBarApp
CDlgBarApp DlgBarApp;
 
//============================================================
//  CDlgBarWindow -    
//============================================================
class CDlgBarWindow : public CFrameWnd
{
//   
protected: 
   //      CDialogBar       
   CDialogBar       m_wndDialogBar;
   
protected:
   //  OnCreate     
   //  
   afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

public:
   //    CDlgBarWindow
   CDlgBarWindow();

   //        
   //  
   afx_msg BOOL DlgBarCommand(UINT nID);
   afx_msg void DlgBarCombo();
   
   //  ,    
   // CDlgBarWindow  
   DECLARE_MESSAGE_MAP()    
}; 

//============================================================
//  BarCommand
//  ,    
//============================================================
BOOL CDlgBarWindow::DlgBarCommand(UINT nID)
{
   CString szCommandAbout;

   //     , 
   //     
   //      
   if(szCommandAbout.LoadString(nID))
      MessageBox(szCommandAbout);

   else 
   {
      //     
      TRACE0("Failed to load string\n");
      return -1;      
   }
   
   return TRUE;
}

//============================================================
//  DlgBarCombo
//  ,    
//============================================================
void CDlgBarWindow::DlgBarCombo()
{
   //    ,      
   MessageBox("Combo-box selection changed");
}

//============================================================
//    CDlgBarWindow
//============================================================
BEGIN_MESSAGE_MAP(CDlgBarWindow, CFrameWnd)

   //    OnCreate
   ON_WM_CREATE()

//============================================================
   //       
   //     Set  Clear
   ON_COMMAND_EX(IDC_BUTTON_SET, DlgBarCommand)
   ON_COMMAND_EX(IDC_BUTTON_CLEAR, DlgBarCommand)

   //     Alighn 
   ON_COMMAND_EX(IDC_RADIO_LEFT, DlgBarCommand)
   ON_COMMAND_EX(IDC_RADIO_CENTER, DlgBarCommand)
   ON_COMMAND_EX(IDC_RADIO_RIGHT, DlgBarCommand)
   
   //     combo-box
   ON_CBN_SELCHANGE( IDC_COMBO_COLOUR, DlgBarCombo)
   
END_MESSAGE_MAP()

//============================================================
//  InitInstance  CDlgBarApp
//         
//============================================================
BOOL CDlgBarApp::InitInstance()
{
   m_pMainWnd = new CDlgBarWindow();
   m_pMainWnd -> ShowWindow(m_nCmdShow);
   m_pMainWnd -> UpdateWindow();

   return TRUE;
}

//============================================================
//   CDlgBarWindow
//============================================================
CDlgBarWindow::CDlgBarWindow()
{ 
   //   ,  
   //    CDlgBarWindow
   Create(NULL, "Dialog Bar", WS_OVERLAPPEDWINDOW,
          rectDefault, NULL); 
}

//============================================================
//  OnCreate  CDlgBarWindow
//     
//============================================================
int CDlgBarWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
   //   OnCreate  
   if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
      return -1;

//============================================================
   //     

   if (!m_wndDialogBar.Create(this, IDD_DIALOG_BAR, CBRS_TOP,
                              IDD_DIALOG_BAR))
   {
      //      
      TRACE0("Failed to create dialog bar\n");
      return -1;
   }
   return 0;
}
