//============================================================
//  MultiMenu
// (c) Frolov G.V., 1996
// E-mail: frolov@glas.apc.org
//============================================================

//    MFC
#include <afxwin.h>
#include <afxext.h> 
#include <afxcmn.h>

//       
#include "resource.h"

//============================================================
//  CMultiMenuApp -    
//============================================================
class CMultiMenuApp : public CWinApp
{
public:
   //     InitInstance,
   //    
   virtual BOOL InitInstance();
};
 
//     CMultiMenuApp
CMultiMenuApp MultiMenuApp;
 
//============================================================
//  CMultiMenuWindow -    
//============================================================
class CMultiMenuWindow : public CFrameWnd
{

protected:  
   //  
   CStatusBar  m_wndStatusBar;   
   
   //    Prosess  Mission
   BOOL  bEnable; 

   //    Construction  Mission
   BOOL  bRadio;  

   //    Restrict  Menu
   int   nCheck;  
       
protected:
   //        
   afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

   //      
   //   
   afx_msg void CMultiMenuWindow::OnDisable();
   afx_msg void CMultiMenuWindow::OnCommand();
   afx_msg void CMultiMenuWindow::OnExit();
   afx_msg void CMultiMenuWindow::OnConstruct();
   afx_msg void CMultiMenuWindow::OnRestrictMenu();
   afx_msg void CMultiMenuWindow::OnFullMenu();

   //    
   afx_msg void OnUpdateProcess(CCmdUI* pCmdUI);
   afx_msg void OnUpdateConstruct(CCmdUI* pCmdUI);
   afx_msg void OnUpdateDisable(CCmdUI* pCmdUI);
   
public:
   //   CMultiMenuWindow
   CMultiMenuWindow();

   //  ,    
   // CMultiMenuWindow  
   DECLARE_MESSAGE_MAP()    
}; 

//============================================================
//    CMultiMenuWindow
//============================================================
BEGIN_MESSAGE_MAP(CMultiMenuWindow, CFrameWnd)
   
   //    OnCreate
   ON_WM_CREATE()

   //    OnContextMenu
   ON_WM_CONTEXTMENU()

   //      
   ON_COMMAND(ID_MENU_DISABLE, OnDisable)
   ON_COMMAND(ID_MISSION_CONSTRUCT, OnConstruct)
   ON_COMMAND(ID_FILE_EXIT, OnExit)
   ON_COMMAND(ID_MISSION_PROCESS, OnCommand)
   
   ON_COMMAND(ID_MENU_RESTRICT, OnRestrictMenu)
   ON_COMMAND(ID_MENU_FULL, OnFullMenu)

   //   ON_UPDATE_COMMAND_UI 
   ON_UPDATE_COMMAND_UI(ID_MISSION_PROCESS, OnUpdateProcess)
   ON_UPDATE_COMMAND_UI(ID_MISSION_CONSTRUCT, 
                           OnUpdateConstruct)
   ON_UPDATE_COMMAND_UI(ID_MENU_DISABLE, OnUpdateDisable)

END_MESSAGE_MAP()

//   
UINT indicator = ID_SEPARATOR;

//============================================================
//  InitInstance  CMultiMenuApp
//         
//============================================================
BOOL CMultiMenuApp::InitInstance()
{
   m_pMainWnd = new CMultiMenuWindow();
   m_pMainWnd -> ShowWindow(m_nCmdShow);
   m_pMainWnd -> UpdateWindow();

   return TRUE;
}

//============================================================
//   CMultiMenuWindow
//============================================================
CMultiMenuWindow::CMultiMenuWindow()
{ 
   //   ,  
   //    CMultiMenuWindow
   Create(NULL, "Multi Menu Sample", WS_OVERLAPPEDWINDOW,
      rectDefault, NULL, MAKEINTRESOURCE(IDR_FULL_MENU));

   //    
   LoadAccelTable(MAKEINTRESOURCE(IDR_ACCELERATOR));

   //  
   bEnable = TRUE;         
   bRadio = TRUE;         
   nCheck = 0;
}

//============================================================
//  OnCreate  CMultiMenuWindow
//      
//============================================================
int CMultiMenuWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
   //   OnCreate  
   if(CFrameWnd::OnCreate(lpCreateStruct) == -1)
      return -1;
   
   //    
   if(!m_wndStatusBar.Create(this))
   {
      //     
      TRACE0("Failed to create status bar\n");
      return -1;   
   }

   //    
   if(!m_wndStatusBar.SetIndicators(&indicator,1))
   {
      //    
      TRACE0("Failed to set indicators\n");
      return -1;   
   }
   
   return 0;
}

//============================================================
//  OnDisable  CMultiMenuWindow
//    bEnable  nCheck 
//============================================================
void CMultiMenuWindow::OnDisable()
{
   //   bEnable  TRUE  FALSE  
   bEnable = !bEnable;
   
   //   bEnable  1  0  
   nCheck = (nCheck == 1) ? 0 : 1; 
}

//============================================================
//  OnRestrictMenu  CMultiMenuWindow
//     IDR_FULL_MENU  
// IDR_RESTRICT_MENU
//============================================================
void CMultiMenuWindow::OnRestrictMenu()
{
   CMenu menuOld;       //  
   CMenu menuRestrict;  //  
   CMenu* pMenu;

   //      
   pMenu = this->GetMenu();
   
   //     menuOld
   menuOld.Attach(pMenu->m_hMenu);

   //   
   menuOld.DestroyMenu();
   
   //   IDR_RESTRICT_MENU
   menuRestrict.LoadMenu(IDR_RESTRICT_MENU);

   //    
   SetMenu(&menuRestrict);

   //      menuRestrict
   menuRestrict.Detach();
}

//============================================================
//  OnFullMenu  CMultiMenuWindow
//     IDR_RESTRICT_MENU  
// IDR_FULL_MENU 
//============================================================
void CMultiMenuWindow::OnFullMenu()
{
   CMenu menuOld;
   CMenu menuRestrict;
   CMenu* pMenu;

   pMenu = this->GetMenu();
   menuOld.Attach(pMenu->m_hMenu);
   menuOld.DestroyMenu();

   menuRestrict.LoadMenu(IDR_FULL_MENU);
   SetMenu(&menuRestrict);
   menuRestrict.Detach();
}

//============================================================
//  OnCommand  CMultiMenuWindow
//============================================================
void CMultiMenuWindow::OnCommand()
{
   MessageBox("Command not implemented");
}

//============================================================
//  OnConstruct  CMultiMenuWindow
//    bRadio
//============================================================
void CMultiMenuWindow::OnConstruct()
{
   //   bRadio  TRUE  FALSE  
   bRadio = !bRadio;
}

//============================================================
//  OnExit  CMultiMenuWindow
//============================================================
void CMultiMenuWindow::OnExit()
{
   //  
   DestroyWindow();
   return;
}

//============================================================
//  OnUpdateProcess  CMultiMenuWindow
//============================================================
void CMultiMenuWindow::OnUpdateProcess(CCmdUI* pCmdUI)
{
   //     Process  Mission
   pCmdUI->Enable(bEnable); 
}

//============================================================
//  OnUpdateConstruct  CMultiMenuWindow
//============================================================
void CMultiMenuWindow::OnUpdateConstruct(CCmdUI* pCmdUI)
{
   //     
   //  Construction  Mission
   pCmdUI->SetRadio(bRadio);
}

//============================================================
//  OnUpdateDisable  CMultiMenuWindow
//============================================================
void CMultiMenuWindow::OnUpdateDisable(CCmdUI* pCmdUI)
{
   //     
   //   Disable  Menu
   pCmdUI->SetCheck(nCheck);
}
