//===================================================== 
//  Status
// (c) Frolov G.V., 1996
// E-mail: frolov@glas.apc.org
//===================================================== 

//    MFC
#include <afxwin.h>
#include <afxext.h> 
#include <afxcmn.h>

//       
#include "resource.h"

//===================================================== 
//  CStateApp -    
//===================================================== 
class CStateApp : public CWinApp
{
public:
   //     InitInstance,
   //    
   virtual BOOL InitInstance();
};
 
//     CStateApp
CStateApp StateApp;
 
//===================================================== 
//  CStateWindow -    
//===================================================== 
class CStateWindow : public CFrameWnd
{

protected:  
   CStatusBar  m_wndStatusBar;   //  
   BOOL  bIndicatorTEXT;         //    
                                 // 
                                 // ID_INDICATOR_TEXT
     
protected:
   //        
   afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

public:
   //    CStateWindow
   CStateWindow();

   //      
   afx_msg BOOL OnMenuDirectADD_SUB(UINT nID);
   afx_msg void OnMenuProcessBar();
   afx_msg void OnMenuDisableADD_SUB();
   afx_msg void OnMenuSwitchTEXT();
   afx_msg void OnMenuExit();
   
   //     ON_UPDATE_COMMAND_UI
   //   ID_INDICATOR_TEXT
   afx_msg void OnUpdateTEXT(CCmdUI* pCmdUI);
   
   //  ,    
   // CStateWindow  
   DECLARE_MESSAGE_MAP()    
}; 

//===================================================== 
//    CStateWindow
//===================================================== 
BEGIN_MESSAGE_MAP(CStateWindow, CFrameWnd)
   
   //    OnCreate
   ON_WM_CREATE()

   //   ON_UPDATE_COMMAND_UI 
   ON_UPDATE_COMMAND_UI(ID_INDICATOR_TEXT, OnUpdateTEXT)
   
   //    Work
   ON_COMMAND(ID_WORK_PROCESS, OnMenuProcessBar)
   ON_COMMAND(ID_WORK_DISABLE_ADDSUB, OnMenuDisableADD_SUB)
   ON_COMMAND(ID_WORK_ON_SWITCH_TEXT, OnMenuSwitchTEXT)
   
   ON_COMMAND_EX(ID_WORK_DIRECT_ADD, OnMenuDirectADD_SUB)
   ON_COMMAND_EX(ID_WORK_DIRECT_SUB, OnMenuDirectADD_SUB)

   ON_COMMAND(ID_WORK_EXIT, OnMenuExit)
   
END_MESSAGE_MAP()

//   .   
//      
// (  ,      SetPaneInfo)
static UINT indicators[] =
{
	ID_SEPARATOR,           //   
   ID_INDICATOR_OVR,       //  OVR
	ID_INDICATOR_PROGRESS,  //    
                           // progress bar
   ID_INDICATOR_CAPS,      //   <Caps Lock>
	ID_INDICATOR_NUM,       //   <Num Lock>
   ID_INDICATOR_SCRL,      //   <Scroll Lock>
   ID_INDICATOR_TEXT,      //  TEXT/PIC
   ID_INDICATOR_ADD,       //  ADD/SUB ( 
                           //  START)
};

//===================================================== 
//  InitInstance  CStateApp
//         
//===================================================== 
BOOL CStateApp::InitInstance()
{
   m_pMainWnd = new CStateWindow();
   m_pMainWnd -> ShowWindow(m_nCmdShow);
   m_pMainWnd -> UpdateWindow();

   return TRUE;
}

//===================================================== 
//   CStateWindow
//===================================================== 
CStateWindow::CStateWindow()
{ 
   //   ,  
   //    CStateWindow
   Create(NULL, "Status Bar Sample", WS_OVERLAPPEDWINDOW,
      rectDefault, NULL, MAKEINTRESOURCE(IDR_MENU)); 
   
   //    bIndicatorTEXT
   bIndicatorTEXT = TRUE;
}

//===================================================== 
//  OnMenuProcessBar  CStateWindow
//===================================================== 
void CStateWindow::OnMenuProcessBar()
{
    //    ID_INDICATOR_PROGRESS
    RECT rectProgress;
    
    m_wndStatusBar.GetItemRect(
       m_wndStatusBar.CommandToIndex(ID_INDICATOR_PROGRESS), 
         &rectProgress);

   //   progress bar.   
   //    ID_INDICATOR_PROGRESS
   CProgressCtrl ctrlProgressBar;

   if(!ctrlProgressBar.Create(WS_CHILD | WS_VISIBLE, 
                              rectProgress, &m_wndStatusBar, 1))
	{
      //    progress bar
		TRACE0("Failed to create progress bar\n");
		return;
	}

   //    progress bar
   ctrlProgressBar.SetRange(0, 100);

   //     progress bar
   ctrlProgressBar.SetStep(1);
 
   //    progress bar
   for(int i=0;i<100;i++)
   {
      //   
      Sleep(10);
      
      //    progress bar
      ctrlProgressBar.StepIt();
   }
   
   //  ,     
   //   
   m_wndStatusBar.SetWindowText("Process completed");
}

//===================================================== 
//  OnMenuDirectADD_SUB  CStateWindow
//===================================================== 
BOOL  CStateWindow::OnMenuDirectADD_SUB(UINT nID)
{
   //    ID_INDICATOR_ADD
   int nIndex = m_wndStatusBar.CommandToIndex(ID_INDICATOR_ADD);

   //      
   m_wndStatusBar.SetPaneStyle(nIndex, SBPS_NORMAL);

   //   Work   Direct set ADD
   if(nID == ID_WORK_DIRECT_ADD)
   {
      //   ADD
      m_wndStatusBar.SetPaneText(nIndex, "ADD");
   }

   //   Work   Direct set SUB
   else if(nID == ID_WORK_DIRECT_SUB)
   {
      //    
      m_wndStatusBar.SetPaneStyle(nIndex, SBPS_POPOUT);

      //   SUB
      m_wndStatusBar.SetPaneText(nIndex, "SUB");
   }

   return TRUE;
}   

//=====================================================
//  OnMenuDisableADD_SUB  OnMenuDisableADD_SUB
//=====================================================
void CStateWindow::OnMenuDisableADD_SUB()
{
   //    ID_INDICATOR_ADD   
   int nIndex = m_wndStatusBar.CommandToIndex(ID_INDICATOR_ADD);
   
   //  
   m_wndStatusBar.SetPaneStyle(nIndex, SBPS_DISABLED);
}   

//===================================================== 
//  OnUpdateTEXT  CStateWindow
//===================================================== 
void CStateWindow::OnMenuSwitchTEXT()
{
   //    bIndicatorTEXT,
   //    OnUpdateTEXT
   bIndicatorTEXT = !bIndicatorTEXT;
}

//===================================================== 
//  OnMenuExit  CStateWindow
//===================================================== 
void CStateWindow::OnMenuExit()
{
   //  
   DestroyWindow();
   return;
}

//===================================================== 
//  OnCreate  CStateWindow
//      
//===================================================== 
int CStateWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
   //   OnCreate  
   if(CFrameWnd::OnCreate(lpCreateStruct) == -1)
      return -1;
   
   //    
	if(!m_wndStatusBar.Create(this))
	{
      //     
		TRACE0("Failed to create status bar\n");
		return -1;   
	}

   //    
   if(!m_wndStatusBar.SetIndicators(indicators,
		                sizeof(indicators)/sizeof(UINT)))
	{
      //    
		TRACE0("Failed to set indicators\n");
		return -1;   
	}
   
   //    ID_INDICATOR_PROGRESS
   m_wndStatusBar.SetPaneInfo( 
      m_wndStatusBar.CommandToIndex(ID_INDICATOR_PROGRESS), 
      ID_INDICATOR_PROGRESS, 
      SBPS_DISABLED |   //   
      SBPS_NOBORDERS,   //    
      150 );            //   150 

   return 0;
}

//===================================================== 
//  OnUpdateTEXT  CStateWindow
//   ON_UPDATE_COMMAND_UI 
//   ID_INDICATOR_TEXT
//===================================================== 
void CStateWindow::OnUpdateTEXT(CCmdUI* pCmdUI)
{
   //      bIndicatorTEXT
   //    ID_INDICATOR_TEXT
   //  TEXT  PIC
   if(bIndicatorTEXT)
  	   pCmdUI->SetText("TEXT"); //   TEXT

   else
      pCmdUI->SetText("PIC");  //   PIC

   //     
	pCmdUI->Enable();
}
