// ----------------------------------------
//   
//  OEM  ANSI  
//   
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <commdlg.h>
#include <mem.h>

//  
HFILE GetSrcFile(void);
HFILE GetDstFile(void);
int  Oem3Ansi(HFILE, HFILE);

//    ,
//     
char far * lpXlatTable;

//   
HINSTANCE hInst;

// -------------------------------
//  WinMain
// -------------------------------

#pragma argsused
int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine,
	int       nCmdShow)
{
  //  
  HFILE hfSrc, hfDst;

  //    
  HRSRC   hResource;

  //   
  HGLOBAL hXlatTable;

  //    
  //   
  hInst = hInstance;

  //   
  hResource   = FindResource(hInstance, "XlatTable", "XLAT");

  //   
  hXlatTable  = LoadResource(hInstance, hResource);

  //    ,   
  lpXlatTable = (char far *)LockResource(hXlatTable);

  //    NULL,   
  //    
  if(lpXlatTable == NULL)
  {
    MessageBox(NULL, "Resource loading error", NULL, MB_OK);
    return(-1);
  }

  //   .
  hfSrc = GetSrcFile();
  if(!hfSrc) return 0;

  //   
  hfDst = GetDstFile();
  if(!hfDst) return 0;

  //   
  if(Oem3Ansi(hfSrc, hfDst))
  {
    MessageBox(NULL, "Low Memory", NULL, MB_OK);
  }

  //     
  _lclose(hfSrc);
  _lclose(hfDst);

  //    
  UnlockResource(hXlatTable);
  FreeResource(hXlatTable);

  return 0;
}

// -------------------------------
//  GetSrcFile
//    
// -------------------------------

HFILE GetSrcFile(void)
{
  OPENFILENAME ofn;

  char szFile[256];
  char szFileTitle[256];
  char szFilter[256] =
	 "Text Files\0*.txt;*.doc\0Any Files\0*.*\0";
  HFILE hf;

  szFile[0] = '\0';
  memset(&ofn, 0, sizeof(OPENFILENAME));

  //    

  //   OFN_ENABLETEMPLATE, 
  //   
  ofn.Flags =   OFN_PATHMUSTEXIST  | OFN_FILEMUSTEXIST
		| OFN_HIDEREADONLY | OFN_ENABLETEMPLATE;

  //  ,  
  //  .    
  //   
  ofn.hInstance = hInst;

  //  ,  
  ofn.lpTemplateName = (LPSTR)"Open";

  //   
  ofn.lStructSize       = sizeof(OPENFILENAME);
  ofn.hwndOwner         = NULL;
  ofn.lpstrFilter       = szFilter;
  ofn.nFilterIndex      = 1;
  ofn.lpstrFile         = szFile;
  ofn.nMaxFile          = sizeof(szFile);
  ofn.lpstrFileTitle    = szFileTitle;
  ofn.nMaxFileTitle     = sizeof(szFileTitle);
  ofn.lpstrInitialDir   = NULL;

  //   
  if (GetOpenFileName(&ofn)) {
    //   
    hf = _lopen(ofn.lpstrFile, OF_READ);
    return hf;
  }
  else return 0;
}

// -------------------------------
//  GetDstFile
//    
//  
// -------------------------------

HFILE GetDstFile(void)
{
  OPENFILENAME ofn;

  char szFile[256];
  char szFileTitle[256];
  char szFilter[256] =
	 "Text Files\0*.txt;*.doc\0Any Files\0*.*\0";

  HFILE hf;

  szFile[0] = '\0';

  memset(&ofn, 0, sizeof(OPENFILENAME));

  //   OFN_ENABLETEMPLATE, 
  //   
  ofn.Flags = OFN_HIDEREADONLY | OFN_ENABLETEMPLATE;

  //  ,  
  ofn.hInstance = hInst;

  //  ,  
  ofn.lpTemplateName = (LPSTR)"Open";

  //    
  ofn.lpstrTitle = (LPSTR)"  ";

  //   
  ofn.lStructSize       = sizeof(OPENFILENAME);
  ofn.hwndOwner         = NULL;
  ofn.lpstrFilter       = szFilter;
  ofn.nFilterIndex      = 1;
  ofn.lpstrFile         = szFile;
  ofn.nMaxFile          = sizeof(szFile);
  ofn.lpstrFileTitle    = szFileTitle;
  ofn.nMaxFileTitle     = sizeof(szFileTitle);
  ofn.lpstrInitialDir   = NULL;

  //   
  if (GetSaveFileName(&ofn)) {

    //   .
    //    
    hf = _lcreat(ofn.lpstrFile, 0);
    return hf;
  }
  else return 0;
}

// -------------------------------
//  Oem3Ansi
//  
// -------------------------------

int Oem3Ansi(HFILE hfSrcFile, HFILE hfDstFile)
{
  //   
  DWORD cbRead;

  //  
  DWORD dwFileSize;

  //   
  // ,    
  //  
  HGLOBAL hglbBuf;

  //     
  unsigned char huge * hBuf;

  //   .  
  //    
  //  
  dwFileSize = _llseek(hfSrcFile, 0l, 2);

  //   
  //   
  _llseek(hfSrcFile, 0l, 0);

  //    ,
  //     
  hglbBuf = GlobalAlloc(GMEM_FIXED, dwFileSize);
  hBuf = (unsigned char huge *)GlobalLock(hglbBuf);

  //    ,
  //   
  if(hBuf == NULL) return(-1);

  //      
  cbRead = _hread(hfSrcFile, hBuf, dwFileSize);

  //  
  for(long i=0; i < cbRead; i++)
  {
    //   ,
    //   
    hBuf[i] = lpXlatTable[hBuf[i]];

    //   OEM  ANSI
    OemToAnsiBuff((const char far*)&hBuf[i],
       (char far*)&hBuf[i], 1);
  }

  //     
  //  
  _hwrite(hfDstFile, hBuf, dwFileSize);

  //   
  //  
  GlobalUnlock(hglbBuf);
  GlobalFree(hglbBuf);
  return 0;
}

