// ----------------------------------------
//   
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>
#include "ownbut.hpp"

//  
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);
void DrawButton(LPDRAWITEMSTRUCT);
void DrawBitmap(HDC hDC, int x, int y, HBITMAP hBitmap);

//   
char const szClassName[]   = "OwnButtonAppClass";

//  
char const szWindowTitle[] = "Owner Draw Button Demo";

//  
HWND hButton1, hButton2, hButton3, hButton4, hButton5;

//   
HINSTANCE hInst;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  //     
  //    
  hInst = hInstance;

  //  
  if(!InitApp(hInstance))
      return FALSE;

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,    
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 

  //     ,  
  if(!hwnd)
    return FALSE;

  //   
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  //   

  //     
  //  
  hButton1 = CreateWindow("button", "Button 1",
    WS_CHILD | WS_VISIBLE | BS_OWNERDRAW,
    20, 20, 180, 30,
    hwnd, (HMENU) IDB_Button1, hInstance, NULL);

  hButton2 = CreateWindow("button", "PUSH",
    WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
    20, 60, 90, 30, hwnd,
    (HMENU) IDB_Button2, hInstance, NULL);

  hButton3 = CreateWindow("button", "POP",
    WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
    20, 100, 90, 30, hwnd,
    (HMENU) IDB_Button3, hInstance, NULL);

  hButton4 = CreateWindow("button", "OFF",
    WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
    20, 140, 90, 30, hwnd,
    (HMENU) IDB_Button4, hInstance, NULL);

  hButton5 = CreateWindow("button", "ON",
    WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
    20, 180, 90, 30, hwnd,
    (HMENU) IDB_Button5, hInstance, NULL);

  //    
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    //  ,   
    //      
    case WM_COMMAND:
    {
      //    , 
      // 
      if(wParam == IDB_Button1)
      {
	MessageBox(hwnd, "  Button 1",
	  "Message WM_COMMAND",MB_OK);
      }
      else if(wParam == IDB_Button2)
      {
        SendMessage(hButton1, BM_SETSTATE, TRUE, 0L);
      }
      else if(wParam == IDB_Button3)
      {
	SendMessage(hButton1, BM_SETSTATE, FALSE, 0L);
      }
      else if(wParam == IDB_Button4)
      {
	EnableWindow(hButton1, FALSE);
      }
      else if(wParam == IDB_Button5)
      {
	EnableWindow(hButton1, TRUE);
      }
      return 0;
    }

    //      
    //    ,  
    //  
    case WM_DRAWITEM:
    {
      //  
      DrawButton( (LPDRAWITEMSTRUCT)lParam );
      break;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// =====================================
//  DrawButton
//  
// =====================================

void DrawButton(LPDRAWITEMSTRUCT lpInfo)
{
   HBITMAP hbm;
   int ResourceID;

   //   WM_DRAWITEM
   //       
   if(lpInfo->CtlType != ODT_BUTTON)
     return;

   //       
   // ,   WM_DRAWITEM,
   //   
   switch (lpInfo->CtlID)
   {
      case IDB_Button1:
      {
	//   
	//    () 
        ResourceID = IDR_BUTTONUP;
	break;
      }
      default:
        return;
   }

   //   ,    
   // 
   if (lpInfo->itemState & ODS_SELECTED)
   {
     ResourceID = IDR_BUTTONDOWN;
   }

   //   ,  
   //     
   else if (lpInfo->itemState & ODS_DISABLED)
   {
     ResourceID = IDR_BUTTONGR;
   }

   //      
   hbm = LoadBitmap(hInst, MAKEINTRESOURCE(ResourceID));

   //     
   if(!hbm) return;

   //       
   // ,   DrawBitmap
   if((lpInfo->itemAction & ODA_DRAWENTIRE) ||
      (lpInfo->itemAction & ODA_SELECT))
   {
     //  
     DrawBitmap(lpInfo->hDC,
       (lpInfo->rcItem).left,
       (lpInfo->rcItem).top , hbm);
   }

   //   ,   
   //    
   DeleteObject(hbm);
}
