#include <stdio.h>
#include <dos.h>
#include <bios.h>

typedef struct _PART_ENTRY_
{
  unsigned char flag;
  unsigned char beg_head;
  unsigned beg_sec_cyl;
  unsigned char sys;
  unsigned char end_head;
  unsigned end_sec_cyl;
  unsigned long rel_sec;
  unsigned long size;
} PART_ENTRY;

typedef struct _MBOOT_
{
  char boot_prg[0x1be];
  PART_ENTRY part_table[4];
  unsigned char signature[2];
} MBOOT;

int getmboot(MBOOT *master_boot, int drive);

int main(void)
{
  MBOOT mb;
  int i,j, k, status;

  printf("\n ࠧ ᪠"
	 "\n  (C)஫ ., 1995\n");

  // ⠥  㧮  ࢮ 
  status = getmboot(&mb, 0);
  if(status != 0)
  {
    printf("\n訡 ⥭ ᪠,  訡: %d",
      status);
    return(1);
  }

  printf("\n"
"\n------------------------------------------------------------"
"\n||砫 ࠧ | ࠧ  |  | |.   |"
"\n|    |---------------|---------------|.|ࠧ|  |"
"\n|    |.|.|.|.|.|.|     |       |ᥪ|"
"\n|----|----|-----|----|----|-----|----|-----|-------|-------|"
"\n");

  for(k=0; k<4; k++)
  {
    printf("|%3X |%4d|%4d |%4d|%4d|%4d |%4d|%5d|%7u|",
      mb.part_table[k].flag,
      mb.part_table[k].beg_head,
      mb.part_table[k].beg_sec_cyl & 0x3f,
      (mb.part_table[k].beg_sec_cyl >> 6) & 0x3ff,
      mb.part_table[k].end_head,
      mb.part_table[k].end_sec_cyl & 0x3f,
      (mb.part_table[k].end_sec_cyl >> 6) & 0x3ff,
      mb.part_table[k].sys,
      mb.part_table[k].size);

    printf("%7u|\n", mb.part_table[k].rel_sec);
  }
  printf("---------------------------"
    "---------------------------------");
  return 0;
}

/**
* getmboot
*
* ⥭  㧮筮 
*
* 㭪 ⠥  㧮 
*  㪠 
*
* int getmboot(MBOOT *master_boot, int drive);
*
* master_boot - 㪠⥫  ,  
*     㤥 ⠭  㧮筠 
*
* drive       -  
*               (0 -  , 1 - ன,...)
*
* 㭪 頥 0, ᫨ 
* 㧮筠  ⠭ ᯥ譮,
*   訡, 祭  㭪樨 BIOS "⥭
* ᥪ" - ᫨ ⥭  㧮筮
*  믮 
**/

int getmboot(MBOOT *master_boot, int drive)
{
  struct diskinfo_t di;
  int status;

  // ⮢   ⥭
  //  㧮筮 
  di.drive = drive | 0x80;
  di.head     = 0;
  di.track    = 0;
  di.sector   = 1;
  di.nsectors = 1;
  di.buffer   = (void far*)master_boot;

  // ⠥ ᥪ, ᮤঠ騩 
  // 㧮 
  status = _bios_disk( _DISK_READ, &di ) >> 8;
  return(status);
}

