// ==================================================
//  STIME (    RTIME)
//    WM_COPYDATA
//     
//
// ()  .., 1996
// Email: frolov@glas.apc.org
// ==================================================

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <time.h>
#include "resource.h"
#include "afxres.h"
#include "stime.h"

HINSTANCE hInst;
char szAppName[]  = "StimeApp";
char szAppTitle[] = "Time Sender";

//   RTIME
char szServerAppName[]  = "RclockApp";

//     RTIME
HWND hWndServer;

//      
//    WM_COPYDATA
COPYDATASTRUCT cd;

//    
char szBuf[80];
char szTerminated[] = "<Terminated>";

// -----------------------------------------------------
//  WinMain
// -----------------------------------------------------
int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;
  
  //   
  hInst = hInstance;

  // ,       
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
    //  ,    
    //  
    if(IsIconic(hWnd))
	    ShowWindow(hWnd, SW_RESTORE);
	  SetForegroundWindow(hWnd);
    return FALSE;
  }

  //     RTIME  
  //  
  hWndServer = FindWindow(szServerAppName, NULL);
  if(hWndServer == NULL)
  {
    //      ,
    //       
    // 
    MessageBox(NULL, "Server RTIME not found", szAppName,
      MB_ICONEXCLAMATION | MB_OK); 
    return FALSE;
  }
  
  //   
  memset(&wc, 0, sizeof(wc));
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICONSM), 
    IMAGE_ICON, 16, 16, 0);
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), 
    IMAGE_ICON, 32, 32, 0);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_APPMENU);
  wc.lpszClassName = szAppName;
  if(!RegisterClassEx(&wc))
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  //    
  hWnd = CreateWindow(szAppName, szAppTitle, 
     WS_OVERLAPPEDWINDOW, 
     CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 
     NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);
    
  //      
  //  
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// -----------------------------------------------------
//  WndProc
// -----------------------------------------------------
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, 
        LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hWnd, WM_TIMER,   WndProc_OnTimer);
    HANDLE_MSG(hWnd, WM_CREATE,  WndProc_OnCreate);
    HANDLE_MSG(hWnd, WM_DESTROY, WndProc_OnDestroy);

    default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
//  WndProc_OnCreate
// -----------------------------------------------------
BOOL WndProc_OnCreate(HWND hWnd, 
                      LPCREATESTRUCT lpCreateStruct)
{
  //      1 
  SetTimer(hWnd, CLOCK_TIMER, 1000, NULL);
  return TRUE;
}

// -----------------------------------------------------
//  WndProc_OnTimer
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnTimer(HWND hWnd, UINT id)
{
  time_t t;
  struct tm *ltime;

  //   
  time(&t);
  ltime = localtime(&t);

  //    
  wsprintf(szBuf, "%02d:%02d:%02d",
    ltime->tm_hour, ltime->tm_min,ltime->tm_sec);

  //       
  //  COPYDATASTRUCT
  cd.lpData = szBuf;
  cd.cbData = strlen(szBuf) + 1;

  //     RCLOCK
  SendMessage(hWndServer, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cd);
  return 0;
}

// -----------------------------------------------------
//  WndProc_OnDestroy
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  //     
  //   <Terminated>
  cd.lpData = szTerminated;
  cd.cbData = strlen(szTerminated) + 1;

  SendMessage(hWndServer, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cd);

  //  
  KillTimer(hWnd, CLOCK_TIMER);

  PostQuitMessage(0);
  return 0L;
}
