#include <stdio.h>
#include <conio.h>
#include <malloc.h>
#include <dos.h>
#include <ctype.h>

typedef struct _EBPB_
{
  unsigned sectsize;
  char clustsize;
  unsigned ressecs;
  char fatcnt;
  unsigned rootsize;
  unsigned totsecs;
  char media;
  unsigned fatsize;
  unsigned seccnt;
  unsigned headcnt;
  unsigned hiddensec_low;
  unsigned hiddensec_hi;
  unsigned long drvsecs;
} EBPB;

typedef struct _BOOT_
{
  char jmp[3];
  char oem[8];
  EBPB bpb;
  char drive;
  char reserved;
  char signature;
  unsigned volser_lo;
  unsigned volser_hi;
  char label[11];
  char fat_format[8];
  char boot_code[450];
} BOOT;

typedef struct _FTIME_
{
  unsigned sec : 5, min : 6, hour : 5;
} FTIME;

typedef struct _FDATE_
{
  unsigned day : 5, month : 4, year : 7;
} FDATE;

typedef struct _FITEM_
{
  char name[8];
  char ext[3];
  char attr;
  char reserved[10];
  FTIME time;
  FDATE date;
  unsigned cluster_nu;
  unsigned long size;
} FITEM;

int getboot(BOOT far *boot, int drive);

union REGS reg;
struct SREGS segreg;

struct
{
  unsigned long first_sect;
  unsigned nsect;
  void far* buf;
} cb;

int main(void)
{
  int i;
  int  root_begin, root_sectors;
  char drive;

  char boot[512];
  BOOT far* boot_rec = (BOOT far*) boot;

  FITEM *root_buffer, far *rptr;

  printf("\n⥭ ୥ ⠫ "
    "᪮ ᪠"
    "\n  (C)஫ ., 1995\n");

  // 訢 ,  ண 室
  // 믮 ⥭ 㧮筮 .
  printf("\n 祭 ᪠ (A, B, ...):");
  drive = getche();

  // 塞  ᪮
  drive = toupper(drive) - 'A';

  // ⠥ 㧮   
  int status = getboot((BOOT far*)boot_rec, drive);

  // ᫨ ந諠 訡 (ਬ, ࠢ쭮 㪠
  // 祭 ᪠), 蠠 ࠡ ணࠬ
  if(status)
  {
    printf("\n訡  ⥭ 㧮筮 ᥪ");
    return(-1);
  }

  // 塞  ࢮ ᥪ
  // ୥ ⠫
  root_begin = boot_rec->bpb.ressecs +
    boot_rec->bpb.fatsize * boot_rec->bpb.fatcnt;

  // 塞  ୥ ⠫
  root_sectors = (boot_rec->bpb.rootsize * 32) /
    boot_rec->bpb.sectsize;

  // 뢠   ୥ ⠫
  root_buffer = (FITEM *)
    malloc(root_sectors * boot_rec->bpb.sectsize);

  if(root_buffer == NULL)
  {
    printf("\n ");
    return(-1);
  }

  // ⠥ ୥ ⠫   root_buffer
  cb.first_sect = root_begin;
  cb.nsect = root_sectors;
  cb.buf = (void far*)root_buffer;

  _BX  = FP_OFF(&cb);
  _DS = FP_SEG(&cb);
  _CX  = 0xffff;
  _DX  = 0;
  _AX  = drive;
  asm int 25h
  asm pop ax
  asm jc error

  // 뢠 ᮤন ୥ ⠫
  printf("\n"
    "\n 䠩    .         "
    "६      "
    "\n------------ ----- ----------  "
    "--------  ------- ------");

  for(rptr = root_buffer;; rptr++)
  {
    printf("\n");

    // ਧ  ⠫ - 㫥   砫
    //  䠩   0xF6 (⮩ ⠫)
    if(rptr->name[0] == 0 ||
       rptr->name[0] == (char)0xF6) break;

    // 뢮 ᮤন ਯ 䠩
    for(i=0; i<8; i++)
      printf("%c",rptr->name[i]);

    printf(".");

    for(i=0; i<3; i++)
      printf("%c",rptr->ext[i]);

    printf(" %02X    %02d-%02d-%02d  %02d:%02d:%02d ",
      rptr->attr, rptr->date.day,
      rptr->date.month, rptr->date.year + 1980,
      rptr->time.hour, rptr->time.min,
      rptr->time.sec * 2);

    printf(" %-6ld   %lu",
      (long)rptr->cluster_nu, (long)rptr->size);
  }

  // ᢮ 
  free(root_buffer);
  return 0;

error:
  printf("\n訡  ⥭ ⠫");
  free(root_buffer);
  return(-1);
}

/**
* getboot
*
*  㧮 
*
* int getboot(BOOT far *boot, int drive);
*
*  boot   - 㪠⥫  ,  
*           㤥 ⠭ 㧮筠 
*
*  drive  -  䨧᪮ 
*           (0 -  , 1 - ன, ...)
**/
int getboot(BOOT far *boot, int drive)
{
  cb.first_sect = 0;
  cb.nsect = 1;
  cb.buf = (void far*)boot;

  _BX  = FP_OFF(&cb);
  _DS = FP_SEG(&cb);
  _CX  = 0xffff;
  _DX  = 0;
  _AX  = drive;

  asm int 25h

  //   ⥪ ⠢襥 ⠬ ᫥
  // 맮 뢠 ᫮
  asm pop ax
  asm jc err

  return(0);
err:
  return(1);
}

