// ----------------------------------------
//    
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>

//   
#define ID_SCROLL 1

//  
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

//   
char const szClassName[]   = "ScrollAppClass";

//  
char const szWindowTitle[] = "Scroll Demo";

//    
int nPosition;

//    
HWND hScroll;

//   
// 
HWND hStatic;

// =====================================
//  WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  //  
  if(!InitApp(hInstance))
      return FALSE;

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,    
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   //   
    0,                   //  
    hInstance,           //  
    NULL);               //   
			 // 

  //     ,  
  if(!hwnd)
    return FALSE;

  //   
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  //   
  hScroll = CreateWindow("scrollbar", NULL,
    WS_CHILD | WS_VISIBLE | SBS_HORZ,
    20, 60,
    200, 15,
    hwnd,
    (HMENU) ID_SCROLL,
    hInstance, NULL);

  //   
  nPosition = 100;

  //    
  //    
  SetScrollRange(hScroll, SB_CTL, 1, 200, TRUE);

  //    
  //  
  SetScrollPos(hScroll, SB_CTL, nPosition, TRUE);

  //      
  //  .  
  //    
  //   
  hStatic = CreateWindow("static", NULL,
    WS_CHILD | WS_VISIBLE | SS_BLACKRECT,
    20, 40,
    nPosition, 15,
    hwnd, (HMENU) -1,hInstance, NULL);

  //    
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
//  InitApp
//    
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //   
                  //  

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
//  WndProc
// =====================================


LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    //     
    case WM_HSCROLL:
    {
      //     
      //   
      switch (wParam)
      {
	case SB_PAGEDOWN:
	{
	  nPosition += 10;
	  break;
        }
	case SB_LINEDOWN:
	{
	  nPosition += 1;
	  break;
        }
	case SB_PAGEUP:
	{
	  nPosition -= 10;
	  break;
        }
	case SB_LINEUP:
	{
	  nPosition -= 1;
	  break;
        }
	case SB_TOP:
	{
          nPosition = 0;
	  break;
        }
	case SB_BOTTOM:
	{
	  nPosition = 200;
	  break;
        }
	case SB_THUMBPOSITION:
	{
          nPosition = LOWORD (lParam);
	  break;
        }
	case SB_THUMBTRACK:
	{
	  nPosition = LOWORD (lParam);
	  break;
        }
	default:
          break;
      }

      //    
      //    1  200
      if(nPosition > 200) nPosition = 200;
      if(nPosition < 1) nPosition = 1;

      //    
      //     
      //  
      SetScrollPos(hScroll, SB_CTL, nPosition, TRUE);

      //    
      //  
      MoveWindow(hStatic, 20, 40, nPosition, 15, TRUE);

      return 0;
    }

    //    
    //   
    case WM_KEYDOWN:
    {
      //       
      //    , 
      //    
      switch (wParam)
      {
	case VK_HOME:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_TOP, 0L);
          break;
        }
	case VK_END:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_BOTTOM, 0L);
          break;
        }
	case VK_LEFT:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_LINEUP, 0L);
          break;
        }
	case VK_RIGHT:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_LINEDOWN, 0L);
          break;
        }
	case VK_PRIOR:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_PAGEUP, 0L);
          break;
        }
	case VK_NEXT:
	{
	  SendMessage(hwnd, WM_HSCROLL, SB_PAGEDOWN, 0L);
          break;
        }
      }
      return 0;
    }
    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}