// ==================================================
//  SETLOCAL
//    
//
// ()  .., 1996
// Email: frolov@glas.apc.org
// ==================================================

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "resource.h"
#include "afxres.h"

#include "setlocal.h"

HINSTANCE hInst;
char szAppName[]  = "SetLocalApp";
char szAppTitle[] = "Set and Get Local Info";

//    
UINT uLayouts;

//     
//  
HKL * lpList;

// -----------------------------------------------------
//  WinMain
// -----------------------------------------------------
int APIENTRY 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
  WNDCLASSEX wc;
  HWND hWnd;
  MSG msg;
  
  //   
  hInst = hInstance;

  // ,       
  hWnd = FindWindow(szAppName, NULL);
  if(hWnd)
  {
    //  ,    
    //  
    if(IsIconic(hWnd))
	    ShowWindow(hWnd, SW_RESTORE);
	  SetForegroundWindow(hWnd);
    return FALSE;
  }

  //   
  //  
  uLayouts = GetKeyboardLayoutList(0, NULL);

  //     
  //  
  lpList = malloc(uLayouts * sizeof(HKL));

  //   
  //  
  uLayouts = GetKeyboardLayoutList(uLayouts, lpList);
  
  //   
  memset(&wc, 0, sizeof(wc));
  wc.cbSize = sizeof(WNDCLASSEX);
  wc.hIconSm = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICONSM), 
    IMAGE_ICON, 16, 16, 0);
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC)WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance = hInst;
  wc.hIcon = LoadImage(hInst,
    MAKEINTRESOURCE(IDI_APPICON), 
    IMAGE_ICON, 32, 32, 0);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
  wc.lpszMenuName = MAKEINTRESOURCE(IDR_APPMENU);
  wc.lpszClassName = szAppName;
  if(!RegisterClassEx(&wc))
    if(!RegisterClass((LPWNDCLASS)&wc.style))
	  return FALSE;
    
  //    
  hWnd = CreateWindow(szAppName, szAppTitle, 
     WS_OVERLAPPEDWINDOW, 
     CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, 
     NULL, NULL, hInst, NULL);
  if(!hWnd) return(FALSE);

  //      
  //  
  ShowWindow(hWnd, nCmdShow);
  UpdateWindow(hWnd);
  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }

  //     
  // ,    
  //  
  free(lpList);
 
  return msg.wParam;
}

// -----------------------------------------------------
//  WndProc
// -----------------------------------------------------
LRESULT WINAPI
WndProc(HWND hWnd, UINT msg, WPARAM wParam, 
        LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hWnd, WM_COMMAND, WndProc_OnCommand);
    HANDLE_MSG(hWnd, WM_DESTROY, WndProc_OnDestroy);

	  default:
      return(DefWindowProc(hWnd, msg, wParam, lParam));
  }
}

// -----------------------------------------------------
//  WndProc_OnDestroy
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnDestroy(HWND hWnd)
{
  PostQuitMessage(0);
  return 0L;
}

// -----------------------------------------------------
//  WndProc_OnCommand
// -----------------------------------------------------
#pragma warning(disable: 4098)
void WndProc_OnCommand(HWND hWnd, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  char szBuf[1024];
  char szBuf1[1024];
  char szKbLayoutName[KL_NAMELENGTH];
  BOOL fRc;
  
  switch (id)
  {
    case ID_FILE_EXIT:  
    {
	    //   
      PostQuitMessage(0);
	    return 0L;
	    break;
    }
	  
    //      
    case ID_LOCALINFO_SETENGLISH:
    {
      //     
      fRc = SetThreadLocale(MAKELCID(
        MAKELANGID(LANG_ENGLISH, SUBLANG_NEUTRAL), 
        SORT_DEFAULT));
      
      //        
      if(fRc == FALSE)
      {
        wsprintf(szBuf1,"SetThreadLocale: Error %ld\n", 
          GetLastError());
        MessageBox(hWnd, szBuf1, "Error", MB_OK);
      }
	    break;
    }
    
    //      
    case ID_LOCALINFO_SETRUSSIAN:
    {
      fRc = SetThreadLocale(MAKELCID(
        MAKELANGID(LANG_RUSSIAN, SUBLANG_NEUTRAL), 
        SORT_DEFAULT));

      if(fRc == FALSE)
      {
        wsprintf(szBuf1,"SetThreadLocale: Error %ld\n", 
          GetLastError());
        MessageBox(hWnd, szBuf1, "Error", MB_OK);
      }
	    break;
    }
    
    //     
    //   
    case ID_LOCALINFO_GETLOCALINFO:
    {
      //     
      strcpy(szBuf, "LOCALE_SLANGUAGE: ");
      GetLocaleInfo(
        GetThreadLocale(), LOCALE_SLANGUAGE, szBuf1, 512);
      strcat(szBuf, szBuf1);

      //   
      strcat(szBuf, "\nLOCALE_ICOUNTRY: ");
      GetLocaleInfo(
        GetThreadLocale(), LOCALE_ICOUNTRY, szBuf1, 512);
      strcat(szBuf, szBuf1);

      //    OEM
      strcat(szBuf, "\nLOCALE_IDEFAULTCODEPAGE: ");
      GetLocaleInfo(
        GetThreadLocale(), LOCALE_IDEFAULTCODEPAGE, szBuf1, 512);
      strcat(szBuf, szBuf1);

      //    ANSI
      strcat(szBuf, "\nLOCALE_IDEFAULTANSICODEPAGE: ");
      GetLocaleInfo(
        GetThreadLocale(), LOCALE_IDEFAULTANSICODEPAGE, szBuf1, 512);
      strcat(szBuf, szBuf1);

      MessageBox(hWnd, szBuf, szAppTitle, MB_OK);
	    break;
    }

    //    
    //   
    case ID_KEYBOARD_GETLAYOUTID:
    {
      GetKeyboardLayoutName(szKbLayoutName);
      wsprintf(szBuf1,"Layout ID: %s", szKbLayoutName);
      
      MessageBox(hWnd, szBuf1, szAppTitle, MB_OK);
	    break;
    }

    //    
    case ID_KEYBOARD_SETLAYOUT:
    {
      //     
      //  
      DialogBox(hInst, 
        MAKEINTRESOURCE(IDD_DIALOG_SETLAYOUT), 
        hWnd, DlgProc);

      break;      
    }
    
    //       ,
    //     
    case ID_LOCALINFO_GETDATE:
    {
      strcpy(szBuf, "Date: ");

      //   
      GetDateFormat(
        GetThreadLocale(),
        LOCALE_NOUSEROVERRIDE | DATE_LONGDATE,
        NULL, NULL, szBuf1, 512);
      
      strcat(szBuf, szBuf1);
      strcat(szBuf, "\nTime: ");
      
      //   
      GetTimeFormat(
        GetThreadLocale(),
        LOCALE_NOUSEROVERRIDE,
        NULL, NULL, szBuf1, 512);
      strcat(szBuf, szBuf1);
      
      //    
      MessageBox(hWnd, szBuf, szAppTitle, MB_OK);

      break;      
    }

    case ID_HELP_ABOUT:
    {
      MessageBox(hWnd, 
        "Set and Get Local Information\n"
        "(C) Alexandr Frolov, 1996\n"
        "Email: frolov@glas.apc.org",
        szAppTitle, MB_OK | MB_ICONINFORMATION);
	     return 0L;
	     break;
    }

  	default:
	    break;
  }
  return FORWARD_WM_COMMAND(hWnd, id, hwndCtl, codeNotify,
    DefWindowProc);
}


// -----------------------------------------------------
//  DlgProc
// -----------------------------------------------------
LRESULT WINAPI
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, 
        LPARAM lParam)
{
  switch(msg)
  {
    HANDLE_MSG(hdlg, WM_INITDIALOG, DlgProc_OnInitDialog);
    HANDLE_MSG(hdlg, WM_COMMAND,    DlgProc_OnCommand);

	default:
    return FALSE;
  }
}

// -----------------------------------------------------
//  DlgProc_OnInitDialog
// -----------------------------------------------------

BOOL DlgProc_OnInitDialog(HWND hdlg, HWND hwndFocus, 
                          LPARAM lParam)
{
  UINT i;
  HKL hklCurrent;
  char szBuf[256];

  //       
  //    
  //     
  //    COMBOBOX,   
  //  
  for(i=0; i<uLayouts; i++)
  {
    //     
    hklCurrent = *(lpList + i);

    //     
    GetLocaleInfo(
      MAKELCID(((UINT)hklCurrent & 0xffffffff), 
      SORT_DEFAULT),
      LOCALE_SLANGUAGE, szBuf, 512);

    //      
    //  COMBOBOX
    SendMessage(GetDlgItem(hdlg, IDC_COMBO1),
      CB_ADDSTRING, 0, (LPARAM)(LPSTR)szBuf);
  }

  return TRUE;
}

// -----------------------------------------------------
//  DlgProc_OnCommand
// -----------------------------------------------------
#pragma warning(disable: 4098)
void DlgProc_OnCommand(HWND hdlg, int id, 
  HWND hwndCtl, UINT codeNotify)
{
  //       COMBOBOX
  LRESULT uSelectedItem;

  switch (id)
  {
    //     OK, 
    //    
    //     
    case IDOK:
    {
      //      
      uSelectedItem = SendMessage(
        GetDlgItem(hdlg, IDC_COMBO1),
        CB_GETCURSEL, 0, 0);

      //    
      ActivateKeyboardLayout(*(lpList + uSelectedItem), 0);

      //    
      EndDialog(hdlg, 1);
      return TRUE;
    }

    //     Set layout, 
    //    ,
    //     
    case IDC_BUTTON1:
    {
      uSelectedItem = SendMessage(
        GetDlgItem(hdlg, IDC_COMBO1),
        CB_GETCURSEL, 0, 0);

      ActivateKeyboardLayout(*(lpList + uSelectedItem), 0);

      return TRUE;
    }

    //     Cancel, 
    //   ,  
    //   
    case IDCANCEL:
    {
      EndDialog(hdlg, 0);
      return TRUE;
    }
  	default:
	    break;
  }
  return FALSE;
}

