#include <dos.h>
#include <stdio.h>
#include <stdlib.h>

typedef struct _DFCB_
{
  unsigned handl_num;
  unsigned char access_mode;
  unsigned reserv1;
  unsigned dev_info;
  void far *driver;
  unsigned first_clu;
  unsigned time;
  unsigned date;
  unsigned long fl_size;
  unsigned long offset;
  unsigned reserv2;
  unsigned reserv7;
  unsigned reserv3;
  char reserv4;
  char filename[11];
  char reserv5[6];
  unsigned ownr_psp;
  unsigned reserv6;
  unsigned last_clu;
  char reserv8[4];
} DFCB;
typedef DFCB far* LPDFCB;

typedef struct _DFT_
{
  struct _DFT_ far *next;
  unsigned file_count;
  DFCB dfcb;
} SFT;
typedef SFT far* LPSFT;

typedef struct
{
  unsigned mcb_seg;
  void far *dev_cb;
  void far *file_tab;
  void far *clock_dr;
  void far *con_dr;
  unsigned max_btbl;
  void far *disk_buf;
  void far *drv_info;
  void far *fcb_tabl;
  unsigned fcb_size;
  unsigned char num_bdev;
  unsigned char lastdriv;
} CVT;
typedef CVT far* LPCVT;

void main(void);
LPSFT get_fsft(LPCVT cvt);
LPSFT get_nsft(LPSFT sft);

void main(void)
{
  union REGS   regs;
  struct SREGS sregs;
  LPCVT        lpCVT;
  LPSFT        lpSFT;
  unsigned     i,j,k;
  LPDFCB       lpDFCB;
  FILE *       list;

  printf("ଠ   䠩 MS-DOS\n"
    "(C) ஫ .., 1995\n");

  // 뢠 䠩  뢮 ଠ樨  䠩
  list = fopen("!sft.lst","w+");

  fprintf(list,"ଠ   䠩 MS-DOS\n"
    "(C) ஫ .., 1995\n\n");

  // 砥  ୮ ⠡ 裡
  regs.h.ah = 0x52;
  intdosx(&regs, &regs, &sregs);

  // । 㪠⥫   msb_seg
  lpCVT = (LPCVT)MK_FP(sregs.es, regs.x.bx - 2);

  lpSFT = get_fsft(lpCVT);  //  砫 ⠡ 䠩

  for(;;)
  {
    if(lpSFT == NULL) break;  //  ⠡

    i = lpSFT->file_count;
    fprintf(list," 䠩 SFT: %Fp,   %d 䠩\n"
      "===========================================\n",
      lpSFT, i);

    for(j=0; j<i; j++)
    {
      lpDFCB = (&(lpSFT->dfcb)) + j; //  DFCB 䠩

      fprintf(list,"\nDFCB 䠩: %Fp\n\n", lpDFCB);
      fprintf(list," 䠩: ");
      for(k=0; k<11; k++)
	fputc(lpDFCB->filename[k], list);

      fprintf(list,
       "\n⢮ 䨪஢:    %d\n"
       " 㯠:                 %d\n"
       " reserv1:                  %04X\n"
       "ଠ  ன⢥:      %04X\n"
       " ࠩ:                %Fp\n"
       "砫 :             %d\n"
       "६:                         %04X\n"
       ":                          %04X\n"
       " 䠩  :         %ld\n"
       "饥 ᬥ饭  䠩:      %ld\n"
       " reserv2:                  %04X\n"
       "᫥ ⠭ : %d\n"
       " PSP  䠩:   %04X\n"
       " reserv7:                  %d\n"
       "-------------------------------\n\n",
       lpDFCB->handl_num, lpDFCB->access_mode,
       lpDFCB->reserv1,   lpDFCB->dev_info,
       lpDFCB->driver,    lpDFCB->first_clu,
       lpDFCB->time,      lpDFCB->date,
       lpDFCB->fl_size,   lpDFCB->offset,
       lpDFCB->reserv2,   lpDFCB->last_clu,
       lpDFCB->ownr_psp,  lpDFCB->reserv7);
    }
    lpSFT = get_nsft(lpSFT);
  }
  fclose(list);
}

LPSFT get_nsft(LPSFT sft)
{
  LPSFT sft_next;

  sft_next = sft->next;
  if(FP_OFF(sft_next) == 0xffff)
    return((LPSFT)NULL);

  return(sft_next);
}

LPSFT get_fsft(LPCVT cvt)
{
  LPSFT sft;
  sft = (LPSFT)cvt->file_tab;
  return(sft);
}

