#define STRICT
#include <windows.h>
#include <commdlg.h>
#include <mem.h>
#include <string.h>
#include <stdlib.h>

#include "toolbar.hpp"
#include "smartpad.hpp"

// ======================================================
//  
// ======================================================

BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

BOOL CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK _export
EditWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

HFILE OpenFile(void);
HFILE OpenSaveFile(void);
int SaveFileAs(HWND hwnd);
int SaveFile(HWND hwnd);
int SelectFile(HWND hwnd);

// ======================================================
//  
// ======================================================

//   
char const szClassName[]   = "SmartPadAppClass";

//  
char const szWindowTitle[] = "Smart Pad";

//     
//   
HINSTANCE hInst;

//      TOOLBAR
Toolbar *Tb;

//     
HMENU hmenuAppMenu;
HMENU hmenuSystemMenu;

//   
HACCEL haccel;

//   
HWND hEdit;

//      
BOOL bNeedSave;

//    
char szCurrentFileName[128];

//  
char szTempBuffer[128];

//   
BOOL bReadOnly = FALSE;

//  
HFILE hfSrcFile, hfDstFile;

//     
DLGPROC lpfnDlgProc;
WNDPROC lpfnEditOldWndProc;
WNDPROC lpfnEditWndProc;

//   
HWND    hwndMain;


// ======================================================
//  WinMain
// ======================================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance, 
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   //     
  HWND hwnd;  //    

  //     
  hInst = hInstance;

  //  
  if(!InitApp(hInstance))
      return FALSE;

  //    
  hmenuAppMenu = LoadMenu(hInstance, "APP_MENU");

  //     
  //   
  hwnd = CreateWindow(
    szClassName,         //   
    szWindowTitle,       //  
    WS_OVERLAPPEDWINDOW, //  
    CW_USEDEFAULT,       //    
    CW_USEDEFAULT,       // ,    
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   //   
    hmenuAppMenu,        //  
    hInstance,           //  
    NULL);               //   
			 // 
  //     ,  
  if(!hwnd)
    return FALSE;

  //     
  //  
  hwndMain = hwnd;

  //   
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  //    TOOLBAR
  Tb = new Toolbar(hInstance, hwnd, TB_FIRST);

  //      TOOLBAR
  Tb->InsertButton(0,
     MAKEINTRESOURCE(IDB_NEWUP),
     MAKEINTRESOURCE(IDB_NEWDOWN), MAKEINTRESOURCE(IDB_NEWUP));
  
  Tb->InsertButton(1,
     MAKEINTRESOURCE(IDB_OPENUP),
     MAKEINTRESOURCE(IDB_OPENDOWN), MAKEINTRESOURCE(IDB_OPENGR));

  Tb->InsertButton(2,
     MAKEINTRESOURCE(IDB_SAVEUP),
     MAKEINTRESOURCE(IDB_SAVEDOWN), MAKEINTRESOURCE(IDB_SAVEGR));

  Tb->InsertButton(4,
     MAKEINTRESOURCE(IDB_CUTUP),
     MAKEINTRESOURCE(IDB_CUTDOWN), MAKEINTRESOURCE(IDB_CUTGR));

  Tb->InsertButton(5,
     MAKEINTRESOURCE(IDB_COPYUP),
     MAKEINTRESOURCE(IDB_COPYDOWN), MAKEINTRESOURCE(IDB_COPYGR));

  Tb->InsertButton(6,
     MAKEINTRESOURCE(IDB_PASTUP),
     MAKEINTRESOURCE(IDB_PASTDOWN), MAKEINTRESOURCE(IDB_PASTGR));

  Tb->InsertButton(7,
     MAKEINTRESOURCE(IDB_UNDOUP),
     MAKEINTRESOURCE(IDB_UNDODOWN), MAKEINTRESOURCE(IDB_UNDOGR));

  Tb->InsertButton(9,
     MAKEINTRESOURCE(IDB_EXITUP),
     MAKEINTRESOURCE(IDB_EXITDOWN), MAKEINTRESOURCE(IDB_EXITGR));

  Tb->InsertButton(10,
     MAKEINTRESOURCE(IDB_HELPUP),
     MAKEINTRESOURCE(IDB_HELPDOWN), MAKEINTRESOURCE(IDB_HELPGR));

  //   
  haccel = LoadAccelerators(hInstance, "APP_ACCELERATORS");

  //    
  while(GetMessage(&msg, 0, 0, 0))
  {
    if(!haccel || !TranslateAccelerator(hwnd, haccel, &msg))
    {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }
  return msg.wParam;
}

// ======================================================
//  InitApp
//    
// ======================================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; //    
  WNDCLASS wc;    //     

  //       
  memset(&wc, 0, sizeof(wc));

  wc.lpszMenuName  = NULL;
  wc.style         = 0;
  wc.lpfnWndProc   = (WNDPROC) WndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon         = LoadIcon(hInstance, "APPICON");
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszClassName = (LPSTR)szClassName;

  //  
  aWndClass = RegisterClass(&wc);
  return (aWndClass != 0);
}

// ======================================================
//      
// ======================================================

LRESULT CALLBACK _export
EditWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  //       
  //   ,     
  //  
  if(msg == WM_RBUTTONDOWN)
  {
    HMENU hmenuPopup;
    POINT pt;

    //      
    pt = MAKEPOINT(lParam);
    ClientToScreen(hwnd, &pt);

    //    
    hmenuPopup = CreatePopupMenu();

    //   
    AppendMenu(hmenuPopup, MF_BYCOMMAND | MF_ENABLED,
         CM_FILENEW, "&New");
    AppendMenu(hmenuPopup, MF_BYCOMMAND | MF_ENABLED,
         CM_FILEOPEN, "&Open");
    AppendMenu(hmenuPopup, MF_BYCOMMAND | MF_ENABLED,
         CM_FILESAVE, "&Save");
    AppendMenu(hmenuPopup, MF_SEPARATOR, 0, 0);
    AppendMenu(hmenuPopup, MF_BYCOMMAND | MF_ENABLED,
         CM_FILEEXIT, "E&xit");

    //       
    TrackPopupMenu(hmenuPopup,
      TPM_CENTERALIGN | TPM_LEFTBUTTON,
      pt.x, pt.y, 0, hwndMain, NULL);

    //   
    DestroyMenu(hmenuPopup);
  }
  //      
  return CallWindowProc(lpfnEditOldWndProc,
     hwnd, msg, wParam, lParam);
}

// ======================================================
//     WndProc
// ======================================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  HFONT hfont;

  switch (msg)
  {
    case WM_CREATE:
    {
      //   
      hEdit = CreateWindow("edit", NULL,
	 WS_CHILD | WS_VISIBLE | WS_BORDER |
         WS_HSCROLL | WS_VSCROLL |
	 ES_LEFT | ES_AUTOHSCROLL | ES_AUTOVSCROLL |
	 ES_MULTILINE,
	 0, 30, 100, 100,
	 hwnd, (HMENU) ID_EDIT, hInst, NULL);

      //      
      //   
      hfont = GetStockFont(ANSI_VAR_FONT);
      SendMessage(hEdit, WM_SETFONT, (WPARAM)hfont,
        (LPARAM)MAKELONG((WORD)TRUE, 0));

      //        
      lpfnEditWndProc =
         (WNDPROC)MakeProcInstance((FARPROC)EditWndProc, hInst);
       
      //       
      lpfnEditOldWndProc = (WNDPROC)GetWindowLong(hEdit, GWL_WNDPROC);

      //       
      SetWindowLong(hEdit, GWL_WNDPROC, (LONG)lpfnEditWndProc);

      //   
      //  ,  32000 
      SendMessage(hEdit, EM_LIMITTEXT, 32000, 0L);

      //      
      //  
      bNeedSave = FALSE;
      bReadOnly = FALSE;

      //         ,
      //        
      lstrcpy(szCurrentFileName, "");

      //    
      SetWindowText(hwnd, "SmartPad - [UNTITLED]");

      //    
      hmenuSystemMenu = GetSystemMenu(hwnd, FALSE);

      //      
      //   "About"
      AppendMenu(hmenuSystemMenu, MF_SEPARATOR, 0, 0);
      AppendMenu(hmenuSystemMenu, MF_BYCOMMAND | MF_ENABLED,
         CM_SYSABOUT, "&About...");

      //      "Close"
      EnableMenuItem(hmenuSystemMenu, SC_CLOSE,
        MF_BYCOMMAND | MF_GRAYED);

      return 0;
    }

    case WM_SIZE:
    {
      //     
      //   TOOLBAR
      Tb->SetWidth(LOWORD(lParam));

      //    
      // ( )  
      //     
      MoveWindow(hEdit, 0, 26, LOWORD(lParam),
	HIWORD(lParam) - 26, TRUE);

      return 0;
    }

    //     
    //  ,    
    case WM_SETFOCUS:
    {
      SetFocus(hEdit);
      return 0;
    }

    //      
    case WM_SYSCOMMAND:
    {
      //     
      //  wParam
      if((wParam & 0xfff0) == CM_SYSABOUT)
      {
        //     
        lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, hInst);

        //    
        DialogBox(hInst, "ABOUT", hwnd, lpfnDlgProc);
        return 0;
      }

      //   "Close".    
      // ,      
      //   EnableMenuItem
      else if((wParam & 0xfff0) == SC_CLOSE)
        return 0;
      break;
    }

    //       TOOLBAR
    case WM_COMMAND:
    {
       switch(wParam)
       {
         //    
         case ID_EDIT:
         {
           // 
           if(HIWORD(lParam) == EN_ERRSPACE)
	   {
	     MessageBox(hwnd, " ",
	       szWindowTitle, MB_OK);
	   }

	   //    
           // 
	   else if(HIWORD(lParam) == EN_UPDATE)
	   {
             //    
             bNeedSave = TRUE;
           }
           return 0;
         }

         //     ,  
         //    
         case CM_HELPUSING_HELP:
         case CM_HELPPROCEDURES:
         case CM_HELPCOMMANDS:
         case CM_HELPKEYBOARD:
         case CM_HELPINDEX:
         case CM_FILEPRINTER_SETUP:
         case CM_FILEPAGE_SETUP:
         case CM_FILEPRINT:
         {
	   MessageBox(hwnd, "   "
                " SmartPad    ",
                NULL, MB_OK);
           return 0;
         }

         //      
         //    
         case TB_HELP:
         case CM_HELPABOUT:
         {
           //     
           lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, hInst);

           //    
           DialogBox(hInst, "ABOUT", hwnd, lpfnDlgProc);

           //  
           FreeProcInstance((FARPROC) lpfnDlgProc);

           return 0;
         }

         //    
         case CM_EDITSETREADONLY:
         {
           //     ,
           //   
           if(!bReadOnly)
           {
             //  
             SendMessage(hEdit, EM_SETREADONLY, TRUE, 0L);

             //     
             CheckMenuItem(hmenuAppMenu, CM_EDITSETREADONLY,
               MF_BYCOMMAND | MF_CHECKED);

             //    
             bReadOnly = TRUE;
           }
           //     ,
           //   
           else
           {
             SendMessage(hEdit, EM_SETREADONLY, FALSE, 0L);
             CheckMenuItem(hmenuAppMenu, CM_EDITSETREADONLY,
               MF_BYCOMMAND | MF_UNCHECKED);
             bReadOnly = FALSE;
           }

           //      
           SetFocus(hEdit);
           return 0;
         }

         case CM_EDITPASTE:
         case TB_PAST:
         {
           SendMessage(hEdit, WM_PASTE, 0, 0L);
           SetFocus(hEdit);
           return 0;
         }

         case CM_EDITCOPY:
         case TB_COPY:
         {
           SendMessage(hEdit, WM_COPY, 0, 0L);
           SetFocus(hEdit);
           return 0;
         }

         case CM_EDITCUT:
         case TB_CUT:
         {
           SendMessage(hEdit, WM_CUT, 0, 0L);
           SetFocus(hEdit);
           return 0;
         }

         case CM_EDITCLEAR:
         {
           SendMessage(hEdit, WM_CLEAR, 0, 0L);
           SetFocus(hEdit);
           return 0;
         }

         case CM_EDITSELALL:
         {
           SendMessage(hEdit, EM_SETSEL, 0, MAKELPARAM(0, -1));
           SetFocus(hEdit);
           return 0;
         }

         case CM_EDITUNDO:
         case TB_UNDO:
         {
           SendMessage(hEdit, EM_UNDO, 0, 0L);
           SetFocus(hEdit);
           return 0;
         }

         //   
         case TB_EXIT:
         case CM_FILEEXIT:
         {
           //   
           if(bNeedSave)
           {
             //     ,
             //   ,  
             //    
	     if(IDYES == MessageBox(hwnd,
	         "  .  ?",
	          szWindowTitle, MB_YESNO | MB_ICONQUESTION))
             {
               //      ,
               //      
               if(szCurrentFileName[0] == '\0')
               {
                 SaveFileAs(hwnd);

                 //     
                 //         
                 wsprintf(szTempBuffer, "SmartPad - [%s]",
                    (LPSTR)szCurrentFileName);
                 SetWindowText(hwnd, szTempBuffer);
               }

               //    ,  
               //   
               else
                 SaveFile(hwnd);
               }
             }

           //   
           DestroyWindow(hwnd);
           return 0;
         }

         case CM_FILENEW:
         case TB_NEW:
         {
           //   
           if(bNeedSave)
           {
	     if(IDYES == MessageBox(hwnd,
	         "  .  ?",
	          szWindowTitle, MB_YESNO | MB_ICONQUESTION))
             {
               if(szCurrentFileName[0] == '\0')
               {
                 SaveFileAs(hwnd);
                 wsprintf(szTempBuffer, "SmartPad - [%s]",
                   (LPSTR)szCurrentFileName);
                 SetWindowText(hwnd, szTempBuffer);
               }
               else
                 SaveFile(hwnd);
             }
           }

           //    
	   SetWindowText(hEdit, "\0");

           bNeedSave = FALSE;

           lstrcpy(szCurrentFileName, "");
           SetWindowText(hwnd, "SmartPad - [UNTITLED]");

           SetFocus(hEdit);
           return 0;
         }

         case CM_FILEOPEN:
         case TB_OPEN:
         {
           //   
           if(bNeedSave)
           {
	     if(IDYES == MessageBox(hwnd,
	         "  .  ?",
	          szWindowTitle, MB_YESNO | MB_ICONQUESTION))
             SaveFile(hwnd);
           }


           if(!SelectFile(hwnd))
           {
             lstrcpy(szCurrentFileName, "");
             SetWindowText(hwnd, "SmartPad - [UNTITLED]");
           }
           else
           {
             wsprintf(szTempBuffer, "SmartPad - [%s]",
               (LPSTR)szCurrentFileName);
             SetWindowText(hwnd, szTempBuffer);
           }

           return 0;
         }

         case CM_FILESAVEAS:
         {
           if(SaveFileAs(hwnd))
           {
             wsprintf(szTempBuffer, "SmartPad - [%s]",
               (LPSTR)szCurrentFileName);
             SetWindowText(hwnd, szTempBuffer);
           }
           else
           {
             lstrcpy(szCurrentFileName, "");
             SetWindowText(hwnd, "SmartPad - [UNTITLED]");
           }
           return 0;
         }

         case CM_FILESAVE:
         case TB_SAVE:
         {
           if(szCurrentFileName[0] == '\0')
           {
             if(SaveFileAs(hwnd))
             {
               wsprintf(szTempBuffer, "SmartPad - [%s]",
                 (LPSTR)szCurrentFileName);
               SetWindowText(hwnd, szTempBuffer);
             }
             else
             {
               lstrcpy(szCurrentFileName, "");
               SetWindowText(hwnd, "SmartPad - [UNTITLED]");
             }
           }
           else
             SaveFile(hwnd);
           return 0;
         }

         default:
           break;
       }
       break;
    }

    //      
    //   Windows.    
    //  ,   ,
    //    
    case WM_QUERYENDSESSION:
    {
      //   
      if(bNeedSave)
      {
        if(IDYES == MessageBox(hwnd,
	    "  .  ?",
	     szWindowTitle, MB_YESNO | MB_ICONQUESTION))
        {
           if(szCurrentFileName[0] == '\0')
           {
              SaveFileAs(hwnd);
              wsprintf(szTempBuffer, "SmartPad - [%s]",
                (LPSTR)szCurrentFileName);
              SetWindowText(hwnd, szTempBuffer);
           }
           else
              SaveFile(hwnd);
        }
      }

      //    Windows
      //   
      return 1L;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// ======================================================
//  OpenFile
//  
// ======================================================

HFILE OpenFile(void)
{
  //    
  OPENFILENAME ofn;

  //       
  char szFile[256];

  //      
  char szFileTitle[256];

  //    
  char szFilter[256] =
	 "Text Files\0*.txt;*.doc\0Any Files\0*.*\0";

  //   
  HFILE hf;

  //    
  //  ,    
  szFile[0] = '\0';

  //      
  // ,    
  //  
  memset(&ofn, 0, sizeof(OPENFILENAME));

  //    

  ofn.lStructSize       = sizeof(OPENFILENAME);
  ofn.hwndOwner         = NULL;
  ofn.lpstrFilter       = szFilter;
  ofn.nFilterIndex      = 1;
  ofn.lpstrFile         = szFile;
  ofn.nMaxFile          = sizeof(szFile);
  ofn.lpstrFileTitle    = szFileTitle;
  ofn.nMaxFileTitle     = sizeof(szFileTitle);
  ofn.lpstrInitialDir   = NULL;
  ofn.Flags =   OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST
				  | OFN_HIDEREADONLY;

  //   
  if (GetOpenFileName(&ofn)) {

    //   
    hf = _lopen(ofn.lpstrFile, OF_READ);

    //     
    lstrcpy(szCurrentFileName, ofn.lpstrFile);

    //   
    return hf;
  }
  //     
  //  
  else return 0;
}

// ======================================================
//  OpenSaveFile
//    
// ======================================================

HFILE OpenSaveFile(void)
{
  OPENFILENAME ofn;

  char szFile[256];
  char szFileTitle[256];
  char szFilter[256] =
	 "Text Files\0*.txt\0Any Files\0*.*\0";

  HFILE hf;

  szFile[0] = '\0';

  memset(&ofn, 0, sizeof(OPENFILENAME));

  ofn.lStructSize       = sizeof(OPENFILENAME);
  ofn.hwndOwner         = NULL;
  ofn.lpstrFilter       = szFilter;
  ofn.nFilterIndex      = 1;
  ofn.lpstrFile         = szFile;
  ofn.nMaxFile          = sizeof(szFile);
  ofn.lpstrFileTitle    = szFileTitle;
  ofn.nMaxFileTitle     = sizeof(szFileTitle);
  ofn.lpstrInitialDir   = NULL;
  ofn.Flags             = OFN_HIDEREADONLY;

  //   
  if (GetSaveFileName(&ofn)) {

    //    
    hf = _lcreat(ofn.lpstrFile, 0);

    //    
    lstrcpy(szCurrentFileName, ofn.lpstrFile);

    return hf;
  }
  else
    return 0;
}

// ======================================================
//  SaveFileAs
//     
// ======================================================
int SaveFileAs(HWND hwnd)
{
  WORD wSize;
  HANDLE hTxtBuf;
  NPSTR  npTextBuffer;

  //   
  hfDstFile = OpenSaveFile();
  if(!hfDstFile) return 0;

  //   
  wSize = GetWindowTextLength(hEdit);

  //    ,
  //     
  hTxtBuf = (HANDLE) SendMessage(hEdit, EM_GETHANDLE, 0, 0L);

  //      
  //  
  npTextBuffer = (NPSTR)LocalLock(hTxtBuf);

  //      
  if(wSize != _lwrite(hfDstFile, npTextBuffer, wSize))
  {
    //       
    _lclose(hfDstFile);
    MessageBox(hwnd, "   ",
       szWindowTitle, MB_OK);
    return 0;
  }

  //  
  _lclose(hfDstFile);

  //   
  LocalUnlock(hTxtBuf);

  //       ,
  //    
  bNeedSave = FALSE;
  SetFocus(hEdit);

  return 1;
}

// ======================================================
//  SaveFile
//     
// ======================================================
int SaveFile(HWND hwnd)
{
  WORD wSize;
  HANDLE hTxtBuf;
  NPSTR  npTextBuffer;


  //   
  hfDstFile = _lopen(szCurrentFileName, OF_WRITE);
  if(!hfDstFile) return 0;

  //   
  wSize = GetWindowTextLength(hEdit);

  //    ,
  //     
  hTxtBuf = (HANDLE) SendMessage(hEdit, EM_GETHANDLE, 0, 0L);

  //      
  //  
  npTextBuffer = (NPSTR)LocalLock(hTxtBuf);

  //      
  if(wSize != _lwrite(hfDstFile, npTextBuffer, wSize))
  {
    //       
    _lclose(hfDstFile);
    MessageBox(hwnd, "   ",
       szWindowTitle, MB_OK);
    return 0;
  }

  //  
  _lclose(hfDstFile);

  //   
  LocalUnlock(hTxtBuf);

  //       ,
  //    
  bNeedSave = FALSE;
  SetFocus(hEdit);

  return 1;
}

// ======================================================
//  SelectFile
//      
// ======================================================

int SelectFile(HWND hwnd)
{
  LPSTR lpTextBuffer;
  DWORD dwFileSize, dwCurrentPos;

  //   .
  hfSrcFile = OpenFile();
  if(!hfSrcFile) return 0;

  //   
  dwCurrentPos = _llseek(hfSrcFile, 0L, 1);
  dwFileSize   = _llseek(hfSrcFile, 0L, 2);
  _llseek(hfSrcFile, dwCurrentPos, 0);

  //      32000 
  if(dwFileSize >= 32000)
  {
     _lclose(hfSrcFile);
     MessageBox(hwnd, "   32000 ",
        szWindowTitle, MB_OK);
     return 0;
  }

  //     
  lpTextBuffer = (LPSTR)malloc(32000);
  if(lpTextBuffer == NULL)
     return 0;

  //      
  _lread(hfSrcFile, lpTextBuffer, dwFileSize);

  //    
  lpTextBuffer[(WORD)dwFileSize] = '\0';

  //  
  _lclose(hfSrcFile);

  //    
  //  
  SetWindowText(hEdit, lpTextBuffer);

  //  
  free((void *)lpTextBuffer);

  //   
  bNeedSave = FALSE;
  SetFocus(hEdit);
  return 1;
}

// ======================================================
//  DldProc
// ======================================================
#pragma argsused

BOOL CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    //   
    case WM_INITDIALOG:
    {
      return TRUE;
    }

    case WM_COMMAND:
    {
      switch(wParam)
      {
        //    "OK"
        case IDOK:

        //   .
        //   ,  
        //    <Esc>
        case IDCANCEL:
        {
          //    
          EndDialog(hdlg, 0);
          return TRUE;
        }
      }
    }
  }
  return FALSE;
}
