#include <windows.h>
#include <windowsx.h>
#include <mem.h>

//    TOOLBAR
LRESULT CALLBACK _export
ToolbarWndProc(HWND, UINT, WPARAM, LPARAM);

// ======================================================
//   TbMain
// ======================================================
class TbMain
{
public:
  //  
  static HINSTANCE hInst;

  //               
  static HBITMAP   hbmpUp[20];     //   
  static HBITMAP   hbmpDown[20];   // 
  static HBITMAP   hbmpGrayed[20]; // 

  //   ,  TOOLBAR
  static HWND      hwndParent;

  //     TOOLBAR
  static int       nFirstId;
};

// ======================================================
//   Toolbar
// ======================================================
class Toolbar
{
  RECT     rcParent;        //   
  RECT     rcToolbar;       //  TOOLBAR
  ATOM     aWndClass;       //    
  char     szClassName[20]; //  
  HWND     hwndToolbar;     //   TOOLBAR
  HWND     hButton[20];     //  
  int      errno;           //  

public:

// ======================================================
//    TOOLBAR
// ======================================================
  void GetRect(void)
  {
    rcToolbar.left   = GetRectLeft();
    rcToolbar.top    = GetRectTop();
    rcToolbar.right  = GetRectRihgt();
    rcToolbar.bottom = GetRectBottom();
  }

// ======================================================
//     TOOLBAR
// ======================================================
  virtual BOOL RegisterWndClass(void)
  {
    WNDCLASS wc; //     

    memset(&wc, 0, sizeof(wc));

    wc.style         = 0;
    wc.lpfnWndProc   = (WNDPROC) ToolbarWndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = TbMain::hInst;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.lpszMenuName  = (LPSTR)NULL;

    //     
    wc.hbrBackground = GetBrush();

    //  
    lstrcpy(szClassName, "FrolovAVToolBar");
    wc.lpszClassName = (LPSTR)szClassName;

    //  
    aWndClass = RegisterClass(&wc);
    return (aWndClass != 0);
  }

// ======================================================
//   ,   
//    TOOLBAR
// ======================================================
  void CreateTbWindow(void)
  {
    hwndToolbar = CreateWindow(
    szClassName,                 //   
    NULL,                        //  
    WS_CHILDWINDOW | WS_VISIBLE, //  
    rcToolbar.left,              //  
    rcToolbar.top,               //     
    rcToolbar.right,
    rcToolbar.bottom,
    TbMain::hwndParent,          //   
    0,                           //  
    TbMain::hInst,               //  
    NULL);                   //    
  }

// ======================================================
//    TOOLBAR
// ======================================================
  void SetWidth(int nWidth)
  {
    RECT rcOld;

    GetClientRect(hwndToolbar, &rcOld);

    MoveWindow(hwndToolbar,
      rcOld.left, rcOld.top,
      nWidth, rcOld.bottom, TRUE);
  }

// ======================================================
//    TOOLBAR
// ======================================================
  BOOL InsertButton(UINT nPosition,
       LPCSTR lpszBmpUp, LPCSTR lpszBmpDown, LPCSTR lpszBmpGrayed)
  {
     //      
     TbMain::hbmpUp[nPosition] =
       LoadBitmap(TbMain::hInst, lpszBmpUp);
     TbMain::hbmpDown[nPosition] =
       LoadBitmap(TbMain::hInst, lpszBmpDown);
     TbMain::hbmpGrayed[nPosition] =
       LoadBitmap(TbMain::hInst, lpszBmpGrayed);

     //    - , 
     //   .     
     //  TOOLBAR
     hButton[nPosition] = CreateWindow("button", NULL,
       WS_CHILD | WS_VISIBLE | BS_OWNERDRAW,
       GetBtnX(nPosition),  //    
       GetBtnY(nPosition),  //      
       GetBmpWidth(),       //      
       GetBmpHeigt(),       //  
       hwndToolbar,         //    
       (HMENU)(nPosition + TbMain::nFirstId), //  
       TbMain::hInst, NULL);
     return TRUE;
  }

// ======================================================
//    Toolbar
// ======================================================
  Toolbar(HINSTANCE hInst, HWND hwndParent, int nFirstid);

// ======================================================
//    Toolbar
// ======================================================
  ~Toolbar();

  //   
  int Error(void) { return errno; }

  //    TOOLBAR
  virtual int GetRectLeft(void)   { return 0; }
  virtual int GetRectTop(void)    { return 0; }
  virtual int GetRectRihgt(void)  { return rcParent.right; }
  virtual int GetRectBottom(void) { return 26; }

  //     TOOLBAR
  virtual HBRUSH GetBrush(void)
  {
     return GetStockBrush(LTGRAY_BRUSH);
  }

  //       
  virtual int GetBtnX(int nPosition)
  {
     return 3 + (nPosition * 30);
  }

  virtual int GetBtnY(int nPosition)   { return 3; }

  //   
  virtual int GetBmpWidth(void) { return 30; }
  virtual int GetBmpHeigt(void) { return 20; }
};
