// (C)  .., 1995
//  E-mail: frolov@glas.apc.org

// ----------------------------------------------------
//     
// ----------------------------------------------------
#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <commdlg.h>
#include <string.h>
#include "prnfile.hpp"

//  
BOOL CALLBACK _export
AbortDlgFunc(HWND hdlg, UINT msg,
   WPARAM wParam, LPARAM lParam);

BOOL CALLBACK _export AbortFunc(HDC hdc, int nCode);
HDC GetPrinterDC(HWND);

//    
extern HWND hdlgAbort;
extern BOOL fAbort;

BOOL fAbort = FALSE;
HWND hdlgAbort = 0;
static PRINTDLG pd;

// ----------------------------------------------------
//  PrintFile
//  
// ----------------------------------------------------

BOOL PrintFile(HWND hwnd, NPSTR npBuff, WORD wSize)
{
  HDC hdc;
  int cyPage;
  int cyChar, yPos, nLength;
  int i;
  WORD wCurPos = 0;
  TEXTMETRIC tm;

  ABORTPROC lpAbortFunc;
  BOOL fDone;
  char abBuffer[256];
  DOCINFO docinfo;
  DLGPROC lpAbortDlgFunc;
  HINSTANCE hInst;
  int rc;

  //      
  hdc = GetPrinterDC(hwnd);

  //     
  cyPage = GetDeviceCaps(hdc, VERTRES);

  //   
  GetTextMetrics(hdc, &tm);

  //    
  cyChar = tm.tmHeight + tm.tmExternalLeading;

  //     AbortFunc 
  hInst = GetWindowInstance(hwnd);
  lpAbortFunc =
     (ABORTPROC)MakeProcInstance((FARPROC)AbortFunc, hInst);

  //   AbortProc
  rc = SetAbortProc(hdc, lpAbortFunc);
  if(rc <= 0)
  {
    DeleteDC(hdc);
    return FALSE;
  }

  //     
  lpAbortDlgFunc =
     (DLGPROC)MakeProcInstance((FARPROC)AbortDlgFunc, hInst);

  //      
  hdlgAbort = CreateDialogParam (
        hInst, MAKEINTRESOURCE(IDD_ABORT),
        hwnd, lpAbortDlgFunc, NULL) ;

  if(!hdlgAbort)
  {
    FreeProcInstance((FARPROC)lpAbortFunc);
    DeleteDC(hdc);
    return FALSE;
  }

  //   
  ShowWindow(hdlgAbort, SW_SHOWNORMAL);
  UpdateWindow(hdlgAbort);

  //     
  // 
  EnableWindow(hwnd, FALSE);

  //   docinfo
  docinfo.cbSize      = sizeof(docinfo);
  docinfo.lpszDocName = NULL;
  docinfo.lpszOutput  = NULL;

  //   
  rc = StartDoc(hdc, &docinfo);
  if(rc <= 0)
  {
    DestroyWindow(hdlgAbort);
    FreeProcInstance((FARPROC)lpAbortFunc);
    FreeProcInstance((FARPROC)lpAbortDlgFunc);
    DeleteDC(hdc);
    return FALSE;
  }

  //    
  fDone = FALSE;

  //    
  while(!fDone && !fAbort)
  {
     //    
     StartPage(hdc);
 
     //    
     yPos = 0;

     //    
     while(yPos + cyChar < cyPage)
     {
        //     
        if(wCurPos > wSize)
        {
          fDone = TRUE;
          break;
        }

        i=0;
        nLength = 0;

        //   
        //     abBuffer
        while((npBuff[wCurPos] != 0x0d) &&
              (wCurPos < wSize))
        {
          abBuffer[i] = npBuff[wCurPos];
          i++;
          wCurPos++;
          nLength++;
        }

        //     
        TextOut(hdc, 0, yPos, abBuffer, nLength);

        //    
        wCurPos += 2;
        yPos += cyChar ;
     }

     //   
     rc = EndPage(hdc);
     if(rc < 0)
     {
       fAbort = TRUE;
       break;
     }
  }

  //     
  //  AbortDoc,   - EndDoc
  if(fAbort)
    AbortDoc(hdc);
  else
    EndDoc(hdc);

  //    
  EnableWindow(hwnd, TRUE);

  //   
  DestroyWindow(hdlgAbort);

  //  
  FreeProcInstance((FARPROC)lpAbortFunc);
  FreeProcInstance((FARPROC)lpAbortDlgFunc);
  DeleteDC(hdc);

  return TRUE ;
}

// ----------------------------------------------------
//  AbortDlgFunc
//     ,
//     
// ----------------------------------------------------
#pragma argsused

BOOL CALLBACK _export
AbortDlgFunc(HWND hdlg,
  UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    //  
    case WM_INITDIALOG:
    {
       fAbort = FALSE;
       hdlgAbort = hdlg;
       return TRUE;
    }

    case WM_COMMAND:
    {
      //     
      if (wParam == IDOK || wParam == IDCANCEL)
      {
        fAbort = TRUE;
        return TRUE;
      }
      return FALSE;
    }

    case WM_DESTROY:
    {
       hdlgAbort = 0;
       return FALSE;
    }
  }
  return FALSE;
}

// ----------------------------------------------------
//  AbortFunc
//    
//     
// ----------------------------------------------------
#pragma argsused

BOOL CALLBACK _export
AbortFunc(HDC hdc, int nCode)
{
  MSG msg;

  //    
  while(PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
  {
    if(!hdlgAbort || !IsDialogMessage (hdlgAbort, &msg))
    {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }

  return(!fAbort);
}

// ----------------------------------------------------
//  GetprinterDC
//      "Print",
//      .
//    
//  
// ----------------------------------------------------

HDC GetPrinterDC(HWND hwnd)
{
  BOOL fResult;

  //   PRINTDLG
  memset(&pd, 0, sizeof(PRINTDLG));

  pd.lStructSize = sizeof(PRINTDLG);
  pd.hwndOwner   = hwnd;
  pd.Flags       = PD_RETURNDC;

  //   
  fResult = PrintDlg(&pd);

  //    , 
  //  PrintDlg   DEVMODE  DEVNAMES
  if(pd.hDevMode != 0)
    GlobalFree (pd.hDevMode);

  if(pd.hDevNames != 0)
    GlobalFree (pd.hDevNames);

  //     
  //  
  if(fResult)
    return pd.hDC;

  else
    return 0;
}

