#include <windows.h>
#include "tele.h"

//   
static int	nyCurrRow, nxCurrCol;

//      
static int	nyRows, nxCols;

//  
static int	nxCharSize, nyCharSize;


// ===================================================================
//  InitTTY
// ===================================================================
void InitTTY(HWND hwnd)
{
	HDC			hdc;				//   
	TEXTMETRIC	tiTextMetric;	//     
	RECT			rcTTYWindow;	//  

	//    
	nyCurrRow = 0;	
	nxCurrCol = 0;

	//   
	hdc = GetDC( hwnd );

	//      OEM_FIXED_FONT
	SelectObject(hdc, GetStockObject(OEM_FIXED_FONT));

	//   tiTextMetric   
   // ,    
	GetTextMetrics(hdc, &tiTextMetric);

	//  
	ReleaseDC( hwnd, hdc );

	//     
	nxCharSize = tiTextMetric.tmAveCharWidth;

	//      
   //  
	nyCharSize = tiTextMetric.tmHeight +
					 tiTextMetric.tmExternalLeading;

	//    
	GetClientRect(hwnd, &rcTTYWindow);

	//   ,   
	nyRows = (rcTTYWindow.bottom - rcTTYWindow.top) / nyCharSize;

	//   ,    
	nxCols = (rcTTYWindow.right - rcTTYWindow.left) / nxCharSize;

	return;
}



// ===================================================================
//  WriteTTY
// ===================================================================
void WriteTTY( LPSTR lpOutString, HWND hwnd, COLORREF rgbColor )
{
	LPSTR	lpCurrChar;	//    
	HDC	hdc;			//   

	//   
	hdc = GetDC( hwnd );

	//      OEM_FIXED_FONT
	SelectObject( hdc, GetStockObject(OEM_FIXED_FONT));

	//   
	SetTextColor(hdc, rgbColor);

	//       
	SetBkColor(hdc, GetSysColor(COLOR_WINDOW));

	//    
	SetBkMode(hdc, OPAQUE);

	//  
	HideCaret( hwnd );

	//   lpOutString  
	for ( lpCurrChar = lpOutString; *lpCurrChar; lpCurrChar++ )
	{
		switch ( *lpCurrChar )
		{
			//      
			case ASCII_BACK:
         {
				if(nxCurrCol)
					nxCurrCol--;

				break;
         }

			//      
			case ASCII_CR:
         {
				nxCurrCol = 0;
				break;
         }

			//     
			case ASCII_LF:
         {
				nyCurrRow++;

				//      
				if ( nyCurrRow == ( nyRows - 1 ) )
				{
					ValidateRect( hwnd, NULL );
					ScrollWindow( hwnd, 0, -nyCharSize, NULL, NULL );

               //   WM_PAINT
					UpdateWindow( hwnd );

               //    
					nyCurrRow = nyRows - 2;
				}
				break;
         }

			//   
			case ASCII_BELL:
         {
				MessageBeep(MB_OK);
				break;
         }

			default:
         {
				//      lpOutString  
            //  
				TextOut( hdc, nxCurrCol * nxCharSize, nyCurrRow * nyCharSize,
							lpCurrChar, 1 );

				//   
				nxCurrCol++;

				//      
				if ( nxCurrCol == ( nxCols - 1 ) )
				{
					nxCurrCol = 0;
					nyCurrRow++;

					//      
					if ( nyCurrRow == ( nyRows - 1 ) )
					{
						ValidateRect( hwnd, NULL );
						ScrollWindow( hwnd, 0, -nyCharSize, NULL, NULL );
						UpdateWindow( hwnd );
						nyCurrRow = nyRows - 2;
					}
				}
				break;
         }
		}
	}

	//     
	SetCaretPos( nxCurrCol * nxCharSize, nyCurrRow * nyCharSize );

	//  
	ShowCaret( hwnd );

	//  
	ReleaseDC( hwnd, hdc );

	return;
}

// ===================================================================
//  SetFocusTTY
// ===================================================================
void SetFocusTTY(HWND hwnd)
{
   //   
	CreateCaret( hwnd, NULL, nxCharSize, nyCharSize );

	//     
	SetCaretPos( nxCurrCol * nxCharSize, nyCurrRow * nyCharSize );

	//  
	ShowCaret( hwnd );

	return;
}

// ===================================================================
//  KillFocusTTY
// ===================================================================
void KillFocusTTY(HWND hwnd)
{
	//  
	HideCaret(hwnd);

	//  
	DestroyCaret();

	return;
}
